VERSION 5.00
Begin VB.Form FrmBinaryFND 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Find text."
   ClientHeight    =   2655
   ClientLeft      =   4830
   ClientTop       =   4755
   ClientWidth     =   5535
   Icon            =   "FormBinaryFND.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2655
   ScaleWidth      =   5535
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdStartButton 
      Caption         =   "Find"
      Default         =   -1  'True
      Height          =   375
      Left            =   4305
      TabIndex        =   8
      Top             =   30
      Width           =   1215
   End
   Begin VB.CommandButton cmdCancelButton 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   4290
      TabIndex        =   7
      Top             =   525
      Width           =   1215
   End
   Begin VB.TextBox txtSearch 
      Height          =   285
      Left            =   0
      TabIndex        =   6
      Top             =   615
      Width           =   4185
   End
   Begin VB.Frame Frame1 
      Caption         =   "Search Mode"
      Height          =   855
      Left            =   0
      TabIndex        =   3
      Top             =   1815
      Width           =   5550
      Begin VB.OptionButton optSearchTyp 
         Caption         =   "Simple Search (Line Mode)"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   5
         Top             =   240
         Value           =   -1  'True
         Width           =   4575
      End
      Begin VB.OptionButton optSearchTyp 
         Caption         =   "Expanded Search (Search the String  on more than one line."
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   4
         Top             =   480
         Width           =   4575
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Search in"
      Height          =   855
      Left            =   0
      TabIndex        =   0
      Top             =   975
      Width           =   5550
      Begin VB.Frame Frame3 
         Caption         =   "Options"
         Height          =   615
         Left            =   2160
         TabIndex        =   10
         Top             =   120
         Width           =   3240
         Begin VB.CheckBox optStartOnTop 
            Caption         =   "Start at first line"
            Height          =   255
            Left            =   120
            TabIndex        =   12
            Top             =   240
            Width           =   1395
         End
         Begin VB.CheckBox optMatchCase 
            Caption         =   "Match Inv/Normal"
            Height          =   255
            Left            =   1590
            TabIndex        =   11
            Top             =   240
            Value           =   1  'Checked
            Width           =   1605
         End
      End
      Begin VB.OptionButton optSearchIn 
         Caption         =   "HEX Mode"
         Height          =   255
         Index           =   1
         Left            =   120
         TabIndex        =   2
         Top             =   480
         Width           =   1425
      End
      Begin VB.OptionButton optSearchIn 
         Caption         =   "ASCII"
         Height          =   255
         Index           =   0
         Left            =   120
         TabIndex        =   1
         Top             =   240
         Value           =   -1  'True
         Width           =   1425
      End
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Text you like to search:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   195
      Left            =   0
      TabIndex        =   9
      Top             =   375
      Width           =   2025
   End
End
Attribute VB_Name = "FrmBinaryFND"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' *******************************************************************************
'  VB81 XuR updated by XavSnap. (2007)
' *******************************************************************************

Option Explicit

Private Sub cmdCancelButton_Click()
  FrmBinaryFND.txtSearch.text = ""
  NextSearch = False
  If FrmBinary.LstHexView.GetFirstVisible.index = 1 Then GoTo NoSet
  FrmBinary.VScroll1.Value = FrmBinary.LstHexView.GetFirstVisible.index - 1
    glLastFound = 0
NoSet:
  FrmBinaryFND.Hide
End Sub


Private Sub cmdStartButton_Click()
  Dim lsSearchText As String
  Dim Lix As Integer
  Dim lbHexSearch As Boolean
  Dim lbMatchCase As Boolean
  
  Const cFindLine = 3
  
    
  If txtSearch.text <> "" Then

      lsSearchText = txtSearch.text
   
    
    ' Hex or ASCII Server
    If optSearchIn(0).Value = True Then
      lbHexSearch = False
    Else
      lbHexSearch = True
    End If
    
    If optMatchCase.Value = vbChecked Then
      lbMatchCase = True
    Else
      lbMatchCase = False
    End If
    
    ' Set the Start
    If optStartOnTop.Value = vbChecked Then
      glLastFound = 1
    End If
    
    ' Start the search
    If optSearchTyp(0).Value = True Then
      ' Simple Search
      glLastFound = SearchText(glLastFound, lsSearchText, lbHexSearch, lbMatchCase, 1)
      If glLastFound = -1 Then
        ' Notfound
        glLastFound = FrmBinary.LstHexView.SelectedItem.index
        Label1 = "Text you like to search: (Start at " & Hex(glLastFound * 16) & "h)"
      Else
        ' Found it
        If glLastFound = 1 Then glLastFound = 2
        With FrmBinary.LstHexView.ListItems.Item(glLastFound - 1)
          .EnsureVisible
          .Selected = True
        End With
        optStartOnTop.Value = vbUnchecked
        If glLastFound <= FrmBinary.VScrollEditor.max Then FrmBinary.VScrollEditor.Value = glLastFound
        glLastFound = glLastFound + 1
        NextSearch = True
        FrmBinaryFND.Hide
      End If
    Else
      ' Extended Search
      glLastFound = SearchText(glLastFound, lsSearchText, lbHexSearch, lbMatchCase, cFindLine)
      If glLastFound = -1 Then
        ' Notfound
        glLastFound = FrmBinary.LstHexView.SelectedItem.index
        Label1 = "Text you like to search: (Start at " & Hex(glLastFound * 16) & "h)"
      Else
        ' Found it
        With FrmBinary.LstHexView.ListItems.Item(glLastFound)
          .EnsureVisible
          .Selected = True
        End With
        optStartOnTop.Value = vbUnchecked
        FrmBinary.VScrollEditor.Value = glLastFound
        glLastFound = glLastFound + 1
        NextSearch = True
        FrmBinaryFND.Hide
        FrmBinary.LstHexView.SetFocus
      End If
    End If

  End If
End Sub

Private Sub Form_Activate()
If NextSearch Then
cmdStartButton_Click
Exit Sub
End If
Label1 = "Text you like to search: (Start at " & Hex(glLastFound * 16) & "h)"
txtSearch.SetFocus
End Sub

Private Sub optSearchIn_GotFocus(index As Integer)
  Select Case index
    Case 0
      optMatchCase.Enabled = True
    Case 1
      optMatchCase.Enabled = False
  End Select
End Sub

Private Sub optStartOnTop_Click()
If optStartOnTop.Value Then
Label1 = "Text you like to search: (Start at 0h)"
Else
Label1 = "Text you like to search: (Start at " & Hex(glLastFound * 16) & "h)"
End If
End Sub

Private Sub txtSearch_Change()
  glLastFound = 1
End Sub

Function SearchText(StartLine As Long, SearchString As String, HexMode As Boolean, MatchCase As Boolean, TotSearch As Integer) As Long
  Dim llLineCounter As Long
  Dim llMaxCounter As Long
  Dim lbFound As Boolean
  Dim lsOrgText As String
  Dim liMaxLine As Integer
  
  llMaxCounter = FrmBinary.LstHexView.ListItems.count
  llLineCounter = StartLine
  lbFound = False
  
  While (llLineCounter <= llMaxCounter) And Not lbFound
   
    If HexMode Then
      ' Search in Hexline, Subitems(1)
      If TotSearch = 1 Then
        lsOrgText = FrmBinary.LstHexView.ListItems.Item(llLineCounter).SubItems(1)
      Else
        If llLineCounter + TotSearch > FrmBinary.LstHexView.ListItems.count Then
          TotSearch = FrmBinary.LstHexView.ListItems.count - FrmBinary.LstHexView.ListItems.count - 1
        End If
        lsOrgText = ""
        For liMaxLine = llLineCounter To llLineCounter + TotSearch
          lsOrgText = lsOrgText + FrmBinary.LstHexView.ListItems.Item(liMaxLine).SubItems(1) + "."
        Next liMaxLine
      End If
      lsOrgText = UCase(lsOrgText)
      SearchString = UCase(SearchString)
      ' Replace the doublespace with .
      While InStr(lsOrgText, "  ") <> 0
        lsOrgText = Trim(Mid(lsOrgText, 1, InStr(lsOrgText, " ") - 1)) + "." + _
                    Trim(Mid(lsOrgText, InStr(lsOrgText, " "), Len(lsOrgText)))
                    
      lsOrgText = Dot_Killer(lsOrgText)
      Wend
      If InStr(lsOrgText, SearchString) <> 0 Then
        ' Found it
        SearchText = llLineCounter
        ' Found it in expanded mode
        If TotSearch <> 1 Then
          SearchText = llLineCounter + InStr(lsOrgText, SearchString) \ 48
        End If
        lbFound = True
      End If
    Else
      ' Search in ASCII, Subitems(2)
      
      SearchString = SearchString
      
      If TotSearch = 1 Then
        lsOrgText = FrmBinary.LstHexView.ListItems.Item(llLineCounter).SubItems(2)
      Else
        If llLineCounter + TotSearch > FrmBinary.LstHexView.ListItems.count Then
          TotSearch = FrmBinary.LstHexView.ListItems.count - FrmBinary.LstHexView.ListItems.count - 1
        End If
        lsOrgText = ""
        For liMaxLine = llLineCounter To llLineCounter + TotSearch
          lsOrgText = lsOrgText + FrmBinary.LstHexView.ListItems.Item(liMaxLine).SubItems(2)
        Next liMaxLine
      End If
      If MatchCase Then
        lsOrgText = UCase(lsOrgText)
        SearchString = UCase(SearchString)
      End If
      If InStr(lsOrgText, SearchString) <> 0 Then
        ' Found it
        SearchText = llLineCounter
        ' Found it in expanded mode
        If TotSearch <> 1 Then
          SearchText = llLineCounter + InStr(lsOrgText, SearchString) \ 16
        End If
        lbFound = True
      End If
    End If
    llLineCounter = llLineCounter + 1
  Wend
 
  If Not lbFound Then
    MsgBox "Can not find the String", vbInformation + vbOKOnly, "Search for: " + SearchString
    SearchText = -1
    NextSearch = False
  End If
End Function

Function TransZxAscii(Str As String) As String
Dim LnStr As Integer, cmp As Integer
TransZxAscii = ""
LnStr = Len(Str)
For cmp = 1 To LnStr
TransZxAscii = TransZxAscii + ZXCharToASCII(Asc(Mid(Str, cmp, 1)), False)
Next cmp
End Function
Private Function ASChex(Strhex As String) As Long
Dim multi As String
Dim a As Integer
multi = 0
ASChex = 0

If Strhex = "" Then Exit Function

For a = Len(Strhex) To 1 Step -1
ASChex = ASChex + (val("&h" & Mid(Strhex, a, 1)) * (16 ^ multi))
multi = multi + 1
Next

End Function

Private Sub txtSearch_KeyPress(KeyAscii As Integer)
If optSearchIn(0).Value Then Exit Sub
If (Not Is_HEX(KeyAscii)) And optSearchIn(1).Value Then KeyAscii = 0
End Sub


Function Dot_Killer(StrPlentyOfDots As String) As String
Dot_Killer = ""
Dim counter
For counter = 1 To Len(StrPlentyOfDots)
If Mid(StrPlentyOfDots, counter, 1) <> "." Then Dot_Killer = Dot_Killer + Mid(StrPlentyOfDots, counter, 1)
Next
End Function
