Attribute VB_Name = "ModAss"

Type Byte16
B1 As Byte
B2 As Byte
End Type

Function GetAsmCodes(Fnc1 As String, Fnc2 As String) As Byte16

Select Case Len(Fnc1)
Case 2
        Select Case Fnc1
' // CP --------------------------------------
        Case "CP"

           Select Case Fnc2
         Case "(HL)"
            GetAsmCodes.B1 = &HBE

         Case "(IX*)"
            GetAsmCodes.B1 = &HBE
            GetAsmCodes.B2 = &HDD

         Case "(IY*)"
            GetAsmCodes.B1 = &HBE
            GetAsmCodes.B2 = &HFD

         Case "A"
            GetAsmCodes.B1 = &HBF

         Case "B"
            GetAsmCodes.B1 = &HB8

         Case "C"
            GetAsmCodes.B1 = &HB9

         Case "D"
            GetAsmCodes.B1 = &HBA

         Case "E"
            GetAsmCodes.B1 = &HBB

         Case "H"
            GetAsmCodes.B1 = &HBC

         Case "IXH"
            GetAsmCodes.B1 = &HBC
            GetAsmCodes.B2 = &HDD

         Case "IXL"
            GetAsmCodes.B1 = &HBD
            GetAsmCodes.B2 = &HDD

         Case "IYH"
            GetAsmCodes.B1 = &HBC
            GetAsmCodes.B2 = &HFD

         Case "IYL"
            GetAsmCodes.B1 = &HBD
            GetAsmCodes.B2 = &HFD

         Case "L"
            GetAsmCodes.B1 = &HBD

         Case "*"
            GetAsmCodes.B1 = &HFE

        End Select

' // DI --------------------------------------
        Case "DI"
            GetAsmCodes.B1 = &HF3


' // EI --------------------------------------
        Case "EI"
            GetAsmCodes.B1 = &HFB

' // EX --------------------------------------
        
        Case "EX"
        
           Select Case Fnc2
         Case "(SP),HL"
            GetAsmCodes.B1 = &HE3

         Case "(SP),IX"
            GetAsmCodes.B1 = &HE3
            GetAsmCodes.B2 = &HDD

         Case "(SP),IY"
            GetAsmCodes.B1 = &HE3
            GetAsmCodes.B2 = &HFD

         Case "AF,AF'"
            GetAsmCodes.B1 = &H8

         Case "DE,HL"
            GetAsmCodes.B1 = &HEB

        End Select

' // IM --------------------------------------

        Case "IM"

        
           Select Case Fnc2
         Case "0"
            GetAsmCodes.B1 = &H46
            GetAsmCodes.B2 = &HED

         Case "1"
            GetAsmCodes.B1 = &H56
            GetAsmCodes.B2 = &HED

         Case "2"
            GetAsmCodes.B1 = &H5E
            GetAsmCodes.B2 = &HED

        End Select

' // IN --------------------------------------
        Case "IN"

        
           Select Case Fnc2
         Case "A,(*)"
            GetAsmCodes.B1 = &H78
            GetAsmCodes.B2 = &HED

         Case "B,(*)"
            GetAsmCodes.B1 = &H40
            GetAsmCodes.B2 = &HED

         Case "C,(*)"
            GetAsmCodes.B1 = &H48
            GetAsmCodes.B2 = &HED

         Case "D,(*)"
            GetAsmCodes.B1 = &H50
            GetAsmCodes.B2 = &HED

         Case "E,(*)"
            GetAsmCodes.B1 = &H58
            GetAsmCodes.B2 = &HED

         Case "F,(*)"
            GetAsmCodes.B1 = &H70
            GetAsmCodes.B2 = &HED

         Case "H,(*)"
            GetAsmCodes.B1 = &H60
            GetAsmCodes.B2 = &HED

         Case "L,(*)"
            GetAsmCodes.B1 = &H68
            GetAsmCodes.B2 = &HED

         Case "A,(*)"
            GetAsmCodes.B1 = &HDB

        End Select

' // JP --------------------------------------
        Case "JP"

        
           Select Case Fnc2
         Case "(HL)"
            GetAsmCodes.B1 = &HE9

         Case "(IX)"
            GetAsmCodes.B1 = &HE9
            GetAsmCodes.B2 = &HDD

         Case "(IY)"
            GetAsmCodes.B1 = &HE9
            GetAsmCodes.B2 = &HFD

         Case "C"
            GetAsmCodes.B1 = &HDA

         Case "M"
            GetAsmCodes.B1 = &HFA

         Case "NC"
            GetAsmCodes.B1 = &HD2

         Case "NZ"
            GetAsmCodes.B1 = &HC2

         Case "P"
            GetAsmCodes.B1 = &HF2

         Case "PE"
            GetAsmCodes.B1 = &HEA

         Case "PO"
            GetAsmCodes.B1 = &HE2

         Case "Z"
            GetAsmCodes.B1 = &HCA

         Case "*"
            GetAsmCodes.B1 = &HC3

        End Select

' // JR --------------------------------------
        Case "JR"

        
           Select Case Fnc2
         Case "C"
            GetAsmCodes.B1 = &H38

         Case "NC"
            GetAsmCodes.B1 = &H30

         Case "NZ"
            GetAsmCodes.B1 = &H20

         Case "Z"
            GetAsmCodes.B1 = &H28

         Case "*"
            GetAsmCodes.B1 = &H18

        End Select

' // LD --------------------------------------
        Case "LD"

        
           Select Case Fnc2
         Case "(BC),A"
            GetAsmCodes.B1 = &H2

         Case "(DE),A"
            GetAsmCodes.B1 = &H12

         Case "(HL),A"
            GetAsmCodes.B1 = &H77

         Case "(HL),B"
            GetAsmCodes.B1 = &H70

         Case "(HL),C"
            GetAsmCodes.B1 = &H71

         Case "(HL),D"
            GetAsmCodes.B1 = &H72

         Case "(HL),E"
            GetAsmCodes.B1 = &H73

         Case "(HL),H"
            GetAsmCodes.B1 = &H74

         Case "(HL),L"
            GetAsmCodes.B1 = &H75

         Case "(HL),*"
            GetAsmCodes.B1 = &H36

         Case "(IX*),A"
            GetAsmCodes.B1 = &H77
            GetAsmCodes.B2 = &HDD

         Case "(IX*),B"
            GetAsmCodes.B1 = &H70
            GetAsmCodes.B2 = &HDD

         Case "(IX*),C"
            GetAsmCodes.B1 = &H71
            GetAsmCodes.B2 = &HDD

         Case "(IX*),D"
            GetAsmCodes.B1 = &H72
            GetAsmCodes.B2 = &HDD

         Case "(IX*),E"
            GetAsmCodes.B1 = &H73
            GetAsmCodes.B2 = &HDD

         Case "(IX*),H"
            GetAsmCodes.B1 = &H74
            GetAsmCodes.B2 = &HDD

         Case "(IX*),L"
            GetAsmCodes.B1 = &H75
            GetAsmCodes.B2 = &HDD

         Case "(IX*),*"
            GetAsmCodes.B1 = &H36
            GetAsmCodes.B2 = &HDD

         Case "(IY*),A"
            GetAsmCodes.B1 = &H77
            GetAsmCodes.B2 = &HFD

         Case "(IY*),B"
            GetAsmCodes.B1 = &H70
            GetAsmCodes.B2 = &HFD

         Case "(IY*),C"
            GetAsmCodes.B1 = &H71
            GetAsmCodes.B2 = &HFD

         Case "(IY*),D"
            GetAsmCodes.B1 = &H72
            GetAsmCodes.B2 = &HFD

         Case "(IY*),E"
            GetAsmCodes.B1 = &H73
            GetAsmCodes.B2 = &HFD

         Case "(IY*),H"
            GetAsmCodes.B1 = &H74
            GetAsmCodes.B2 = &HFD

         Case "(IY*),L"
            GetAsmCodes.B1 = &H75
            GetAsmCodes.B2 = &HFD

         Case "(IY*),*"
            GetAsmCodes.B1 = &H36
            GetAsmCodes.B2 = &HFD

         Case "(*),A"
            GetAsmCodes.B1 = &H32

         Case "(*),BC"
            GetAsmCodes.B1 = &H43
            GetAsmCodes.B2 = &HED

         Case "(*),DE"
            GetAsmCodes.B1 = &H53
            GetAsmCodes.B2 = &HED

         Case "(*),HL"
            GetAsmCodes.B1 = &H22

         Case "(*),IX"
            GetAsmCodes.B1 = &H22
            GetAsmCodes.B2 = &HDD

         Case "(*),IY"
            GetAsmCodes.B1 = &H22
            GetAsmCodes.B2 = &HFD

         Case "(*),SP"
            GetAsmCodes.B1 = &H73
            GetAsmCodes.B2 = &HED

         Case "A,(BC)"
            GetAsmCodes.B1 = &HA

         Case "A,(DE)"
            GetAsmCodes.B1 = &H1A

         Case "A,(HL)"
            GetAsmCodes.B1 = &H7E

         Case "A,(IX*)"
            GetAsmCodes.B1 = &H7E
            GetAsmCodes.B2 = &HDD

         Case "A,(IY*)"
            GetAsmCodes.B1 = &H7E
            GetAsmCodes.B2 = &HFD

         Case "A,A"
            GetAsmCodes.B1 = &H7F

         Case "A,B"
            GetAsmCodes.B1 = &H78

         Case "A,C"
            GetAsmCodes.B1 = &H79

         Case "A,D"
            GetAsmCodes.B1 = &H7A

         Case "A,E"
            GetAsmCodes.B1 = &H7B

         Case "A,H"
            GetAsmCodes.B1 = &H7C

         Case "A,I"
            GetAsmCodes.B1 = &H57
            GetAsmCodes.B2 = &HED

         Case "A,IXH"
            GetAsmCodes.B1 = &H7C
            GetAsmCodes.B2 = &HDD

         Case "A,IXL"
            GetAsmCodes.B1 = &H7D
            GetAsmCodes.B2 = &HDD

         Case "A,IYH"
            GetAsmCodes.B1 = &H7C
            GetAsmCodes.B2 = &HFD

         Case "A,IYL"
            GetAsmCodes.B1 = &H7D
            GetAsmCodes.B2 = &HFD

         Case "A,L"
            GetAsmCodes.B1 = &H7D

         Case "A,R"
            GetAsmCodes.B1 = &H5F
            GetAsmCodes.B2 = &HED

         Case "A,(*)"
            GetAsmCodes.B1 = &H3A

         Case "A,*"
            GetAsmCodes.B1 = &H3E

         Case "B,(HL)"
            GetAsmCodes.B1 = &H46

         Case "B,(IX*)"
            GetAsmCodes.B1 = &H46
            GetAsmCodes.B2 = &HDD

         Case "B,(IY*)"
            GetAsmCodes.B1 = &H46
            GetAsmCodes.B2 = &HFD

         Case "B,A"
            GetAsmCodes.B1 = &H47

         Case "B,B"
            GetAsmCodes.B1 = &H40

         Case "B,C"
            GetAsmCodes.B1 = &H41

         Case "B,D"
            GetAsmCodes.B1 = &H42

         Case "B,E"
            GetAsmCodes.B1 = &H43

         Case "B,H"
            GetAsmCodes.B1 = &H44

         Case "B,IXH"
            GetAsmCodes.B1 = &H44
            GetAsmCodes.B2 = &HDD

         Case "B,IXL"
            GetAsmCodes.B1 = &H45
            GetAsmCodes.B2 = &HDD

         Case "B,IYH"
            GetAsmCodes.B1 = &H44
            GetAsmCodes.B2 = &HFD

         Case "B,IYL"
            GetAsmCodes.B1 = &H45
            GetAsmCodes.B2 = &HFD

         Case "B,L"
            GetAsmCodes.B1 = &H45

         Case "B,*"
            GetAsmCodes.B1 = &H6

         Case "BC,(*)"
            GetAsmCodes.B1 = &H4B
            GetAsmCodes.B2 = &HED

         Case "BC,*"
            GetAsmCodes.B1 = &H1

         Case "C,(HL)"
            GetAsmCodes.B1 = &H4E

         Case "C,(IX*)"
            GetAsmCodes.B1 = &H4E
            GetAsmCodes.B2 = &HDD

         Case "C,(IY*)"
            GetAsmCodes.B1 = &H4E
            GetAsmCodes.B2 = &HFD

         Case "C,A"
            GetAsmCodes.B1 = &H4F

         Case "C,B"
            GetAsmCodes.B1 = &H48

         Case "C,C"
            GetAsmCodes.B1 = &H49

         Case "C,D"
            GetAsmCodes.B1 = &H4A

         Case "C,E"
            GetAsmCodes.B1 = &H4B

         Case "C,H"
            GetAsmCodes.B1 = &H4C

         Case "C,IXH"
            GetAsmCodes.B1 = &H4C
            GetAsmCodes.B2 = &HDD

         Case "C,IXL"
            GetAsmCodes.B1 = &H4D
            GetAsmCodes.B2 = &HDD

         Case "C,IYH"
            GetAsmCodes.B1 = &H4C
            GetAsmCodes.B2 = &HFD

         Case "C,IYL"
            GetAsmCodes.B1 = &H4D
            GetAsmCodes.B2 = &HFD

         Case "C,L"
            GetAsmCodes.B1 = &H4D

         Case "C,*"
            GetAsmCodes.B1 = &HE

         Case "D,(HL)"
            GetAsmCodes.B1 = &H56

         Case "D,(IX*)"
            GetAsmCodes.B1 = &H56
            GetAsmCodes.B2 = &HDD

         Case "D,(IY*)"
            GetAsmCodes.B1 = &H56
            GetAsmCodes.B2 = &HFD

         Case "D,A"
            GetAsmCodes.B1 = &H57

         Case "D,B"
            GetAsmCodes.B1 = &H50

         Case "D,C"
            GetAsmCodes.B1 = &H51

         Case "D,D"
            GetAsmCodes.B1 = &H52

         Case "D,E"
            GetAsmCodes.B1 = &H53

         Case "D,H"
            GetAsmCodes.B1 = &H54

         Case "D,IXH"
            GetAsmCodes.B1 = &H54
            GetAsmCodes.B2 = &HDD

         Case "D,IXL"
            GetAsmCodes.B1 = &H55
            GetAsmCodes.B2 = &HDD

         Case "D,IYH"
            GetAsmCodes.B1 = &H54
            GetAsmCodes.B2 = &HFD

         Case "D,IYL"
            GetAsmCodes.B1 = &H55
            GetAsmCodes.B2 = &HFD

         Case "D,L"
            GetAsmCodes.B1 = &H55

         Case "D,*"
            GetAsmCodes.B1 = &H16

         Case "DE,(*)"
            GetAsmCodes.B1 = &H5B
            GetAsmCodes.B2 = &HED

         Case "DE,*"
            GetAsmCodes.B1 = &H11

         Case "E,(HL)"
            GetAsmCodes.B1 = &H5E

         Case "E,(IX*)"
            GetAsmCodes.B1 = &H5E
            GetAsmCodes.B2 = &HDD

         Case "E,(IY*)"
            GetAsmCodes.B1 = &H5E
            GetAsmCodes.B2 = &HFD

         Case "E,A"
            GetAsmCodes.B1 = &H5F

         Case "E,B"
            GetAsmCodes.B1 = &H58

         Case "E,C"
            GetAsmCodes.B1 = &H59

         Case "E,D"
            GetAsmCodes.B1 = &H5A

         Case "E,E"
            GetAsmCodes.B1 = &H5B

         Case "E,H"
            GetAsmCodes.B1 = &H5C

         Case "E,IXH"
            GetAsmCodes.B1 = &H5C
            GetAsmCodes.B2 = &HDD

         Case "E,IXL"
            GetAsmCodes.B1 = &H5D
            GetAsmCodes.B2 = &HDD

         Case "E,IYH"
            GetAsmCodes.B1 = &H5C
            GetAsmCodes.B2 = &HFD

         Case "E,IYL"
            GetAsmCodes.B1 = &H5D
            GetAsmCodes.B2 = &HFD

         Case "E,L"
            GetAsmCodes.B1 = &H5D

         Case "E,*"
            GetAsmCodes.B1 = &H1E

         Case "H,(HL)"
            GetAsmCodes.B1 = &H66

         Case "H,(IX*)"
            GetAsmCodes.B1 = &H66
            GetAsmCodes.B2 = &HDD

         Case "H,(IY*)"
            GetAsmCodes.B1 = &H66
            GetAsmCodes.B2 = &HFD

         Case "H,A"
            GetAsmCodes.B1 = &H67

         Case "H,B"
            GetAsmCodes.B1 = &H60

         Case "H,C"
            GetAsmCodes.B1 = &H61

         Case "H,D"
            GetAsmCodes.B1 = &H62

         Case "H,E"
            GetAsmCodes.B1 = &H63

         Case "H,H"
            GetAsmCodes.B1 = &H64

         Case "H,L"
            GetAsmCodes.B1 = &H65

         Case "H,*"
            GetAsmCodes.B1 = &H26

         Case "HL,(*)"
            GetAsmCodes.B1 = &H2A

         Case "HL,*"
            GetAsmCodes.B1 = &H21

         Case "I,A"
            GetAsmCodes.B1 = &H47
            GetAsmCodes.B2 = &HED

         Case "IX,(*)"
            GetAsmCodes.B1 = &H2A
            GetAsmCodes.B2 = &HDD

         Case "IX,*"
            GetAsmCodes.B1 = &H21
            GetAsmCodes.B2 = &HDD

         Case "IXH,A"
            GetAsmCodes.B1 = &H67
            GetAsmCodes.B2 = &HDD

         Case "IXH,B"
            GetAsmCodes.B1 = &H60
            GetAsmCodes.B2 = &HDD

         Case "IXH,C"
            GetAsmCodes.B1 = &H61
            GetAsmCodes.B2 = &HDD

         Case "IXH,D"
            GetAsmCodes.B1 = &H62
            GetAsmCodes.B2 = &HDD

         Case "IXH,E"
            GetAsmCodes.B1 = &H63
            GetAsmCodes.B2 = &HDD

         Case "IXH,IXH"
            GetAsmCodes.B1 = &H64
            GetAsmCodes.B2 = &HDD

         Case "IXH,IXL"
            GetAsmCodes.B1 = &H65
            GetAsmCodes.B2 = &HDD

         Case "IXH,*"
            GetAsmCodes.B1 = &H26
            GetAsmCodes.B2 = &HDD

         Case "IXL,A"
            GetAsmCodes.B1 = &H6F
            GetAsmCodes.B2 = &HDD

         Case "IXL,B"
            GetAsmCodes.B1 = &H68
            GetAsmCodes.B2 = &HDD

         Case "IXL,C"
            GetAsmCodes.B1 = &H69
            GetAsmCodes.B2 = &HDD

         Case "IXL,D"
            GetAsmCodes.B1 = &H6A
            GetAsmCodes.B2 = &HDD

         Case "IXL,E"
            GetAsmCodes.B1 = &H6B
            GetAsmCodes.B2 = &HDD

         Case "IXL,IXH"
            GetAsmCodes.B1 = &H6C
            GetAsmCodes.B2 = &HDD

         Case "IXL,IXL"
            GetAsmCodes.B1 = &H6D
            GetAsmCodes.B2 = &HDD

         Case "IXL,*"
            GetAsmCodes.B1 = &H2E
            GetAsmCodes.B2 = &HDD

         Case "IY,(*)"
            GetAsmCodes.B1 = &H2A
            GetAsmCodes.B2 = &HFD

         Case "IY,*"
            GetAsmCodes.B1 = &H21
            GetAsmCodes.B2 = &HFD

         Case "IYH,A"
            GetAsmCodes.B1 = &H67
            GetAsmCodes.B2 = &HFD

         Case "IYH,B"
            GetAsmCodes.B1 = &H60
            GetAsmCodes.B2 = &HFD

         Case "IYH,C"
            GetAsmCodes.B1 = &H61
            GetAsmCodes.B2 = &HFD

         Case "IYH,D"
            GetAsmCodes.B1 = &H62
            GetAsmCodes.B2 = &HFD

         Case "IYH,E"
            GetAsmCodes.B1 = &H63
            GetAsmCodes.B2 = &HFD

         Case "IYH,IYH"
            GetAsmCodes.B1 = &H64
            GetAsmCodes.B2 = &HFD

         Case "IYH,IYL"
            GetAsmCodes.B1 = &H65
            GetAsmCodes.B2 = &HFD

         Case "IYH,*"
            GetAsmCodes.B1 = &H26
            GetAsmCodes.B2 = &HFD

         Case "IYL,A"
            GetAsmCodes.B1 = &H6F
            GetAsmCodes.B2 = &HFD

         Case "IYL,B"
            GetAsmCodes.B1 = &H68
            GetAsmCodes.B2 = &HFD

         Case "IYL,C"
            GetAsmCodes.B1 = &H69
            GetAsmCodes.B2 = &HFD

         Case "IYL,D"
            GetAsmCodes.B1 = &H6A
            GetAsmCodes.B2 = &HFD

         Case "IYL,E"
            GetAsmCodes.B1 = &H6B
            GetAsmCodes.B2 = &HFD

         Case "IYL,IYH"
            GetAsmCodes.B1 = &H6C
            GetAsmCodes.B2 = &HFD

         Case "IYL,IYL"
            GetAsmCodes.B1 = &H6D
            GetAsmCodes.B2 = &HFD

         Case "IYL,*"
            GetAsmCodes.B1 = &H2E
            GetAsmCodes.B2 = &HFD

         Case "L,(HL)"
            GetAsmCodes.B1 = &H6E

         Case "L,(IX*)"
            GetAsmCodes.B1 = &H6E
            GetAsmCodes.B2 = &HDD

         Case "L,(IY*)"
            GetAsmCodes.B1 = &H6E
            GetAsmCodes.B2 = &HFD

         Case "L,A"
            GetAsmCodes.B1 = &H6F

         Case "L,B"
            GetAsmCodes.B1 = &H68

         Case "L,C"
            GetAsmCodes.B1 = &H69

         Case "L,D"
            GetAsmCodes.B1 = &H6A

         Case "L,E"
            GetAsmCodes.B1 = &H6B

         Case "L,H"
            GetAsmCodes.B1 = &H6C

         Case "L,L"
            GetAsmCodes.B1 = &H6D

         Case "L,*"
            GetAsmCodes.B1 = &H2E

         Case "R,A"
            GetAsmCodes.B1 = &H4F
            GetAsmCodes.B2 = &HED

         Case "SP,(*)"
            GetAsmCodes.B1 = &H7B
            GetAsmCodes.B2 = &HED

         Case "SP,HL"
            GetAsmCodes.B1 = &HF9

         Case "SP,IX"
            GetAsmCodes.B1 = &HF9
            GetAsmCodes.B2 = &HDD

         Case "SP,IY"
            GetAsmCodes.B1 = &HF9
            GetAsmCodes.B2 = &HFD

         Case "SP,*"
            GetAsmCodes.B1 = &H31

        End Select

' // OR --------------------------------------
        Case "OR"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &HB6

           Case "(IX*)"
            GetAsmCodes.B1 = &HB6
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HB6
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &HB7

           Case "B"
            GetAsmCodes.B1 = &HB0

           Case "C"
            GetAsmCodes.B1 = &HB1

           Case "D"
            GetAsmCodes.B1 = &HB2

           Case "E"
            GetAsmCodes.B1 = &HB3

           Case "H"
            GetAsmCodes.B1 = &HB4

           Case "IXH"
            GetAsmCodes.B1 = &HB4
            GetAsmCodes.B2 = &HDD

           Case "IXL"
            GetAsmCodes.B1 = &HB5
            GetAsmCodes.B2 = &HDD

           Case "IYH"
            GetAsmCodes.B1 = &HB4
            GetAsmCodes.B2 = &HFD

           Case "IYL"
            GetAsmCodes.B1 = &HB5
            GetAsmCodes.B2 = &HFD

           Case "L"
            GetAsmCodes.B1 = &HB5

           Case "*"
            GetAsmCodes.B1 = &HF6

        End Select

' // RL --------------------------------------
        Case "RL"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &H16
            GetAsmCodes.B2 = &HCB

           Case "(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &H17
            GetAsmCodes.B2 = &HCB

           Case "B"
            GetAsmCodes.B1 = &H10
            GetAsmCodes.B2 = &HCB

           Case "C"
            GetAsmCodes.B1 = &H11
            GetAsmCodes.B2 = &HCB

           Case "D"
            GetAsmCodes.B1 = &H12
            GetAsmCodes.B2 = &HCB

           Case "E"
            GetAsmCodes.B1 = &H13
            GetAsmCodes.B2 = &HCB

           Case "H"
            GetAsmCodes.B1 = &H14
            GetAsmCodes.B2 = &HCB

           Case "L"
            GetAsmCodes.B1 = &H15
            GetAsmCodes.B2 = &HCB

           Case "A,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

        End Select

' // RR --------------------------------------
        Case "RR"

           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &H1E
            GetAsmCodes.B2 = &HCB

           Case "(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &H1F
            GetAsmCodes.B2 = &HCB

           Case "B"
            GetAsmCodes.B1 = &H18
            GetAsmCodes.B2 = &HCB

           Case "C"
            GetAsmCodes.B1 = &H19
            GetAsmCodes.B2 = &HCB

           Case "D"
            GetAsmCodes.B1 = &H1A
            GetAsmCodes.B2 = &HCB

           Case "E"
            GetAsmCodes.B1 = &H1B
            GetAsmCodes.B2 = &HCB

           Case "H"
            GetAsmCodes.B1 = &H1C
            GetAsmCodes.B2 = &HCB

           Case "L"
            GetAsmCodes.B1 = &H1D
            GetAsmCodes.B2 = &HCB

           Case "A,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

        End Select
        End Select ' fnc1
Case 3
        Select Case Fnc1
        
' // ADC --------------------------------------
        Case "ADC"


           Select Case Fnc2
           Case "A,(HL)"
            GetAsmCodes.B1 = &H8E

           Case "A,(IX*)"
            GetAsmCodes.B1 = &H8E
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &H8E
            GetAsmCodes.B2 = &HFD

           Case "A,A"
            GetAsmCodes.B1 = &H8F

           Case "A,B"
            GetAsmCodes.B1 = &H88

           Case "A,C"
            GetAsmCodes.B1 = &H89

           Case "A,D"
            GetAsmCodes.B1 = &H8A

           Case "A,E"
            GetAsmCodes.B1 = &H8B

           Case "A,H"
            GetAsmCodes.B1 = &H8C

           Case "A,IXH"
            GetAsmCodes.B1 = &H8C
            GetAsmCodes.B2 = &HDD

           Case "A,IXL"
            GetAsmCodes.B1 = &H8D
            GetAsmCodes.B2 = &HDD

           Case "A,IYH"
            GetAsmCodes.B1 = &H8C
            GetAsmCodes.B2 = &HFD

           Case "A,IYL"
            GetAsmCodes.B1 = &H8D
            GetAsmCodes.B2 = &HFD

           Case "A,L"
            GetAsmCodes.B1 = &H8D

           Case "A,*"
            GetAsmCodes.B1 = &HCE

           Case "HL,BC"
            GetAsmCodes.B1 = &H4A
            GetAsmCodes.B2 = &HED

           Case "HL,DE"
            GetAsmCodes.B1 = &H5A
            GetAsmCodes.B2 = &HED

           Case "HL,HL"
            GetAsmCodes.B1 = &H6A
            GetAsmCodes.B2 = &HED

           Case "HL,SP"
            GetAsmCodes.B1 = &H7A
            GetAsmCodes.B2 = &HED

        End Select

' // ADD -------------------------------------
        Case "ADD"


           Select Case Fnc2
           Case "A,(HL)"
            GetAsmCodes.B1 = &H86

           Case "A,(IX*)"
            GetAsmCodes.B1 = &H86
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &H86
            GetAsmCodes.B2 = &HFD

           Case "A,A"
            GetAsmCodes.B1 = &H87

           Case "A,B"
            GetAsmCodes.B1 = &H80

           Case "A,C"
            GetAsmCodes.B1 = &H81

           Case "A,D"
            GetAsmCodes.B1 = &H82

           Case "A,E"
            GetAsmCodes.B1 = &H83

           Case "A,H"
            GetAsmCodes.B1 = &H84

           Case "A,IXH"
            GetAsmCodes.B1 = &H84
            GetAsmCodes.B2 = &HDD

           Case "A,IXL"
            GetAsmCodes.B1 = &H85
            GetAsmCodes.B2 = &HDD

           Case "A,IYH"
            GetAsmCodes.B1 = &H84
            GetAsmCodes.B2 = &HFD

           Case "A,IYL"
            GetAsmCodes.B1 = &H85
            GetAsmCodes.B2 = &HFD

           Case "A,L"
            GetAsmCodes.B1 = &H85

           Case "A,*"
            GetAsmCodes.B1 = &HC6

           Case "HL,BC"
            GetAsmCodes.B1 = &H9

           Case "HL,DE"
            GetAsmCodes.B1 = &H19

           Case "HL,HL"
            GetAsmCodes.B1 = &H29

           Case "HL,SP"
            GetAsmCodes.B1 = &H39

           Case "IX,BC"
            GetAsmCodes.B1 = &H9
            GetAsmCodes.B2 = &HDD

           Case "IX,DE"
            GetAsmCodes.B1 = &H19
            GetAsmCodes.B2 = &HDD

           Case "IX,IX"
            GetAsmCodes.B1 = &H29
            GetAsmCodes.B2 = &HDD

           Case "IX,SP"
            GetAsmCodes.B1 = &H39
            GetAsmCodes.B2 = &HDD

           Case "IY,BC"
            GetAsmCodes.B1 = &H9
            GetAsmCodes.B2 = &HFD

           Case "IY,DE"
            GetAsmCodes.B1 = &H19
            GetAsmCodes.B2 = &HFD

           Case "IY,IY"
            GetAsmCodes.B1 = &H29
            GetAsmCodes.B2 = &HFD

           Case "IY,SP"
            GetAsmCodes.B1 = &H39
            GetAsmCodes.B2 = &HFD

        End Select

' // AND -------------------------------------
        Case "AND"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &HA6

           Case "(IX*)"
            GetAsmCodes.B1 = &HA6
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HA6
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &HA7

           Case "B"
            GetAsmCodes.B1 = &HA0

           Case "C"
            GetAsmCodes.B1 = &HA1

           Case "D "
            GetAsmCodes.B1 = &HA2

           Case "E"
            GetAsmCodes.B1 = &HA3

           Case "H"
            GetAsmCodes.B1 = &HA4

           Case "IXH"
            GetAsmCodes.B1 = &HA4
            GetAsmCodes.B2 = &HDD

           Case "IXL"
            GetAsmCodes.B1 = &HA5
            GetAsmCodes.B2 = &HDD

           Case "IYH"
            GetAsmCodes.B1 = &HA4
            GetAsmCodes.B2 = &HFD

           Case "IYL"
            GetAsmCodes.B1 = &HA5
            GetAsmCodes.B2 = &HFD

           Case "L"
            GetAsmCodes.B1 = &HA5

           Case "*"
            GetAsmCodes.B1 = &HE6

        End Select

' // BIT -------------------------------------
        Case "BIT"


           Select Case Fnc2
           Case "*,(HL)"
            GetAsmCodes.B1 = &H46
            GetAsmCodes.B2 = &HCB

           Case "*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "*,A"
            GetAsmCodes.B1 = &H47
            GetAsmCodes.B2 = &HCB

           Case "*,B"
            GetAsmCodes.B1 = &H40
            GetAsmCodes.B2 = &HCB

           Case "*,C"
            GetAsmCodes.B1 = &H41
            GetAsmCodes.B2 = &HCB

           Case "*,D"
            GetAsmCodes.B1 = &H42
            GetAsmCodes.B2 = &HCB

           Case "*,E"
            GetAsmCodes.B1 = &H43
            GetAsmCodes.B2 = &HCB

           Case "*,H"
            GetAsmCodes.B1 = &H44
            GetAsmCodes.B2 = &HCB

           Case "*,L"
            GetAsmCodes.B1 = &H45
            GetAsmCodes.B2 = &HCB

        End Select

' // CCF -------------------------------------
        Case "CCF"
            GetAsmCodes.B1 = &H3F


' // CPD -------------------------------------
        Case "CPD"
            GetAsmCodes.B1 = &HA9
            GetAsmCodes.B2 = &HED


' // CPI -------------------------------------
        Case "CPI"
            GetAsmCodes.B1 = &HA1
            GetAsmCodes.B2 = &HED


' // CPL -------------------------------------
        Case "CPL"
            GetAsmCodes.B1 = &H2F


' // DAA -------------------------------------
        Case "DAA"
            GetAsmCodes.B1 = &H27


' // DEC -------------------------------------
        Case "DEC"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &H35

           Case "(IX*)"
            GetAsmCodes.B1 = &H35
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &H35
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &H3D

           Case "B"
            GetAsmCodes.B1 = &H5

           Case "BC"
            GetAsmCodes.B1 = &HB

           Case "C"
            GetAsmCodes.B1 = &HD

           Case "D"
            GetAsmCodes.B1 = &H15

           Case "DE"
            GetAsmCodes.B1 = &H1B

           Case "E"
            GetAsmCodes.B1 = &H1D

           Case "H"
            GetAsmCodes.B1 = &H25

           Case "HL"
            GetAsmCodes.B1 = &H2B

           Case "IX"
            GetAsmCodes.B1 = &H2B
            GetAsmCodes.B2 = &HDD

           Case "IXH"
            GetAsmCodes.B1 = &H25
            GetAsmCodes.B2 = &HDD

           Case "IXL"
            GetAsmCodes.B1 = &H2D
            GetAsmCodes.B2 = &HDD

           Case "IY"
            GetAsmCodes.B1 = &H2B
            GetAsmCodes.B2 = &HFD

           Case "IYH"
            GetAsmCodes.B1 = &H24
            GetAsmCodes.B2 = &HFD

           Case "IYL"
            GetAsmCodes.B1 = &H2D
            GetAsmCodes.B2 = &HFD

           Case "L"
            GetAsmCodes.B1 = &H2D

           Case "SP"
            GetAsmCodes.B1 = &H3B

        End Select

' // EXX -------------------------------------
        Case "EXX"
            GetAsmCodes.B1 = &HD9


' // INO -------------------------------------
        Case "IN0"


           Select Case Fnc2
           Case "A,(*)"
            GetAsmCodes.B1 = &H38
            GetAsmCodes.B2 = &HED

           Case "B,(*)"
            GetAsmCodes.B1 = &HED

           Case "C,(*)"
            GetAsmCodes.B1 = &H8ED

           Case "D,(*)"
            GetAsmCodes.B1 = &H10
            GetAsmCodes.B2 = &HED

           Case "E,(*)"
            GetAsmCodes.B1 = &H18
            GetAsmCodes.B2 = &HED

           Case "H,(*)"
            GetAsmCodes.B1 = &H20
            GetAsmCodes.B2 = &HED

           Case "L,(*)"
            GetAsmCodes.B1 = &H28
            GetAsmCodes.B2 = &HED

        End Select

' // INC -------------------------------------
        Case "INC"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &H34

           Case "(IX*)"
            GetAsmCodes.B1 = &H34
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &H34
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &H3C

           Case "B"
            GetAsmCodes.B1 = &H4

           Case "BC"
            GetAsmCodes.B1 = &H3

           Case "C"
            GetAsmCodes.B1 = &HC

           Case "D"
            GetAsmCodes.B1 = &H14

           Case "DE"
            GetAsmCodes.B1 = &H13

           Case "E"
            GetAsmCodes.B1 = &H1C

           Case "H"
            GetAsmCodes.B1 = &H24

           Case "HL"
            GetAsmCodes.B1 = &H23

           Case "IX"
            GetAsmCodes.B1 = &H23
            GetAsmCodes.B2 = &HDD

           Case "IXH"
            GetAsmCodes.B1 = &H24
            GetAsmCodes.B2 = &HDD

           Case "IXL"
            GetAsmCodes.B1 = &H2C
            GetAsmCodes.B2 = &HDD

           Case "IY"
            GetAsmCodes.B1 = &H23
            GetAsmCodes.B2 = &HFD

           Case "IYH"
            GetAsmCodes.B1 = &H24
            GetAsmCodes.B2 = &HFD

           Case "IYL"
            GetAsmCodes.B1 = &H2C
            GetAsmCodes.B2 = &HFD

           Case "L"
            GetAsmCodes.B1 = &H2C

           Case "SP"
            GetAsmCodes.B1 = &H33

        End Select

' // IND -------------------------------------
        Case "IND"
            GetAsmCodes.B1 = &HAA
            GetAsmCodes.B2 = &HED


' // INI -------------------------------------
        Case "INI"
            GetAsmCodes.B1 = &HA2
            GetAsmCodes.B2 = &HED


' // LDD -------------------------------------
        Case "LDD"
            GetAsmCodes.B1 = &HA8
            GetAsmCodes.B2 = &HED


' // LDI -------------------------------------
        Case "LDI"
            GetAsmCodes.B1 = &HA0
            GetAsmCodes.B2 = &HED


' // NEG -------------------------------------
        Case "NEG"
            GetAsmCodes.B1 = &H44
            GetAsmCodes.B2 = &HED


' // NOP -------------------------------------
        Case "NOP"
            GetAsmCodes.B1 = &H0


' // MLT -------------------------------------
        Case "MLT"


           Select Case Fnc2
           Case "BC"
            GetAsmCodes.B1 = &H4C
            GetAsmCodes.B2 = &HED

           Case "DE"
            GetAsmCodes.B1 = &H5C
            GetAsmCodes.B2 = &HED

           Case "HL"
            GetAsmCodes.B1 = &H6C
            GetAsmCodes.B2 = &HED

           Case "SP"
            GetAsmCodes.B1 = &H7C
            GetAsmCodes.B2 = &HED

        End Select

' // OUT -------------------------------------
        Case "OUT"


           Select Case Fnc2
           Case "(*),A"
            GetAsmCodes.B1 = &H79
            GetAsmCodes.B2 = &HED

           Case "(*),B"
            GetAsmCodes.B1 = &H41
            GetAsmCodes.B2 = &HED

           Case "(*),C"
            GetAsmCodes.B1 = &H49
            GetAsmCodes.B2 = &HED

           Case "(*),D"
            GetAsmCodes.B1 = &H51
            GetAsmCodes.B2 = &HED

           Case "(*),E"
            GetAsmCodes.B1 = &H59
            GetAsmCodes.B2 = &HED

           Case "(*),F"
            GetAsmCodes.B1 = &H71
            GetAsmCodes.B2 = &HED

           Case "(*),0"
            GetAsmCodes.B1 = &H71
            GetAsmCodes.B2 = &HED

           Case "(*),H"
            GetAsmCodes.B1 = &H61
            GetAsmCodes.B2 = &HED

           Case "(*),L"
            GetAsmCodes.B1 = &H69
            GetAsmCodes.B2 = &HED

           Case "(*),A"
            GetAsmCodes.B1 = &HD3

        End Select

' // POP -------------------------------------
        Case "POP"


           Select Case Fnc2
           Case "AF"
            GetAsmCodes.B1 = &HF1

           Case "BC"
            GetAsmCodes.B1 = &HC1

           Case "DE"
            GetAsmCodes.B1 = &HD1

           Case "HL"
            GetAsmCodes.B1 = &HE1

           Case "IX"
            GetAsmCodes.B1 = &HE1
            GetAsmCodes.B2 = &HDD

           Case "IY"
            GetAsmCodes.B1 = &HE1
            GetAsmCodes.B2 = &HFD

        End Select

' // RES -------------------------------------
        Case "RES"


           Select Case Fnc2
           Case "*,(HL)"
            GetAsmCodes.B1 = &H86
            GetAsmCodes.B2 = &HCB

           Case "*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "*,A"
            GetAsmCodes.B1 = &H87
            GetAsmCodes.B2 = &HCB

           Case "*,B"
            GetAsmCodes.B1 = &H80
            GetAsmCodes.B2 = &HCB

           Case "*,C"
            GetAsmCodes.B1 = &H81
            GetAsmCodes.B2 = &HCB

           Case "*,D"
            GetAsmCodes.B1 = &H82
            GetAsmCodes.B2 = &HCB

           Case "*,E"
            GetAsmCodes.B1 = &H83
            GetAsmCodes.B2 = &HCB

           Case "*,H"
            GetAsmCodes.B1 = &H84
            GetAsmCodes.B2 = &HCB

           Case "*,L"
            GetAsmCodes.B1 = &H85
            GetAsmCodes.B2 = &HCB

           Case "A,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "A,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

        End Select

' // RET -------------------------------------
        Case "RET"


           Select Case Fnc2
           Case ""
            GetAsmCodes.B1 = &HC9

           Case "C"
            GetAsmCodes.B1 = &HD8

           Case "M"
            GetAsmCodes.B1 = &HF8

           Case "NC"
            GetAsmCodes.B1 = &HD0

           Case "NZ"
            GetAsmCodes.B1 = &HC0

           Case "P"
            GetAsmCodes.B1 = &HF0

           Case "PE"
            GetAsmCodes.B1 = &HE8

           Case "PO"
            GetAsmCodes.B1 = &HE0

           Case "Z"
            GetAsmCodes.B1 = &HC8

        End Select

' // RRC -------------------------------------
        Case "RRC"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &HE
            GetAsmCodes.B2 = &HCB

           Case "(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &HF
            GetAsmCodes.B2 = &HCB

           Case "B"
            GetAsmCodes.B1 = &H8
            GetAsmCodes.B2 = &HCB

           Case "C"
            GetAsmCodes.B1 = &H9
            GetAsmCodes.B2 = &HCB

           Case "D"
            GetAsmCodes.B1 = &HA
            GetAsmCodes.B2 = &HCB

           Case "E"
            GetAsmCodes.B1 = &HB
            GetAsmCodes.B2 = &HCB

           Case "H"
            GetAsmCodes.B1 = &HC
            GetAsmCodes.B2 = &HCB

           Case "L"
            GetAsmCodes.B1 = &HD
            GetAsmCodes.B2 = &HCB

           Case "A,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

        End Select

' // RRD -------------------------------------
        Case "RRD"
            GetAsmCodes.B1 = &H67
            GetAsmCodes.B2 = &HED


' // RST -------------------------------------
        Case "RST"


           Select Case Fnc2
           Case "00"
            GetAsmCodes.B1 = &HC7

           Case "08"
            GetAsmCodes.B1 = &HCF

           Case "10"
            GetAsmCodes.B1 = &HD7

           Case "18"
            GetAsmCodes.B1 = &HDF

           Case "20"
            GetAsmCodes.B1 = &HE7

           Case "28"
            GetAsmCodes.B1 = &HEF

           Case "30"
            GetAsmCodes.B1 = &HF7

           Case "38"
            GetAsmCodes.B1 = &HFF

        End Select

' // SBC -------------------------------------
        Case "SBC"


           Select Case Fnc2
           Case "A,(HL)"
            GetAsmCodes.B1 = &H9E

           Case "A,(IX*)"
            GetAsmCodes.B1 = &H9E
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &H9E
            GetAsmCodes.B2 = &HFD

           Case "A,A"
            GetAsmCodes.B1 = &H9F

           Case "A,B"
            GetAsmCodes.B1 = &H98

           Case "A,C"
            GetAsmCodes.B1 = &H99

           Case "A,D"
            GetAsmCodes.B1 = &H9A

           Case "A,E"
            GetAsmCodes.B1 = &H9B

           Case "A,H"
            GetAsmCodes.B1 = &H9C

           Case "A,IXH"
            GetAsmCodes.B1 = &H9C
            GetAsmCodes.B2 = &HDD

           Case "A,IXL"
            GetAsmCodes.B1 = &H9D
            GetAsmCodes.B2 = &HDD

           Case "A,IYH"
            GetAsmCodes.B1 = &H9C
            GetAsmCodes.B2 = &HFD

           Case "A,IYL"
            GetAsmCodes.B1 = &H9D
            GetAsmCodes.B2 = &HFD

           Case "A,L"
            GetAsmCodes.B1 = &H9D

           Case "HL,BC"
            GetAsmCodes.B1 = &H42
            GetAsmCodes.B2 = &HED

           Case "HL,DE"
            GetAsmCodes.B1 = &H52
            GetAsmCodes.B2 = &HED

           Case "HL,HL"
            GetAsmCodes.B1 = &H62
            GetAsmCodes.B2 = &HED

           Case "HL,SP"
            GetAsmCodes.B1 = &H72
            GetAsmCodes.B2 = &HED

           Case "A,*"
            GetAsmCodes.B1 = &HDE

        End Select

' // SCF -------------------------------------
        Case "SCF"
            GetAsmCodes.B1 = &H37


' // SET -------------------------------------
        Case "SET"


           Select Case Fnc2
           Case "*,(HL)"
            GetAsmCodes.B1 = &HC6
            GetAsmCodes.B2 = &HCB

           Case "*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "*,A"
            GetAsmCodes.B1 = &HC7
            GetAsmCodes.B2 = &HCB

           Case "*,B"
            GetAsmCodes.B1 = &HC0
            GetAsmCodes.B2 = &HCB

           Case "*,C"
            GetAsmCodes.B1 = &HC1
            GetAsmCodes.B2 = &HCB

           Case "*,D"
            GetAsmCodes.B1 = &HC2
            GetAsmCodes.B2 = &HCB

           Case "*,E"
            GetAsmCodes.B1 = &HC3
            GetAsmCodes.B2 = &HCB

           Case "*,H"
            GetAsmCodes.B1 = &HC4
            GetAsmCodes.B2 = &HCB

           Case "*,L"
            GetAsmCodes.B1 = &HC5
            GetAsmCodes.B2 = &HCB

           Case "A,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,*,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "A,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,*,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

        End Select

' // SLA -------------------------------------
        Case "SLA"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &H26
            GetAsmCodes.B2 = &HCB

           Case "(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &H27
            GetAsmCodes.B2 = &HCB

           Case "B"
            GetAsmCodes.B1 = &H20
            GetAsmCodes.B2 = &HCB

           Case "C"
            GetAsmCodes.B1 = &H21
            GetAsmCodes.B2 = &HCB

           Case "D"
            GetAsmCodes.B1 = &H22
            GetAsmCodes.B2 = &HCB

           Case "E"
            GetAsmCodes.B1 = &H23
            GetAsmCodes.B2 = &HCB

           Case "H"
            GetAsmCodes.B1 = &H24
            GetAsmCodes.B2 = &HCB

           Case "L"
            GetAsmCodes.B1 = &H25
            GetAsmCodes.B2 = &HCB

           Case "A,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

        End Select

' // SL1 -------------------------------------
        Case "SL1"


           Select Case Fnc2
           Case "B"
            GetAsmCodes.B1 = &H30
            GetAsmCodes.B2 = &HCB

           Case "C"
            GetAsmCodes.B1 = &H31
            GetAsmCodes.B2 = &HCB

           Case "D"
            GetAsmCodes.B1 = &H32
            GetAsmCodes.B2 = &HCB

           Case "E"
            GetAsmCodes.B1 = &H33
            GetAsmCodes.B2 = &HCB

           Case "H"
            GetAsmCodes.B1 = &H34
            GetAsmCodes.B2 = &HCB

           Case "L"
            GetAsmCodes.B1 = &H35
            GetAsmCodes.B2 = &HCB

           Case "(HL)"
            GetAsmCodes.B1 = &H36
            GetAsmCodes.B2 = &HCB

           Case "A"
            GetAsmCodes.B1 = &H37
            GetAsmCodes.B2 = &HCB

           Case "(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "A,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

        End Select

' // SLL -------------------------------------
        Case "SLL"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &H36
            GetAsmCodes.B2 = &HCB

           Case "(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &H37
            GetAsmCodes.B2 = &HCB

           Case "B"
            GetAsmCodes.B1 = &H30
            GetAsmCodes.B2 = &HCB

           Case "C"
            GetAsmCodes.B1 = &H31
            GetAsmCodes.B2 = &HCB

           Case "D"
            GetAsmCodes.B1 = &H32
            GetAsmCodes.B2 = &HCB

           Case "E"
            GetAsmCodes.B1 = &H33
            GetAsmCodes.B2 = &HCB

           Case "H"
            GetAsmCodes.B1 = &H34
            GetAsmCodes.B2 = &HCB

           Case "L"
            GetAsmCodes.B1 = &H35
            GetAsmCodes.B2 = &HCB

           Case "A,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

        End Select

' // SLP -------------------------------------
        Case "SLP"
            GetAsmCodes.B1 = &H76
            GetAsmCodes.B2 = &HED


' // SRA -------------------------------------
        Case "SRA"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &H2E
            GetAsmCodes.B2 = &HCB

           Case "(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &H2F
            GetAsmCodes.B2 = &HCB

           Case "B"
            GetAsmCodes.B1 = &H28
            GetAsmCodes.B2 = &HCB

           Case "C"
            GetAsmCodes.B1 = &H29
            GetAsmCodes.B2 = &HCB

           Case "D"
            GetAsmCodes.B1 = &H2A
            GetAsmCodes.B2 = &HCB

           Case "E"
            GetAsmCodes.B1 = &H2B
            GetAsmCodes.B2 = &HCB

           Case "H"
            GetAsmCodes.B1 = &H2C
            GetAsmCodes.B2 = &HCB

           Case "L"
            GetAsmCodes.B1 = &H2D
            GetAsmCodes.B2 = &HCB

           Case "A,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

        End Select

' // SRL -------------------------------------
        Case "SRL"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &H3E
            GetAsmCodes.B2 = &HCB

           Case "(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &H3F
            GetAsmCodes.B2 = &HCB

           Case "B"
            GetAsmCodes.B1 = &H38
            GetAsmCodes.B2 = &HCB

           Case "C"
            GetAsmCodes.B1 = &H39
            GetAsmCodes.B2 = &HCB

           Case "D"
            GetAsmCodes.B1 = &H3A
            GetAsmCodes.B2 = &HCB

           Case "E"
            GetAsmCodes.B1 = &H3B
            GetAsmCodes.B2 = &HCB

           Case "H"
            GetAsmCodes.B1 = &H3C
            GetAsmCodes.B2 = &HCB

           Case "L"
            GetAsmCodes.B1 = &H3D
            GetAsmCodes.B2 = &HCB

           Case "A,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

        End Select

' // SUB -------------------------------------
        Case "SUB"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &H96

           Case "(IX*)"
            GetAsmCodes.B1 = &H96
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &H96
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &H97

           Case "B"
            GetAsmCodes.B1 = &H90

           Case "C"
            GetAsmCodes.B1 = &H91

           Case "D"
            GetAsmCodes.B1 = &H92

           Case "E"
            GetAsmCodes.B1 = &H93

           Case "H"
            GetAsmCodes.B1 = &H94

           Case "IXH"
            GetAsmCodes.B1 = &H94
            GetAsmCodes.B2 = &HDD

           Case "IXL"
            GetAsmCodes.B1 = &H95
            GetAsmCodes.B2 = &HDD

           Case "IYH"
            GetAsmCodes.B1 = &H94
            GetAsmCodes.B2 = &HFD

           Case "IYL"
            GetAsmCodes.B1 = &H95
            GetAsmCodes.B2 = &HFD

           Case "L"
            GetAsmCodes.B1 = &H95

           Case "*"
            GetAsmCodes.B1 = &HD6

        End Select

' // TST -------------------------------------
        Case "TST"


           Select Case Fnc2
           Case "A"
            GetAsmCodes.B1 = &H3C
            GetAsmCodes.B2 = &HED

           Case "B"
            GetAsmCodes.B1 = &H4
            GetAsmCodes.B2 = &HED

           Case "C"
            GetAsmCodes.B1 = &HC
            GetAsmCodes.B2 = &HED

           Case "D"
            GetAsmCodes.B1 = &H14
            GetAsmCodes.B2 = &HED

           Case "E"
            GetAsmCodes.B1 = &H1C
            GetAsmCodes.B2 = &HED

           Case "H"
            GetAsmCodes.B1 = &H24
            GetAsmCodes.B2 = &HED

           Case "L"
            GetAsmCodes.B1 = &H2C
            GetAsmCodes.B2 = &HED

           Case "(HL)"
            GetAsmCodes.B1 = &H34
            GetAsmCodes.B2 = &HED

           Case "*"
            GetAsmCodes.B1 = &H64
            GetAsmCodes.B2 = &HED

        End Select

' // XOR -------------------------------------
        Case "XOR"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &HAE

           Case "(IX*)"
            GetAsmCodes.B1 = &HAE
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HAE
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &HAF

           Case "B"
            GetAsmCodes.B1 = &HA8

           Case "C"
            GetAsmCodes.B1 = &HA9

           Case "D"
            GetAsmCodes.B1 = &HAA

           Case "E"
            GetAsmCodes.B1 = &HAB

           Case "H"
            GetAsmCodes.B1 = &HAC

           Case "IXH"
            GetAsmCodes.B1 = &HAC
            GetAsmCodes.B2 = &HDD

           Case "IXL"
            GetAsmCodes.B1 = &HAD
            GetAsmCodes.B2 = &HDD

           Case "IYH"
            GetAsmCodes.B1 = &HAC
            GetAsmCodes.B2 = &HFD

           Case "IYL"
            GetAsmCodes.B1 = &HAD
            GetAsmCodes.B2 = &HFD

           Case "L"
            GetAsmCodes.B1 = &HAD

           Case "*"
            GetAsmCodes.B1 = &HEE

        End Select

' // RLA -------------------------------------
        Case "RLA"
            GetAsmCodes.B1 = &H17


' // RLC -------------------------------------
        Case "RLC"


           Select Case Fnc2
           Case "(HL)"
            GetAsmCodes.B1 = &H6
            GetAsmCodes.B2 = &HCB

           Case "(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "A"
            GetAsmCodes.B1 = &H7
            GetAsmCodes.B2 = &HCB

           Case "B"
            GetAsmCodes.B1 = &HCB

           Case "C"
            GetAsmCodes.B1 = &H1
            GetAsmCodes.B2 = &HCB

           Case "D"
            GetAsmCodes.B1 = &H2
            GetAsmCodes.B2 = &HCB

           Case "E"
            GetAsmCodes.B1 = &H3
            GetAsmCodes.B2 = &HCB

           Case "H"
            GetAsmCodes.B1 = &H4
            GetAsmCodes.B2 = &HCB

           Case "L"
            GetAsmCodes.B1 = &H5
            GetAsmCodes.B2 = &HCB

           Case "A,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "A,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "B,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "B,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "C,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "C,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "D,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "D,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "E,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "E,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "H,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "H,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

           Case "L,(IX*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HDD

           Case "L,(IY*)"
            GetAsmCodes.B1 = &HCB
            GetAsmCodes.B2 = &HFD

        End Select

' // RLD -------------------------------------
        Case "RLD"
            GetAsmCodes.B1 = &H6F
            GetAsmCodes.B2 = &HED


' // RRA -------------------------------------
        Case "RRA"
            GetAsmCodes.B1 = &H1F

        
     End Select ' fnc1

Case 4
     Select Case Fnc1
' // CALL ------------------------------------
        Case "CALL"


           Select Case Fnc2
           Case "C"
            GetAsmCodes.B1 = &HDC

           Case "M"
            GetAsmCodes.B1 = &HFC

           Case "NC"
            GetAsmCodes.B1 = &HD4

           Case "NZ"
            GetAsmCodes.B1 = &HC4

           Case "P"
            GetAsmCodes.B1 = &HF4

           Case "PE"
            GetAsmCodes.B1 = &HEC

           Case "PO"
            GetAsmCodes.B1 = &HE4

           Case "Z"
            GetAsmCodes.B1 = &HCC

           Case "*"
            GetAsmCodes.B1 = &HCD

        End Select

' // CPDR ------------------------------------
        Case "CPDR"
            GetAsmCodes.B1 = &HB9
            GetAsmCodes.B2 = &HED


' // CPIR ------------------------------------
        Case "CPIR"
            GetAsmCodes.B1 = &HB1
            GetAsmCodes.B2 = &HED


' // DJNZ ------------------------------------
        Case "DJNZ"
            GetAsmCodes.B1 = &H10


' // HALT ------------------------------------
        Case "HALT"
            GetAsmCodes.B1 = &H76


' // INDR ------------------------------------
        Case "INDR"
            GetAsmCodes.B1 = &HBA
            GetAsmCodes.B2 = &HED


' // INIR ------------------------------------
        Case "INIR"
            GetAsmCodes.B1 = &HB2
            GetAsmCodes.B2 = &HED


' // LDDR ------------------------------------
        Case "LDDR"
            GetAsmCodes.B1 = &HB8
            GetAsmCodes.B2 = &HED


' // LDIR ------------------------------------
        Case "LDIR"
            GetAsmCodes.B1 = &HB0
            GetAsmCodes.B2 = &HED


' // OTDM ------------------------------------
        Case "OTDM"
            GetAsmCodes.B1 = &H8B
            GetAsmCodes.B2 = &HED

' // CPDR ------------------------------------
        Case "OTDR"
            GetAsmCodes.B1 = &HBB
            GetAsmCodes.B2 = &HED

' // OTIM ------------------------------------
        Case "OTIM"
            GetAsmCodes.B1 = &H83
            GetAsmCodes.B2 = &HED

' // OTIR ------------------------------------
        Case "OTIR"
            GetAsmCodes.B1 = &HB3
            GetAsmCodes.B2 = &HED

' // OUT0 ------------------------------------
        Case "OUT0"


           Select Case Fnc2
           Case "(*),A"
            GetAsmCodes.B1 = &H39
            GetAsmCodes.B2 = &HED

           Case "(*),B"
            GetAsmCodes.B1 = &H1
            GetAsmCodes.B2 = &HED

           Case "(*),C"
            GetAsmCodes.B1 = &H9
            GetAsmCodes.B2 = &HED

           Case "(*),D"
            GetAsmCodes.B1 = &H11
            GetAsmCodes.B2 = &HED

           Case "(*),E"
            GetAsmCodes.B1 = &H19
            GetAsmCodes.B2 = &HED

           Case "(*),H"
            GetAsmCodes.B1 = &H21
            GetAsmCodes.B2 = &HED

           Case "(*),L"
            GetAsmCodes.B1 = &H29
            GetAsmCodes.B2 = &HED

        End Select

' // OUTD ------------------------------------
        Case "OUTD"
            GetAsmCodes.B1 = &HAB
            GetAsmCodes.B2 = &HED


' // OUTI ------------------------------------
        Case "OUTI"
            GetAsmCodes.B1 = &HA3
            GetAsmCodes.B2 = &HED


' // PUSH ------------------------------------
        Case "PUSH"


           Select Case Fnc2
           Case "AF"
            GetAsmCodes.B1 = &HF5

           Case "BC"
            GetAsmCodes.B1 = &HC5

           Case "DE"
            GetAsmCodes.B1 = &HD5

           Case "HL"
            GetAsmCodes.B1 = &HE5

           Case "IX"
            GetAsmCodes.B1 = &HE5
            GetAsmCodes.B2 = &HDD

           Case "IY"
            GetAsmCodes.B1 = &HE5
            GetAsmCodes.B2 = &HFD

        End Select

' // RETI ------------------------------------
        Case "RETI"
            GetAsmCodes.B1 = &H4D
            GetAsmCodes.B2 = &HED


' // RETN ------------------------------------
        Case "RETN"
            GetAsmCodes.B1 = &H45
            GetAsmCodes.B2 = &HED


' // RRCA ------------------------------------
        Case "RRCA"
            GetAsmCodes.B1 = &HF


' // RLCA ------------------------------------
        Case "RLCA"
            GetAsmCodes.B1 = &H7



        End Select ' fnc1


Case 5
        Select Case Fnc1
' // TSTIO -----------------------------------
        Case "TSTIO *"
            GetAsmCodes.B1 = &H74
            GetAsmCodes.B2 = &HED

' // OTIMR ------------------------------------
        Case "OTIMR"
            GetAsmCodes.B1 = &H93
            GetAsmCodes.B2 = &HED

' // OTDMR ------------------------------------
        Case "OTDMR"
            GetAsmCodes.B1 = &H9B
            GetAsmCodes.B2 = &HED

        End Select ' fnc1

End Select 'Len fnc1

End Function

Sub Get_Lines(text As String, LinesArray() As String)
Dim line_Cnt As Long

text = UCase(text)

line_Cnt = 0

Do
LOffset = InStr(1, text, vbCrLf, vbBinaryCompare)
If LOffset = 0 Then Exit Do
ReDim Preserve LinesArray(line_Cnt)
LinesArray(line_Cnt) = Trim(Left(text, LOffset - 1))
If LinesArray(line_Cnt) = "" Or Left(text, 1) = ";" Then line_Cnt = line_Cnt - 1

text = Right(text, Len(text) - LOffset)
Do While Left(text, 1) = " " Or Left(text, 1) = vbTab Or Left(text, 1) = vbLf
 text = Right(text, Len(text) - 1)
Loop

line_Cnt = line_Cnt + 1
Loop
End Sub

Sub Assemble(text As String)
Dim LinesArray() As String, NbLine As Long, fnc As String, Fnc1 As String, Fnc2 As String, GetASM As String
Dim Sub1 As String, Sub2 As String
Dim FrstChr As String * 1
Dim MnemValue1 As Long, MnemValue2 As Long
Dim AsmBuffer() As Byte
Dim Result As Byte16
Dim ASMcnt As Long
Dim LabelsArray()
Dim Org_ASM As Long
Dim DirectASM() As Byte
Dim f1 As Integer
Dim RetUnStr As Integer
Dim CurLine As String

ASMcnt = 0

'ReDim LinesArray(0)
Get_Lines text, LinesArray()

Org_ASM = 16514
' Get "Org" function.

Do While NbLine <= UBound(LinesArray)
If InStr(1, UCase(LinesArray(NbLine)), "ORG") <> 0 Then
If InStr(1, LinesArray(NbLine), "+") Then
' decimal numeric value.
Org_ASM = val(Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - InStr(1, LinesArray(NbLine), "+")))
Else
' Hexadecimal numeric value.
Org_ASM = val("&h" & Trim(Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - InStr(1, UCase(LinesArray(NbLine)), "ORG") - 2)))
End If
If Org_ASM > &HFFFE Then Org_ASM = 16514
Exit Do
End If
NbLine = NbLine + 1
Loop

Do While NbLine <= UBound(LinesArray)
label = ""
Label2 = ""
Fnc1 = ""
Fnc2 = ""

'Mirror the current line to get directs
' ASM values, if the mnemonics test is corrupt.
CurLine = UCase(LinesArray(NbLine))


FrstChr = LinesArray(NbLine)
Select Case FrstChr
    Case "@"

    If InStr(1, LinesArray(NbLine), "=") = 0 Then
            nxtpar = InStr(1, LinesArray(NbLine), " ")
                If nxtpar <= 1 Then
                label = LinesArray(NbLine)
                LinesArray(NbLine) = ""

                Else
                label = Left(LinesArray(NbLine), nxtpar - 1)
                LinesArray(NbLine) = Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - InStr(1, LinesArray(NbLine), " "))
                End If
    Else
             nxtpar = InStr(1, LinesArray(NbLine), "=")
                If nxtpar <= 1 Then
                label = LinesArray(NbLine)
                LinesArray(NbLine) = ""

                Else
                label = Left(LinesArray(NbLine), nxtpar - 1)
                LinesArray(NbLine) = Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - nxtpar)
                End If
                
                nxtpar = InStr(1, LinesArray(NbLine), " ")
                If nxtpar <= 1 Then
                Label2 = LinesArray(NbLine)
                LinesArray(NbLine) = ""

                Else
                Label2 = Left(LinesArray(NbLine), nxtpar - 1)
                LinesArray(NbLine) = Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - nxtpar)
                End If
  
    End If
    
    Case ";"
            'Remarque.
            GoTo Nscan:
End Select

If LinesArray(NbLine) = "" Or Left(LinesArray(NbLine), 1) = ";" Then GoTo Nscan:

nxtpar = InStr(1, LinesArray(NbLine), " ")
If nxtpar <= 1 Then
Fnc1 = LinesArray(NbLine)
LinesArray(NbLine) = ""

Else
Fnc1 = Left(LinesArray(NbLine), nxtpar - 1)
LinesArray(NbLine) = Right(LinesArray(NbLine), Len(LinesArray(NbLine)) - nxtpar)
End If


If Fnc1 <> "JP" And Fnc1 <> "JR" Then
Fnc2 = Remove_Spaces(LinesArray(NbLine))
Else
nxtpar = InStr(1, LinesArray(NbLine), " ")
If nxtpar <> 0 Then
Fnc2 = Left(LinesArray(NbLine), nxtpar - 1)
Else
Fnc2 = "*" 'Value
End If
End If
nxtpar = InStr(1, Fnc2, ";")

If nxtpar > 1 Then Fnc2 = Left(Fnc2, nxtpar - 1)

Nscan:
Debug.Print "*>"; label, Label2, Fnc1, Fnc2

If InStr(1, UCase(Fnc1), "ORG") > 0 Or (Fnc1 = "" And Fnc2 = "") Then GoTo Nxt_line

'Test Function argument.
'String.
FrstChr = Fnc2
If FrstChr = Chr(34) Then
Fnc2 = Right(Fnc2, Len(Fnc2) - 1)
nxtpar = InStr(1, Fnc2, Chr(34))
Fnc2 = Left(Fnc2, nxtpar - 1)

  FrstChr = Fnc2
        
       MnemValue1 = ASCIICharToZX(FrstChr)
       Debug.Print Hex8(MnemValue1)
  Fnc2 = "*"

End If

MnemValue1 = 0
MnemValue2 = 0
vallen = 0

' Get sub-mnemonics.
nxtpar = InStr(1, Fnc2, ",")
' Is there any vigule.
If nxtpar > 1 Then
Sub1 = Left(Fnc2, nxtpar - 1)
Sub2 = Right(Fnc2, Len(Fnc2) - nxtpar)

    If Len(Sub1) > 1 Then
    FrstChr = Sub1
        If FrstChr = "(" Then
        Sub1 = Right(Sub2, Len(Sub2) - 1)
        nxtpar = InStr(1, Fnc2, ")")
        Sub1 = Left(Fnc2, nxtpar)
        FrstChr = Sub1
          If FrstChr = "+" Then
           MnemValue1 = val(Sub1)
          Else
          If IsHexValue(Sub1) Then
           MnemValue1 = ASChex(Sub1)
           Else
           Debug.Print "Erreur HEXA"
         
          End If
          If Fnc1 = "OUT" Then vallen = 1 Else vallen = 2
          If Sub1 <> "(HL)" And Sub1 <> "(BC)" And Sub1 <> "(DE)" Then Sub1 = "(*)"
          End If
        
        Debug.Print Hex16(MnemValue1)
        Else
        FrstChr = Sub1
        If FrstChr = "+" Then
          MnemValue1 = val(Sub1)
          Else
          If IsHexValue(Sub1) Then
           MnemValue1 = ASChex(Sub1)
           Else
            Debug.Print "Erreur HEXA"
                  


          End If
        If Sub1 = "BC" Or Sub1 = "HL" Or Sub1 = "DE" Or Sub1 = "SP" Then vallen = 2 Else vallen = 1: Sub1 = "*"
        
        End If
      
        Debug.Print Hex16(MnemValue1)
        End If
    End If
        
  If Len(Sub2) > 1 Then
        FrstChr = Sub2
    If FrstChr = "(" Then
        Sub2 = Right(Sub2, Len(Sub2) - 1)
        nxtpar = InStr(1, Fnc2, ")")
        Sub2 = Left(Fnc2, nxtpar - 1)
        FrstChr = Sub2
        
          If FrstChr = "+" Then
           MnemValue2 = val(Sub2)
          Else
          If IsHexValue(Sub2) Then
           MnemValue2 = ASChex(Sub2)
           Else
          Debug.Print "Erreur HEXA"

          End If
          
                  If Sub2 = "*" Then
                     If MnemValue2 = 188 Then Sub2 = "BC"
                     If MnemValue2 = 222 Then Sub2 = "DE"
                  Else
                     vallen = 2
                     Sub2 = "(*)"
                  End If
          
          End If

        Debug.Print Hex16(MnemValue2)
     Else
       FrstChr = Sub2
       If FrstChr = "+" Then
       
               MnemValue2 = val(Sub2)
               
        Else
                      If IsHexValue(Sub2) Then
                           MnemValue2 = ASChex(Sub2)
                           Sub2 = "*"
                         If MnemValue2 = 188 Then Sub2 = "BC"
                         If MnemValue2 = 222 Then Sub2 = "DE"

                      Else
                           Debug.Print "Erreur HEXA"
                      End If
                      
                      If Sub1 = "(*)" Then
                         If MnemValue2 = 188 Then Sub2 = "BC"
                         If MnemValue2 = 222 Then Sub2 = "DE"
                      Else
                         vallen = 1
                         Sub2 = "*"
                      End If
          End If
        
        Debug.Print Hex16(MnemValue2)

        End If
    End If
        Fnc2 = Sub1 & "," & Sub2
        Debug.Print Fnc2
End If

Result = GetAsmCodes(Fnc1, Fnc2)
If Result.B1 <> 0 And Fnc1 <> "NOP" Then
Debug.Print Fnc1; "-"; Hex16(CLng(Result.B1) * 256 + CLng(Result.B2)); ": Ok!"
Else
' Assemble as is. (hex value or dec value.
' Rescan the line and add in the asm codes.
If Trim(CurLine) <> "" And InStr(1, CurLine, "ORG") = 0 Then
If InStr(1, Trim(CurLine), ";") = 1 Then GoTo Nxt_line
If InStr(1, CurLine, ";") > 0 Then CurLine = Trim(Left(CurLine, InStr(1, CurLine, ";") - 1))
RetUnStr = -1
RetUnStr = Unstring(CurLine, DirectASM())
If RetUnStr = -1 Then GoTo Nxt_line
For f1 = 0 To RetUnStr
ReDim Preserve AsmBuffer(ASMcnt)
AsmBuffer(ASMcnt) = DirectASM(f1)
ASMcnt = ASMcnt + 1
Next f1
End If
GoTo Nxt_line
End If

ReDim Preserve AsmBuffer(ASMcnt)

AsmBuffer(ASMcnt) = Result.B1
ASMcnt = ASMcnt + 1

If Result.B2 <> 0 Then
ReDim Preserve AsmBuffer(ASMcnt)
AsmBuffer(ASMcnt) = Result.B2
ASMcnt = ASMcnt + 1
End If

If vallen <> 0 Then
If vallen < 2 Then
     ReDim Preserve AsmBuffer(ASMcnt)
         If Sub1 = "*" Or Sub1 = "(*)" Then AsmBuffer(ASMcnt) = CByte(MnemValue1 And 255)
         If Sub2 = "*" Or Sub2 = "(*)" Then AsmBuffer(ASMcnt) = CByte(MnemValue2 And 255)
     ASMcnt = ASMcnt + 1
End If

If vallen = 2 Then
ReDim Preserve AsmBuffer(ASMcnt)
         If Sub1 = "(*)" Then AsmBuffer(ASMcnt) = CByte(MnemValue1 \ 256)
         If Sub2 = "(*)" Then AsmBuffer(ASMcnt) = CByte(MnemValue2 \ 256)
    ASMcnt = ASMcnt + 1
End If
End If
Nxt_line:
NbLine = NbLine + 1
Loop
hFile_PRT = FreeFile
If Dir(App_path & "\Asm_Debug.bin") <> "" Then Kill App_path & "\Asm_Debug.bin"
Open App_path & "\Asm_Debug.bin" For Binary As hFile_PRT
Put #hFile_PRT, 1, AsmBuffer
Close hFile_PRT
End Sub

Function Remove_Spaces(text As String) As String
Dim TmpTXT As String
Dim FrstChr As String * 1
TmpTXT = ""

Do
FrstChr = text
If FrstChr <> " " And FrstChr <> vbTab Then TmpTXT = TmpTXT & FrstChr
If text = "" Then Exit Do
text = Right(text, Len(text) - 1)
Loop
Remove_Spaces = TmpTXT
End Function

Function IsHexValue(text As String) As Boolean
Dim FrstChr As String * 1
Dim TstCHR As Byte
Dim TmpTXT As String

TmpTXT = UCase(text)
IsHexValue = True

Do
FrstChr = TmpTXT
TstCHR = CByte(Asc(FrstChr))

If Not (TstCHR > &H40 And TstCHR < &H47) _
And Not (TstCHR > &H2F And TstCHR < &H3A) Then IsHexValue = False: Exit Function
TmpTXT = Right(TmpTXT, Len(TmpTXT) - 1)
If TmpTXT = "" Then Exit Do
Loop
End Function

Function Unstring(TxtStr As String, datas() As Byte) As Integer
If TxtStr = "" Then Unstring = -1: Exit Function
' Convert a string : "1 2 3" to a bytes array values.
'  Datas(0)=1 , Datas(1)=2 and Datas(2)=3.
Dim TmpStr As String
Dim cmp As Integer, StrCmp As Integer

cmp = 0
On Error Resume Next
TxtStr = TxtStr & "|"

Do

If InStr(1, TxtStr, " ") = 0 Then
TmpStr = Left(TxtStr, InStr(1, TxtStr, "|") - 1)
TxtStr = "|"
Else
TmpStr = Left(TxtStr, InStr(1, TxtStr, " ") - 1)
TxtStr = Trim(Right(TxtStr, Len(TxtStr) - Len(TmpStr) - 1))
End If

ReDim Preserve datas(cmp)
If InStr(1, TmpStr, "+") > 0 Then
    'decimal values.
    datas(cmp) = val(Right(TmpStr, Len(TmpStr) - 1))
Else
    If InStr(1, TmpStr, Chr(&H22)) > 0 Then ' ...'"' ist's a ZxChar. code.
        For StrCmp = 2 To Len(TmpStr) - 1
        ReDim Preserve datas(cmp)
        datas(cmp) = ASCIICharToZX(Mid(TmpStr, StrCmp, 1))
        If Mid(TmpStr, StrCmp + 1, 1) = Chr(&H22) Then Exit For
        cmp = cmp + 1
        Next StrCmp
    Else
        'Hexa Values.
        datas(cmp) = val("&h" & Trim(TmpStr))
    End If
End If
If TxtStr = "|" Then Exit Do
cmp = cmp + 1
Loop

Unstring = cmp

End Function
