Attribute VB_Name = "ModSnapZ81"

' *******************************************************************************
' VB81 XuR
' ModSnapZ81.BAS - Added by XavSnap. (2007)
' *******************************************************************************


'// Load Snap files Z80

' // CPU Statement:

Sub Snap_CPU(file_name As String)
Dim Lix As Integer, buff_line As String, a As Long
Dim Mem_Rng As Long
Dim TmpIf1 As Integer
Dim TmpIf2 As Integer

  bBooting = True
  bInputWait = False
  
  DoEvents
  
' // Clear ZX81 MEMORY
ClrMemory MEM(8192), 57344

' // INIT graphic cards
G_Card = eNo_Card
'SaveSetting "Grok", "vb81", "Graphic_Card", G_Card
 
' // Reset disk drives Larken & Mageco
bLarken = False
bMageco = False
'SaveSetting "Grok", "vb81", "Larken", "0"
'SaveSetting "Grok", "vb81", "Mageco", "0"
' Disk drivers are not cleaned...
' But, the rom at 2000h can be overwriten by the the memory dump.

Get_Config_z81 (file_name)

Lix = FreeFile
Open file_name For Input As Lix

Do Until (InStr(1, buff_line, "MEMRANGE") <> 0 Or EOF(Lix))
Line Input #Lix, buff_line

If InStr(1, buff_line, "PC ") > 0 Then Start = Get_Lng(buff_line, "PC ", 3): Debug.Print "PC:"; Hex(Start)
If InStr(1, buff_line, "SP ") > 0 Then regSP = Get_Lng(buff_line, "SP ", 4): Debug.Print "SP:"; Hex(regSP)
If InStr(1, buff_line, "HL ") > 0 Then regHL = Get_Lng(buff_line, "HL ", 3): Debug.Print "HL:"; Hex(regHL)
If InStr(1, buff_line, "DE ") > 0 Then regDE = Get_Lng(buff_line, "DE ", 3): Debug.Print "DE:"; Hex(regDE)

If InStr(1, buff_line, "AF ") > 0 Then
regA = val("&h" & (Mid(buff_line, InStr(1, buff_line, "AF") + 3, 2)))
setF val("&h" & (Mid(buff_line, InStr(1, buff_line, "AF") + 5, 2)))
Debug.Print "AF:"; Hex(regA * 256 + val("&h" & (Mid(buff_line, InStr(1, buff_line, "AF") + 5, 2))))
setAF (regA * 256 Or val("&h" & (Mid(buff_line, InStr(1, buff_line, "AF") + 5, 2))))
End If

If InStr(1, buff_line, "BC ") > 0 Then setBC val("&h" & (Mid(buff_line, InStr(1, buff_line, "BC") + 3, 4))): Debug.Print "BC:"; Hex8(regB); Hex8(regC)


If InStr(1, buff_line, "HL_") > 0 Then regHL_ = Get_Lng(buff_line, "HL_", 4): Debug.Print "HL_:"; Hex16(regHL_)
If InStr(1, buff_line, "DE_") > 0 Then regDE_ = Get_Lng(buff_line, "DE_", 4): Debug.Print "DE_:"; Hex16(regDE_)
If InStr(1, buff_line, "BC_") > 0 Then regBC_ = Get_Lng(buff_line, "BC_", 4): Debug.Print "BC_:"; Hex16(regBC_)
If InStr(1, buff_line, "AF_") > 0 Then regAF_ = Get_Lng(buff_line, "AF_", 4): Debug.Print "AF_:"; Hex16(regAF_)
If InStr(1, buff_line, "IX") > 0 Then regIX = Get_Lng(buff_line, "IX", 3): Debug.Print "IX:"; Hex16(regIX)
If InStr(1, buff_line, "IY") > 0 Then regIY = Get_Lng(buff_line, "IY", 4): Debug.Print "IY:"; Hex16(regIY)
If InStr(1, buff_line, "IM") > 0 Then intIM = val("&h" & (Mid(buff_line, InStr(1, buff_line, "IM") + 3, 2))): Debug.Print "IM:"; Hex8(intIM)

If InStr(1, buff_line, "IF1") > 0 Then
    TmpIf1 = val("&h" & (Mid(buff_line, InStr(1, buff_line, "IF1") + 4, 2)))

        If TmpIf1 <> 0 Then
        intIFF1 = True
        Else
        intIFF1 = False
        End If
 Debug.Print "IF1:"; intIFF1
 End If


If InStr(1, buff_line, "IF2") > 0 Then
    TmpIf2 = val("&h" & (Mid(buff_line, InStr(1, buff_line, "IF2") + 4, 2)))
    If TmpIf2 <> 0 Then
    intIFF2 = True
    Else
    intIFF2 = False
    End If
 Debug.Print "IF2:"; intIFF2
End If

'If InStr(1, buff_line, "HT") > 0 Then 'regSP = val("&h" &(Mid(buff_line, InStr(1, buff_line, "SP") + 1, 4)))

If InStr(1, buff_line, "IR") Then
intI = val("&h" & (Mid(buff_line, InStr(1, buff_line, "IR") + 3, 2)))
intR = val("&h" & (Mid(buff_line, InStr(1, buff_line, "IR") + 5, 2)))
Debug.Print "IR:"; Hex8(intI); Hex8(intR)
intRTemp = intR And 128
 End If
 
If InStr(1, buff_line, "NMI") > 0 Then

If val("&h" & (Mid(buff_line, InStr(1, buff_line, "NMI") + 5, 2))) = 0 Then
        ' SLOW Mode
      '  regAF_ = regAF_ Or 32768
      Else
        ' FAST Mode
      '  regAF_ = regAF_ And (Not 32768)
End If
End If

If val("&h" & (Mid(buff_line, InStr(1, buff_line, "ROW") + 3, 2))) > 0 Then

End If

'If InStr(1, buff_line, "HSYNC") > 0 Then
'If InStr(1, buff_line, "ROW") > 0 Then

 
 Loop
 
go_spp:

 If InStr(1, buff_line, "MEMRANGE") > 0 Then Mem_Rng = val("&h" & (Mid(buff_line, InStr(1, buff_line, "MEMRANGE") + 9, 4)))

 
 Close #Lix
 
 If Mem_Rng < 16384 Then bAllowWritesToROM = True
 
  'initParity
  getsnap_mem Mem_Rng, file_name
  
    
  regPC = Start
  
  lHiresLoc = SearchHiresScreen
  
  If G_Card = eHiResWRX And lHiresLoc > 0 Then WRX_Display = 0
    
       ClrMemory sLastScreen(0), 768
  
       ClrMemory gcBufferBits(0), 6528
        
   gpicDisplay.Cls

  
    If regAF_ And (Not 32768) > 0 Then bInputWait = True Else bInputWait = False
  'ShowDisplay True, True
  
  
    ' // PERFORM Z80 hardware functions (mimicking the NMI on a real ZX81)
    If (MEM(16443) And 128) = 128 Then
        ' // SLOW mode
        If lHiresLoc = 0 Then
            ScreenPaint True
        Else
            HiresScreenPaint
        End If
        
        ShowDisplay True, False
        
    ElseIf bInputWait Then
        ' // FAST mode, but waiting for a keypress
        If lHiresLoc = 0 Then
            ScreenPaint True
        Else
            HiresScreenPaint
        End If
        
        ShowDisplay True, False
    Else
               
        ' // FAST mode, executing code (hide display if necessary)
        ShowDisplay False, True
        
        If (MEM(16443) And 128) = 0 And (MEM(16443) And 64) = 64 Then ShowDisplay True, True
    End If
   
    

End Sub

Sub getsnap_mem(Mem_Rng As Long, file_name As String)
Dim Offset As Long
Dim snap_buffer() As Byte
Dim Data2 As String * 2
Dim Data4 As String * 4
Dim Mem_Offset As Long
Dim Data1 As String * 1
Dim TmpValue As String
Dim GetVal As Integer
 
m_iFile = FreeFile

   '//   Load Z81 file.
   
  Mem_Offset = Mem_Rng
  Open file_name For Binary Access Read Lock Write As #m_iFile ' Len = 2
  
 End_file = LOF(m_iFile)
 
 ' Move to memory offset TAG "MEMRANGE"
 Do
 Offset = Offset + 1
 If Offset >= End_file Then GoTo err_eof
 Get #m_iFile, Offset, Data4
 

 
 Loop Until Data4 = "MEMR"
 
 'Move to next Line
  Do
 Offset = Offset + 1
 If Offset >= End_file Then GoTo err_eof
 Get #m_iFile, Offset, Data2
 Loop Until Left(Data2, 1) = Chr(&HA)
 
add_chars:
  Offset = Offset + 1
  
If Offset >= End_file Then GoTo err_eof
  
  Do
    Get #m_iFile, Offset, Data2
    
If Mem_Offset >= 65536 Then GoTo err_eof

    If Left(Data2, 1) <> "*" Then
    ' Load ASCII value in memory
    MEM(Mem_Offset) = (val("&h" & Data2))
    Mem_Offset = Mem_Offset + 1
    Offset = Offset + 3
    Else
    Offset = Offset + 1
    Get #m_iFile, Offset, Data4
    Offset = Offset + 5
    Get #m_iFile, Offset, Data2
    Offset = Offset + 3
    
  ' Load ASCII values in memory.
   For a = 1 To CLng(val("&h" & Data4))
     MEM(Mem_Offset) = val("&h" & Data2)
     If Offset >= End_file Then GoTo err_eof
     Mem_Offset = Mem_Offset + 1
   Next
   
    End If
    
    If Offset >= End_file Then GoTo err_eof
  Loop Until Left(Data2, 1) = "*" Or Data2 = vbCrLf Or InStr(1, Data2, Chr(13)) <> 0
  
  If Left(Data2, 1) = "*" Then GoTo add_chars
err_eof:
  Close #m_iFile
  
 
End Sub

Function Get_Lng(buff_line As String, FndStr As String, Decay As Byte) As Long
Get_Lng = val("&h" & (Mid(buff_line, InStr(1, buff_line, FndStr) + Decay, 2))) * 256 + val("&h" & (Mid(buff_line, InStr(1, buff_line, FndStr) + Decay + 2, 2)))
End Function

Sub PutSnap_mem(Mem_Rng As Long, file_name As String)
Dim Lix As Integer, buff_line As String, a As Long
    

Dim Offset As Long
Dim snap_buffer() As String
Dim Data2 As String * 2
Dim Data4 As String * 4
Dim Mem_Offset As Long

If bAllowWritesToROM Then
Offset = &H2000
Else
Offset = &H4000
End If

m_iFile = FreeFile

   '//   Save Z81 file.
   
  Mem_Offset = Mem_Rng
  Open file_name For Output Access Write Lock Read As #m_iFile
  
  Debug.Print regPC
Debug.Print "PC "; Hex16(regPC); Tab(11); "SP  "; Hex16(regSP)
Debug.Print "HL "; Hex16(regHL); Tab(11); "HL_ "; Hex16(regHL_)
Debug.Print "DE "; Hex16(regDE); Tab(11); "DE_ "; Hex16(regDE_)
Debug.Print "BC "; Hex16((regB * 256) + regC); Tab(11); "BC_ "; Hex16(regBC_)
Debug.Print "AF "; Hex16((regA * 256) + getF); Tab(11); "AF_ "; Hex16(regAF_)
Debug.Print "IX "; Hex16(regIX); Tab(11); "IY  "; Hex16(regIY)
Debug.Print "IR "; Hex16((intI * 256) Or (intR And 127))
Debug.Print "IM "; Hex8(intIM); Tab(11); "IF1 "; IIf(intIFF1, "01", "00")
Debug.Print "HT 00"; Tab(11); "IF2 "; IIf(intIFF2, "01", "00")
  
  Print #m_iFile, "[CPU]"
  Print #m_iFile, "PC "; Hex16(regPC); Tab(11); "SP  "; Hex16(regSP)
  Print #m_iFile, "HL "; Hex16(regHL); Tab(11); "HL_ "; Hex16(regHL_)
  Print #m_iFile, "DE "; Hex16(regDE); Tab(11); "DE_ "; Hex16(regDE_)
  Print #m_iFile, "BC "; Hex16((regB * 256) Or regC); Tab(11); "BC_ "; Hex16(regBC_)
  Print #m_iFile, "AF "; Hex16((regA * 256) Or getF); Tab(11); "AF_ "; Hex16(regAF_)
  Print #m_iFile, "IX "; Hex16(regIX); Tab(11); "IY  "; Hex16(regIY)
  Print #m_iFile, "IR "; Hex16((intI * 256) Or intR)
  Print #m_iFile, "IM "; Hex8(intIM); Tab(11); "IF1 "; IIf(intIFF1, "01", "00")
  Print #m_iFile, "HT 00"; Tab(11); "IF2 "; IIf(intIFF2, "01", "00")
  Print #m_iFile,
  Print #m_iFile, "[ZX81]"
  Print #m_iFile, "NMI "; IIf(regA And &H80, "00", "01"); Tab(11); "HSYNC 01"
  Print #m_iFile, "ROW 007"
  Print #m_iFile,
  Print #m_iFile, "[CONFIG]"
  Print #m_iFile, "GCARD=" & Trim(CStr(G_Card))
  
  If G_Card > 0 Then
        Select Case G_Card
        Case eHiResMEMOTECH
             Print #m_iFile, "BASDISPLAY=" & Trim(CStr(Mem_Display))
        Case eHiResG007
             Print #m_iFile, "BASDISPLAY=" & Trim(CStr(G007_Display))
        Case eHiResQS
             Print #m_iFile, "BASDISPLAY=" & Trim(CStr(QSHRG_Display))
        End Select
  End If
  
    If S_Card > 0 Then
        Select Case S_Card
        Case esOctaviaKit
             Print #m_iFile, "BASSOUND=" & Trim(CStr(esOctaviaKit))
        Case esVtr
             Print #m_iFile, "BASSOUND=" & Trim(CStr(esVtr))
        Case esQuickSilva
             Print #m_iFile, "BASSOUND=" & Trim(CStr(esQuickSilva))
        Case esAGB
             Print #m_iFile, "BASSOUND=" & Trim(CStr(esAGB))
        Case esFuller
             Print #m_iFile, "BASSOUND=" & Trim(CStr(esFuller))
         Case esUSER
             Print #m_iFile, "BASSOUND=" & Trim(CStr(esUSER))
         Case esSPO256
             Print #m_iFile, "BASSOUND=" & Trim(CStr(esSPO256))
         Case esParrotSPO256
             Print #m_iFile, "BASSOUND=" & Trim(CStr(esParrotSPO256))
        End Select
  End If
  
  Print #m_iFile, "RAM=" & Trim(CStr(SRamPack))
  Print #m_iFile, "UDG=" & IIf(bAGBChargen Or bQSChargen, IIf(bAGBChargen, "2", "1"), "0")
  Print #m_iFile, "DISK=" & IIf(bLarken Or bMageco, IIf(bMageco, "2", "1"), "0")
  Print #m_iFile, "KEYS=" & val(GetSetting("Grok", "vb81", "Cursors", "0"))
  Print #m_iFile, "CENTRO=" & IIf(bPPI8255, "1", "0")
  Print #m_iFile, "FDISPLAY=" & GetSetting("Grok", "vb81", "ForceDisplay", "0")
  Print #m_iFile, "IDISPLAY=" & GetSetting("Grok", "vb81", "InvertedDisplay", "0")
  Print #m_iFile, "SHADOW=" & IIf(bAllowWritesToROM, "1", "0")

  Print #m_iFile,
  Print #m_iFile, "[MEMORY]"
  Print #m_iFile, "MEMRANGE " & Hex(Offset) & " " & Hex16(SRamLim)
  
  '/// Adventure C problem with 64k ram pack!
  '/// This address isn't mirrored and is placed in &h8000
  '/// It crash the computer when it's reloaded.
  '/// I don't know why!
  If peekw(&H4004) = &H8000 And &H8000 <> 0 Then MEM(&H8000) = 0
  
  For a = Offset To SRamLim
  Mem_Offset = 1
  If MEM(a) <> MEM(a + 1) Then
   Print #m_iFile, Hex8(CLng(MEM(a))); " ";
  Else
  
  Do
  Mem_Offset = Mem_Offset + 1
  a = a + 1
  If a + 1 >= UBound(MEM) Then Exit Do
  Loop Until MEM(a) <> MEM(a + 1)
  Print #m_iFile, "*"; Hex16(Mem_Offset); " "; Hex8(CLng(MEM(a))); " ";
  Mem_Offset = 1
  End If
  Next a
  
  If Mem_Offset > 1 Then Print #m_iFile, "*"; Hex16(Mem_Offset); " "; Hex8(CLng(MEM(a)));

  
    Print #m_iFile,
      Print #m_iFile, "[EOF]"
err_eof:
  Close #m_iFile
  
End Sub




Sub Extract_P(file_name As String, Optional Temp_F As Boolean = False, Optional New_FN As String = "")
Dim Offset As Long
Dim snap_buffer() As Byte
Dim snap_buffer2() As Byte
Dim Data2 As String * 2
Dim Data4 As String * 4
Dim Mem_Offset As Long
Dim Mem_Rng1 As Long
Dim Mem_Rng2  As Long
Dim P_Len As Long
Dim Lix As Integer
Dim Decay As Long

Lix = FreeFile
Open file_name For Input As Lix
Do Until (InStr(1, buff_line, "MEMRANGE") <> 0 Or EOF(Lix))
Line Input #Lix, buff_line
Loop
Mem_Rng1 = val("&h" & (Mid(buff_line, InStr(1, buff_line, "MEMRANGE") + 9, 4)))
Mem_Rng2 = val("&h" & (Mid(buff_line, InStr(1, buff_line, "MEMRANGE") + 14, 4)))
Close #Lix
 
If Mem_Rng1 < &H4000 Then Decay = (&H4000 - Mem_Rng1) Else Decay = 0
 
m_iFile = FreeFile

   '//   Load Z81 file.
   
  Mem_Offset = 0
  
  If Mem_Rng2 < 0 Then Mem_Rng2 = 65535
  
  ReDim snap_buffer(Mem_Rng2 - Mem_Rng1 + 1)
  Open file_name For Binary Access Read Lock Write As #m_iFile Len = 2
  
 End_file = LOF(m_iFile)
 
 ' Move to memory offset TAG "MEMRANGE"
 Do
 Offset = Offset + 1
 If Offset >= End_file Then GoTo err_eof
 Get #m_iFile, Offset, Data4
 Loop Until Data4 = "MEMR"
 
 'Move to next Line
  Do
 Offset = Offset + 1
 If Offset >= End_file Then GoTo err_eof
 Get #m_iFile, Offset, Data2
 Loop Until Left(Data2, 1) = Chr(&HA)
 
add_chars:
  Offset = Offset + 1
  
If Offset >= End_file Then GoTo err_eof
  
  Do
    Get #m_iFile, Offset, Data2
    
    If Mem_Offset > 65535 Or Data2 = vbCrLf Then GoTo err_eof
    
    If Left(Data2, 1) <> "*" Then
    ' Load ASCII value in memory
    snap_buffer(Mem_Offset) = val("&h" & Data2)
    Mem_Offset = Mem_Offset + 1
    Offset = Offset + 3
    Else
    Offset = Offset + 1
    Get #m_iFile, Offset, Data4
    Offset = Offset + 5
    Get #m_iFile, Offset, Data2
    Offset = Offset + 3
    
  ' Load ASCII values in memory.
   For a = 1 To CLng(val("&h" & Data4))
     snap_buffer(Mem_Offset) = val("&h" & Data2)
     If Offset >= End_file Then GoTo err_eof
     Mem_Offset = Mem_Offset + 1
   Next
   
    End If
    
    If Offset >= End_file Then GoTo err_eof
  Loop Until Left(Data2, 1) = "*" Or Data2 = vbCrLf Or InStr(1, Data2, Chr(13)) <> 0
  
  If Left(Data2, 1) = "*" Then GoTo add_chars
err_eof:
  Close #m_iFile
  
If Mem_Rng1 < &H2000 Then
RAM_TOP = GetW(Mem_Rng1 + Decay + &H28, snap_buffer())
Else
RAM_TOP = GetW(&H28, snap_buffer())
End If

P_Len = (RAM_TOP - &H4009)
If P_Len < 0 Then P_Len = &H4000
ReDim snap_buffer2(P_Len)

If Mem_Rng1 < &H4000 Then
CopyMemory snap_buffer2(0), snap_buffer(&H2009), P_Len
Else
CopyMemory snap_buffer2(0), snap_buffer(9), P_Len
End If


'Dim buffer() As Byte
  '      Dim len_p As Integer
  '      len_p = peekw(&H4004) - &H4009
  '      ReDim buffer(len_p - 1)
   '     CopyMemory buffer(0), mem(&H4009), len_p

If New_FN = "" And Temp_F = False Then Exit Sub
Lix = FreeFile

If Temp_F Then
     Open App.path & "\Snap_TMP.P" For Binary As Lix
     Put Lix, 1, snap_buffer2
     Close Lix
Else

     Open New_FN For Binary As Lix
     Put Lix, 1, snap_buffer2
     Close Lix

End If
End Sub

Function valHex(StrVal As String) As Long
Dim v1 As Long, V2 As Long
v1 = Asc(StrVal)
V2 = Asc(StrVal)
End Function

Private Function Get_Config_z81(FileName As String)
Dim Lix
Dim buff_line As String
Dim bConfig As Boolean

 Get_Config_z81 = False
 bConfig = False

' Test If there's a ZX81 configuration.
Lix = FreeFile
Open FileName For Input As Lix
Do Until (bConfig Or EOF(Lix))
Line Input #Lix, buff_line
If InStr(1, buff_line, "[CONFIG]") > 0 Then bConfig = True
Loop
Close Lix

 Get_Config_z81 = bConfig

If Not bConfig Then Debug.Print "No config  infos in this Z81 !": Exit Function

' Get Emulator configuration .
' --------------------------
Dim Offset As Long

Dim Data2 As String * 2
Dim Data4 As String * 4
Dim Data8 As String * 8
Dim Mem_Offset As Long
Dim Data1 As String * 1
Dim TmpValue As String
Dim GetVal As Integer


 Offset = 0
 
Lix = FreeFile
  Open FileName For Binary Access Read Lock Write As #Lix
  End_file = LOF(Lix)

 Do
 ' Move to offset TAG "[CONFIG]"
 Offset = Offset + 1
 If Offset >= End_file Then GoTo err_eof
 Get #Lix, Offset, Data8
 Loop Until Data8 = "[CONFIG]"
  
 Do 'Until EOF(Lix)
 
TmpValue = ""
 
  
 'Move to next Line
  Do
 Offset = Offset + 1
 If Offset >= End_file Then GoTo err_eof
 Get #Lix, Offset, Data1
 TmpValue = TmpValue + Data1
 Loop Until Data1 = Chr(&HA)
 
 If Right(TmpValue, 2) = vbCrLf Then
  TmpValue = Left(TmpValue, Len(TmpValue) - 2)
 Else
  TmpValue = Left(TmpValue, Len(TmpValue) - 1)
 End If
 
 
 GetVal = val(Trim(Right(TmpValue, Len(TmpValue) - InStr(1, TmpValue, "="))))
 Data4 = TmpValue
 
 Debug.Print TmpValue; ":"; GetVal
 
 
 'refresh HRG CARD's Rom
 If Data4 = "GCAR" Then G_Card = GetVal: If G_Card > 0 Then Load_TrueHrg (G_Card)
 'refresh RAM pack.
 If Data4 = "RAM=" Then SRamPack = GetVal
 
 If Data4 = "BASD" Then
   Select Case GetVal
    Case 0
        ' If 0= Basic Display
        FrmMainWnd.DispHRGon
        Select Case G_Card
        Case eHiResMEMOTECH
            Mem_Display = 0
        Case eHiResG007
            G007_Display = 0
        Case eHiResQS
            QSHRG_Display = 0
        End Select
        
    Case 1
        ' If 1= Graphic Display
        FrmMainWnd.DispHRGoff
        
        Select Case G_Card
        Case eHiResMEMOTECH
        ' ??? Not documented.
            Mem_Display = 1
        Case eHiResG007
             G007_Display = 1
        Case eHiResQS
            QSHRG_Display = 1
        End Select


    Case 2
        ' If 2= Graphic Display (for Memotech cards)
        FrmMainWnd.DispHRGoff
        
        Select Case G_Card
        Case eHiResMEMOTECH
            Mem_Display = 2
        End Select
        
    Case 3
       ' If 3= Reversed Display (for Memotech cards)
        FrmMainWnd.DispHRGon
        
        Select Case G_Card
        Case eHiResMEMOTECH
        Mem_Display = 3
        End Select

  End Select
  End If
 'INIT SOUNDCARD
 If Data4 = "BASS" Then
 
 Select Case GetVal
        Case esOctaviaKit
             S_Card = esOctaviaKit ' Octavia
        Case esVtr
             S_Card = esVtr ' ZONx / VTR
        Case esQuickSilva
             S_Card = esQuickSilva ' QuickSilva Sound card.
        Case esAGB
             S_Card = esAGB ' AGB Sound card.
        Case esFuller
             S_Card = esFuller ' Fuller Sound card.
        Case esUSER
             S_Card = esUSER ' USER AY Sound card.
        Case esSPO256
             S_Card = esSPO256 ' SPO256 Sound card.
        Case esParrotSPO256
             S_Card = esParrotSPO256 ' SPO256 Sound card.
 End Select
        
 End If
 
 If Data4 = "UDG=" Then
 Select Case GetVal
 Case 1
 bQSChargen = True: bAGBChargen = False
 Case 2
 bAGBChargen = True: bQSChargen = False
 Case Else
 bAGBChargen = False: bQSChargen = False
 End Select
 End If
 If Data4 = "DISK" Then
  Select Case GetVal
 Case 1
 bLarken = True: bMageco = False
 Case 2
 bMageco = True: bLarken = False
 Case Else
 bMageco = False: bLarken = False
 End Select
 End If
 
 'If Data4 = "KEYS" Then b val(GetSetting("Grok", "vb81", "Cursors", "0"))
 If Data4 = "CENT" Then bPPI8255 = IIf(GetVal = 1, True, False)
 If Data4 = "FDIS" Then bForceDisplay = IIf(GetVal = 1, True, False)
 If Data4 = "IDIS" Then bInv_Display = IIf(GetVal = 1, True, False)
 If Data4 = "SHAD" Then bAllowWritesToROM = IIf(GetVal = 1, True, False)
 'If Data4 = "MEMR" Then Exit Do
 Loop Until EOF(Lix) Or Data4 = "MEMR"
err_eof:
 Close #Lix
 On Error GoTo 0
If G_Card = eHiResMEMOTECH Or G_Card = eHiResG007 Or G_Card = eHiResQS Or G_Card = eHiResWRX Or bQSChargen Or bAGBChargen Then FrmMainWnd!ZX_DISP.Visible = True: FrmMainWnd!MnuBasicDisp.Visible = True Else FrmMainWnd!ZX_DISP.Visible = False: FrmMainWnd!MnuBasicDisp.Visible = False
If G_Card = eHiResG007 Then FrmMainWnd!VARiables.Enabled = False Else FrmMainWnd!VARiables.Enabled = True
If G_Card = eHiResMEMOTECH Or G_Card = eHiResQS Then FrmMainWnd!SEP3.Visible = True Else FrmMainWnd!SEP3.Visible = False
If G_Card = eHiResMEMOTECH Then FrmMainWnd!MnuMemotool.Visible = True Else FrmMainWnd!MnuMemotool.Visible = False
If G_Card = eHiResQS Then FrmMainWnd!MnuQStool.Visible = True Else FrmMainWnd!MnuQStool.Visible = False

 
End Function
