Attribute VB_Name = "ModSymbol"
Function Get_Rom(Address As Long, DecOffset As Integer) As String

DecOffset = 0

ReScan:
Select Case Address

   Case 0
      Get_Rom = "START"

   Case 8
      Get_Rom = "ERROR_1"

   Case 16
      Get_Rom = "PRINT_A"

   Case 24
      Get_Rom = "GET_CHAR"

   Case 28
      Get_Rom = "TEST_SP"

   Case 32
      Get_Rom = "NEXT_CHAR"

   Case 40
      Get_Rom = "FP_CALC"

   Case 43
      Get_Rom = "END_CALC"

   Case 48
      Get_Rom = "BC_SPACES"

   Case 56
      Get_Rom = "INTERRUPT"

   Case 65
      Get_Rom = "WAIT_INT"

   Case 69
      Get_Rom = "SCAN_LINE"

   Case 73
      Get_Rom = "CH_ADD+1"

   Case 76
      Get_Rom = "TEMP_PTR1"

   Case 77
      Get_Rom = "TEMP_PTR2"

   Case 86
      Get_Rom = "ERROR_2"

   Case 88
      Get_Rom = "ERROR_3"

   Case 102
      Get_Rom = "NMI"

   Case 109
      Get_Rom = "NMI_RET"

   Case 111
      Get_Rom = "NMI_CONT"

   Case 126
      Get_Rom = "K_UNSHIFT"

   Case 165
      Get_Rom = "K_SHIFT"

   Case 204
      Get_Rom = "K_FUNCT"

   Case 243
      Get_Rom = "K_GRAPH"

   Case 273
      Get_Rom = "TOKENS"

   Case 508
      Get_Rom = "LOAD_SAVE"

   Case 519
      Get_Rom = "SLOW_FAST"

   Case 534
      Get_Rom = "LOOP_11"

   Case 550
      Get_Rom = "NO_SLOW"

   Case 553
      Get_Rom = "DISPLAY_1"

   Case 557
      Get_Rom = "DISPLAY_P"

   Case 567
      Get_Rom = "ANOTHER"

   Case 569
      Get_Rom = "OVER_NC"

   Case 574
      Get_Rom = "DISPLAY_2"

   Case 612
      Get_Rom = "NO_KEY"

   Case 618
      Get_Rom = "LOOP_B"

   Case 641
      Get_Rom = "R_IX_1"

   Case 655
      Get_Rom = "R_IX_2"

   Case 658
      Get_Rom = "DISPLAY_3"

   Case 681
      Get_Rom = "DISPLAY_4"

   Case 693
      Get_Rom = "DISPLAY_5"

   Case 699
      Get_Rom = "KEYBOARD"

   Case 709
      Get_Rom = "EACH_LINE"

   Case 743
      Get_Rom = "SET_FAST"

   Case 756
      Get_Rom = "REPORT_F"

   Case 758
      Get_Rom = "SAVE"

   Case 767
      Get_Rom = "HEADER"

   Case 772
      Get_Rom = "DELAY_1"

   Case 779
      Get_Rom = "OUT_NAME"

   Case 790
      Get_Rom = "OUT_PROG"

   Case 798
      Get_Rom = "OUT_BYTE"

   Case 800
      Get_Rom = "EACH_BIT"

   Case 809
      Get_Rom = "PULSES"

   Case 813
      Get_Rom = "DELAY_2"

   Case 818
      Get_Rom = "BREAK_2"

   Case 822
      Get_Rom = "DELAY_3"

   Case 827
      Get_Rom = "DELAY_4"

   Case 832
      Get_Rom = "LOAD"

   Case 839
      Get_Rom = "NEXT_PROG"

   Case 844
      Get_Rom = "IN_BYTE"

   Case 846
      Get_Rom = "NEXT_BIT"

   Case 848
      Get_Rom = "BREAK_3"

   Case 865
      Get_Rom = "RESTART"

   Case 870
      Get_Rom = "IN_NAME"

   Case 881
      Get_Rom = "MATCHING"

   Case 891
      Get_Rom = "IN_PROG"

   Case 901
      Get_Rom = "GET_BIT"

   Case 904
      Get_Rom = "TRAILER"

   Case 906
      Get_Rom = "COUNTER"

   Case 924
      Get_Rom = "BIT_DONE"

   Case 930
      Get_Rom = "BREAK_4"

   Case 934
      Get_Rom = "REPORT_D"

   Case 936
      Get_Rom = "NAME"

   Case 963
      Get_Rom = "NEW"

   Case 971
      Get_Rom = "RAM_CHECK"

   Case 975
      Get_Rom = "RAM_FILL"

   Case 981
      Get_Rom = "RAM_READ"

   Case 994
      Get_Rom = "SET_TOP"

   Case 997
      Get_Rom = "INITIAL"

   Case 1032
      Get_Rom = "LINE"

   Case 1043
      Get_Rom = "N_L_ONLY"

   Case 1049
      Get_Rom = "UPPER"

   Case 1069
      Get_Rom = "ADDR_TOP"

   Case 1075
      Get_Rom = "LIST_TOP"

   Case 1108
      Get_Rom = "DOWN_KEY"

   Case 1111
      Get_Rom = "INC_LINE"

   Case 1124
      Get_Rom = "KEY_INPUT"

   Case 1135
      Get_Rom = "EDIT_INP"

   Case 1138
      Get_Rom = "LOWER"

   Case 1141
      Get_Rom = "EACH_CHAR"

   Case 1154
      Get_Rom = "END_LINE"

   Case 1159
      Get_Rom = "EDIT_LINE"

   Case 1162
      Get_Rom = "EDIT_ROOM"

   Case 1201
      Get_Rom = "FREE_LINE"

   Case 1217
      Get_Rom = "DISPLAY_6"

   Case 1231
      Get_Rom = "SLOW_DISP"

   Case 1247
      Get_Rom = "K_DECODE"

   Case 1266
      Get_Rom = "FUNC_BASE"

   Case 1271
      Get_Rom = "FETCH_1"

   Case 1285
      Get_Rom = "TABLE_ADD"

   Case 1288
      Get_Rom = "FETCH_2"

   Case 1301
      Get_Rom = "FETCH_3"

   Case 1302
      Get_Rom = "TEST_CURS"

   Case 1307
      Get_Rom = "ENTER"

   Case 1315
      Get_Rom = "BACK_NEXT"

   Case 1318
      Get_Rom = "ADD_CHAR"

   Case 1323
      Get_Rom = "K_L_KEY"

   Case 1325
      Get_Rom = "KEY_SORT"

   Case 1335
      Get_Rom = "CURSOR"

   Case 1344
      Get_Rom = "K_MODE"

   Case 1348
      Get_Rom = "TEST_CHAR"

   Case 1366
      Get_Rom = "L_MODE"

   Case 1372
      Get_Rom = "CLEAR_ONE"

   Case 1378
      Get_Rom = "ED_KEYS"

   Case 1398
      Get_Rom = "LEFT_KEY"

   Case 1407
      Get_Rom = "RIGHT_KEY"

   Case 1416
      Get_Rom = "GET_CODE"

   Case 1417
      Get_Rom = "ENDED_1"

   Case 1419
      Get_Rom = "RUBOUT"

   Case 1427
      Get_Rom = "LEFT_EDGE"

   Case 1437
      Get_Rom = "ENDED_2"

   Case 1439
      Get_Rom = "UP_KEY"

   Case 1455
      Get_Rom = "FUNCTION"

   Case 1463
      Get_Rom = "ZERO_DE"

   Case 1467
      Get_Rom = "LINE_NO"

   Case 1476
      Get_Rom = "EDIT_KEY"

   Case 1548
      Get_Rom = "N_L_KEY"

   Case 1574
      Get_Rom = "STK_UPPER"

   Case 1577
      Get_Rom = "NOW_SCAN"

   Case 1614
      Get_Rom = "N_L_INP"

   Case 1633
      Get_Rom = "TEST_NULL"

   Case 1636
      Get_Rom = "N_L_NULL"

   Case 1644
      Get_Rom = "NEXT_LINE"

   Case 1710
      Get_Rom = "STOP_LINE"

   Case 1738
      Get_Rom = "CONTINUE"

   Case 1745
      Get_Rom = "REPORT"

   Case 1760
      Get_Rom = "N_L_LINE"

   Case 1797
      Get_Rom = "COPY_OVER"

   Case 1836
      Get_Rom = "LLIST"

   Case 1840
      Get_Rom = "LIST"

   Case 1854
      Get_Rom = "LIST_PROG"

   Case 1856
      Get_Rom = "UNTIL_END"

   Case 1861
      Get_Rom = "OUT_LINE"

   Case 1877
      Get_Rom = "TEST_END"

   Case 1894
      Get_Rom = "COPY_LINE"

   Case 1901
      Get_Rom = "MORE_LINE"

   Case 1916
      Get_Rom = "TEST_NUM"

   Case 1946
      Get_Rom = "NOT_TOKEN"

   Case 1949
      Get_Rom = "OUT_CURS"

   Case 1962
      Get_Rom = "FLAGS_2"

   Case 1972
      Get_Rom = "NUMBER"

   Case 1981
      Get_Rom = "DECODE"

   Case 1991
      Get_Rom = "KEY_LINE"

   Case 2012
      Get_Rom = "LEAD_SP"

   Case 2017
      Get_Rom = "OUT_DIGIT"

   Case 2018
      Get_Rom = "DIGIT_INC"

   Case 2027
      Get_Rom = "OUT_CODE"

   Case 2030
      Get_Rom = "OUT_CH"

   Case 2033
      Get_Rom = "PRINT_CH"

   Case 2037
      Get_Rom = "PRINT_SP"

   Case 2050
      Get_Rom = "LPRINT_A"

   Case 2053
      Get_Rom = "PRINT_EXX"

   Case 2056
      Get_Rom = "ENTER_CH"

   Case 2066
      Get_Rom = "TEST_N_L"

   Case 2092
      Get_Rom = "TEST_LOW"

   Case 2101
      Get_Rom = "REPORT_5"

   Case 2106
      Get_Rom = "EXPAND_1"

   Case 2110
      Get_Rom = "WRITE_CH"

   Case 2119
      Get_Rom = "WRITE_N_L"

   Case 2129
      Get_Rom = "LPRINT_CH"

   Case 2153
      Get_Rom = "COPY"

   Case 2161
      Get_Rom = "COPY_BUFF"

   Case 2166
      Get_Rom = "COPY_D"

   Case 2170
      Get_Rom = "COPY_LOOP"

   Case 2173
      Get_Rom = "COPY_TIME"

   Case 2176
      Get_Rom = "COPY_BRK"

   Case 2184
      Get_Rom = "REPORT_D2"

   Case 2186
      Get_Rom = "COPY_CONT"

   Case 2204
      Get_Rom = "COPY_NEXT"

   Case 2229
      Get_Rom = "COPY_BITS"

   Case 2234
      Get_Rom = "COPY_WAIT"

   Case 2247
      Get_Rom = "COPY_N_L"

   Case 2270
      Get_Rom = "COPY_END"

   Case 2274
      Get_Rom = "CLEAR_PRB"

   Case 2281
      Get_Rom = "PRB_BYTES"

   Case 2293
      Get_Rom = "PRINT_AT"

   Case 2298
      Get_Rom = "TEST_VAL"

   Case 2309
      Get_Rom = "WRONG_VAL"

   Case 2315
      Get_Rom = "SET_FIELD"

   Case 2328
      Get_Rom = "LOC_ADDR"

   Case 2343
      Get_Rom = "LOOK_BACK"

   Case 2368
      Get_Rom = "EXPAND_2"

   Case 2379
      Get_Rom = "TOKENS"

   Case 2393
      Get_Rom = "ALL_CHARS"

   Case 2413
      Get_Rom = "TRAIL_SP"

   Case 2421
      Get_Rom = "TOKEN_ADD"

   Case 2431
      Get_Rom = "TEST_HIGH"

   Case 2437
      Get_Rom = "WORDS"

   Case 2450
      Get_Rom = "COMP_FLAG"

   Case 2451
      Get_Rom = "FOUND"

   Case 2459
      Get_Rom = "ONE_SPACE"

   Case 2462
      Get_Rom = "MAKE_ROOM"

   Case 2477
      Get_Rom = "POINTERS"

   Case 2484
      Get_Rom = "NEXT_PTR"

   Case 2504
      Get_Rom = "PTR_DONE"

   Case 2520
      Get_Rom = "LINE_ADDR"

   Case 2526
      Get_Rom = "NEXT_TEST"

   Case 2538
      Get_Rom = "CP_LINES"

   Case 2546
      Get_Rom = "NEXT_ONE"

   Case 2561
      Get_Rom = "NEXT+FIVE"

   Case 2568
      Get_Rom = "NEXT_LETT"

   Case 2575
      Get_Rom = "LINES"

   Case 2576
      Get_Rom = "NEXT_O_4"

   Case 2581
      Get_Rom = "NEXT_ADD"

   Case 2583
      Get_Rom = "DIFFER"

   Case 2591
      Get_Rom = "LINE_ENDS"

   Case 2602
      Get_Rom = "CLS"

   Case 2604
      Get_Rom = "B_LINES"

   Case 2626
      Get_Rom = "CLEAR_LOC"

   Case 2642
      Get_Rom = "COLLAPSED"

   Case 2653
      Get_Rom = "RECLAIM_1"

   Case 2656
      Get_Rom = "RECLAIM_2"

   Case 2675
      Get_Rom = "E_LINE_NO"

   Case 2705
      Get_Rom = "NO_NUMBER"

   Case 2712
      Get_Rom = "OUT_NUM"

   Case 2725
      Get_Rom = "OUT_NO"

   Case 2733
      Get_Rom = "THOUSAND"

   Case 2751
      Get_Rom = "UNITS"

   Case 2757
      Get_Rom = "UNSTACK_Z"

   Case 2763
      Get_Rom = "LPRINT"

   Case 2767
      Get_Rom = "PRINT"

   Case 2773
      Get_Rom = "PRINT_1"

   Case 2810
      Get_Rom = "NOT_AT"

   Case 2846
      Get_Rom = "TAB_TEST"

   Case 2865
      Get_Rom = "NOT_TAB"

   Case 2871
      Get_Rom = "PRINT_ON"

   Case 2884
      Get_Rom = "SPACING"

   Case 2894
      Get_Rom = "SYNTAX_ON"

   Case 2901
      Get_Rom = "PRINT_STK"

   Case 2916
      Get_Rom = "PR_STR_1"

   Case 2918
      Get_Rom = "PR_STR_2"

   Case 2919
      Get_Rom = "PR_STR_3"

   Case 2923
      Get_Rom = "PR_STR_4"

   Case 2948
      Get_Rom = "PRINT_END"

   Case 2955
      Get_Rom = "FIELD"

   Case 2980
      Get_Rom = "CENTRE"

   Case 2987
      Get_Rom = "RIGHT"

   Case 2991
      Get_Rom = "PLOT_UNP"

   Case 3013
      Get_Rom = "COLUMNS"

   Case 3018
      Get_Rom = "FIND_ADDR"

   Case 3033
      Get_Rom = "SQ_SAVED"

   Case 3034
      Get_Rom = "TABLE_PTR"

   Case 3049
      Get_Rom = "PLOT"

   Case 3051
      Get_Rom = "UNPLOT"

   Case 3057
      Get_Rom = "PLOT_END"

   Case 3061
      Get_Rom = "STK_TO_BC"

   Case 3074
      Get_Rom = "STK_TO_A"

   Case 3086
      Get_Rom = "SCROLL"

   Case 3113
      Get_Rom = "OFFSET_T"

   Case 3144
      Get_Rom = "P_LET"

   Case 3147
      Get_Rom = "P_GOTO"

   Case 3151
      Get_Rom = "P_IF"

   Case 3156
      Get_Rom = "P_GOSUB"

   Case 3160
      Get_Rom = "P_STOP"

   Case 3163
      Get_Rom = "P_RETURN"

   Case 3166
      Get_Rom = "P_FOR"

   Case 3174
      Get_Rom = "P_NEXT"

   Case 3178
      Get_Rom = "P_PRINT"

   Case 3181
      Get_Rom = "P_INPUT"

   Case 3185
      Get_Rom = "P_DIM"

   Case 3188
      Get_Rom = "P_REM"

   Case 3191
      Get_Rom = "P_NEW"

   Case 3194
      Get_Rom = "P_RUN"

   Case 3197
      Get_Rom = "P_LIST"

   Case 3200
      Get_Rom = "P_POKE"

   Case 3206
      Get_Rom = "P_RAND"

   Case 3209
      Get_Rom = "P_LOAD"

   Case 3212
      Get_Rom = "P_SAVE"

   Case 3215
      Get_Rom = "P_CONT"

   Case 3218
      Get_Rom = "P_CLEAR"

   Case 3221
      Get_Rom = "P_CLS"

   Case 3224
      Get_Rom = "P_PLOT"

   Case 3230
      Get_Rom = "P_UNPLOT"

   Case 3236
      Get_Rom = "P_SCROLL"

   Case 3239
      Get_Rom = "P_PAUSE"

   Case 3243
      Get_Rom = "P_SLOW"

   Case 3246
      Get_Rom = "P_FAST"

   Case 3249
      Get_Rom = "P_COPY"

   Case 3252
      Get_Rom = "P_LPRINT"

   Case 3255
      Get_Rom = "P_LLIST"

   Case 3258
      Get_Rom = "LINE_SCAN"

   Case 3265
      Get_Rom = "LINE_RUN"

   Case 3292
      Get_Rom = "STOP"

   Case 3294
      Get_Rom = "LINE_NULL"

   Case 3316
      Get_Rom = "SCAN_LOOP"

   Case 3319
      Get_Rom = "GET_PARAM"

   Case 3344
      Get_Rom = "SEPARATOR"

   Case 3350
      Get_Rom = "CLASS_TBL"

   Case 3357
      Get_Rom = "CHECK_END"

   Case 3362
      Get_Rom = "CHECK_2"

   Case 3366
      Get_Rom = "REPORT_C2"

   Case 3368
      Get_Rom = "CLASS_3"

   Case 3373
      Get_Rom = "CLASS_0"

   Case 3374
      Get_Rom = "CLASS_5"

   Case 3386
      Get_Rom = "CLASS_END"

   Case 3388
      Get_Rom = "CLASS_1"

   Case 3391
      Get_Rom = "CLASS_4_2"

   Case 3403
      Get_Rom = "REPORT_2"

   Case 3405
      Get_Rom = "SET_STK"

   Case 3427
      Get_Rom = "SET_STRLN"

   Case 3434
      Get_Rom = "REM"

   Case 3435
      Get_Rom = "CLASS_2"

   Case 3439
      Get_Rom = "INPUT_REP"

   Case 3461
      Get_Rom = "CLASS_4"

   Case 3474
      Get_Rom = "CLASS_6"

   Case 3482
      Get_Rom = "REPORT_C"

   Case 3484
      Get_Rom = "NO_TO_STK"

   Case 3494
      Get_Rom = "SYNTAX_Z"

   Case 3499
      Get_Rom = "IF"

   Case 3510
      Get_Rom = "IF_END"

   Case 3513
      Get_Rom = "FOR"

   Case 3526
      Get_Rom = "F_USE_ONE"

   Case 3532
      Get_Rom = "F_REORDER"

   Case 3562
      Get_Rom = "F_LMT_STP"

   Case 3598
      Get_Rom = "NXTLIN_NO"

   Case 3626
      Get_Rom = "FOR_END"

   Case 3630
      Get_Rom = "NEXT"

   Case 3672
      Get_Rom = "REPORT_1"

   Case 3674
      Get_Rom = "NEXT_LOOP"

   Case 3682
      Get_Rom = "LMT_V_VAL"

   Case 3689
      Get_Rom = "IMPOSS"

   Case 3692
      Get_Rom = "RAND"

   Case 3703
      Get_Rom = "SET_SEED"

   Case 3708
      Get_Rom = "CONT"

   Case 3713
      Get_Rom = "GOTO"

   Case 3718
      Get_Rom = "GOTO_2"

   Case 3730
      Get_Rom = "POKE"

   Case 3739
      Get_Rom = "POKE_SAVE"

   Case 3751
      Get_Rom = "FIND_INT"

   Case 3757
      Get_Rom = "REPORT_B"

   Case 3759
      Get_Rom = "RUN"

   Case 3765
      Get_Rom = "GOSUB"

   Case 3781
      Get_Rom = "TEST_ROOM"

   Case 3795
      Get_Rom = "REPORT_4"

   Case 3800
      Get_Rom = "RETURN"

   Case 3813
      Get_Rom = "REPORT_7"

   Case 3817
      Get_Rom = "INPUT"

   Case 3845
      Get_Rom = "PROMPT"

   Case 3860
      Get_Rom = "ENTER_CUR"

   Case 3873
      Get_Rom = "REPORT_8"

   Case 3875
      Get_Rom = "FAST"

   Case 3883
      Get_Rom = "SLOW"

   Case 3890
      Get_Rom = "PAUSE"

   Case 3910
      Get_Rom = "BREAK_1"

   Case 3915
      Get_Rom = "DEBOUNCE"

   Case 3925
      Get_Rom = "SCANNING"

   Case 3929
      Get_Rom = "S_LOOP_1"

   Case 3978
      Get_Rom = "S_JPI_END"

   Case 3980
      Get_Rom = "S_TEST_PI"

   Case 3993
      Get_Rom = "S_PI_END"

   Case 3997
      Get_Rom = "S_TST_INK"

   Case 4018
      Get_Rom = "S_ALPHANUM"

   Case 4054
      Get_Rom = "S_QUOTE"

   Case 4064
      Get_Rom = "S_Q_AGAIN"

   Case 4067
      Get_Rom = "S_QUOTE_S"

   Case 4077
      Get_Rom = "S_STRING"

   Case 4088
      Get_Rom = "S_J_CONT_3"

   Case 4091
      Get_Rom = "S_Q_NL"

   Case 4095
      Get_Rom = "S_RPT_C"

   Case 4098
      Get_Rom = "S_FUNCTION"

   Case 4122
      Get_Rom = "S_NO_TO__STR"

   Case 4128
      Get_Rom = "S_PUSH_PO"

   Case 4133
      Get_Rom = "S_LTR_DGT"

   Case 4167
      Get_Rom = "S_DECIMAL"

   Case 4207
      Get_Rom = "S_STK_DEC"

   Case 4227
      Get_Rom = "S_NUMERIC"

   Case 4231
      Get_Rom = "S_CONT_2"

   Case 4232
      Get_Rom = "S_CONT_3"

   Case 4248
      Get_Rom = "S_OPERTR"

   Case 4263
      Get_Rom = "SUBMLTDIV"

   Case 4277
      Get_Rom = "GET_PRIO"

   Case 4284
      Get_Rom = "S_LOOP"

   Case 4309
      Get_Rom = "S_SYNTEST"

   Case 4315
      Get_Rom = "S_RPORT_C"

   Case 4318
      Get_Rom = "S_RUNTEST"

   Case 4330
      Get_Rom = "S_LOOPEND"

   Case 4333
      Get_Rom = "S_TIGHTER"

   Case 4354
      Get_Rom = "S_NOT_AND"

   Case 4362
      Get_Rom = "S_NEXT"

   Case 4367
      Get_Rom = "TBL_PRI"

   Case 4380
      Get_Rom = "LOOK_VARS"

   Case 4409
      Get_Rom = "V_CHAR"

   Case 4419
      Get_Rom = "V_STR_VAR"

   Case 4424
      Get_Rom = "V_RUN_SYN"

   Case 4438
      Get_Rom = "V_RUN"

   Case 4441
      Get_Rom = "V_EACH"

   Case 4459
      Get_Rom = "V_MATCHES"

   Case 4460
      Get_Rom = "V_SPACES"

   Case 4479
      Get_Rom = "V_GET_PTR"

   Case 4480
      Get_Rom = "V_NEXT"

   Case 4488
      Get_Rom = "V_80_BYTE"

   Case 4490
      Get_Rom = "V_SYNTAX"

   Case 4500
      Get_Rom = "V_FOUND_1"

   Case 4501
      Get_Rom = "V_FOUND_2"

   Case 4505
      Get_Rom = "V_PASS"

   Case 4513
      Get_Rom = "V_END"

   Case 4519
      Get_Rom = "STK_VAR"

   Case 4530
      Get_Rom = "SV_SIMPLE_STR"

   Case 4543
      Get_Rom = "SV_ARRAYS"

   Case 4561
      Get_Rom = "SV_PTR"

   Case 4564
      Get_Rom = "SV_COMMA"

   Case 4585
      Get_Rom = "SV_CLOSE"

   Case 4593
      Get_Rom = "SV_CH_ADD"

   Case 4600
      Get_Rom = "SV_COUNT"

   Case 4603
      Get_Rom = "SV_LOOP"

   Case 4620
      Get_Rom = "SV_MULT"

   Case 4643
      Get_Rom = "SV_RPT_C"

   Case 4657
      Get_Rom = "REPORT_3"

   Case 4659
      Get_Rom = "SV_NUMBER"

   Case 4669
      Get_Rom = "SV_ELEM_STR"

   Case 4694
      Get_Rom = "SV_SLICE"

   Case 4697
      Get_Rom = "SV_DIM"

   Case 4698
      Get_Rom = "SV_SLICE"

   Case 4707
      Get_Rom = "SLICING"

   Case 4747
      Get_Rom = "SL_RPT_C"

   Case 4754
      Get_Rom = "SL_SECOND"

   Case 4773
      Get_Rom = "SL_DEFINE"

   Case 4793
      Get_Rom = "SL_OVER"

   Case 4798
      Get_Rom = "SL_STORE"

   Case 4802
      Get_Rom = "STK_ST_0"

   Case 4803
      Get_Rom = "STK_STO__STR"

   Case 4829
      Get_Rom = "INT_EXP1"

   Case 4830
      Get_Rom = "INT_EXP2"

   Case 4857
      Get_Rom = "I_CARRY"

   Case 4860
      Get_Rom = "I_RESTORE"

   Case 4863
      Get_Rom = "DE_DE+1"

   Case 4869
      Get_Rom = "GET_HL_DE"

   Case 4881
      Get_Rom = "HL_LOOP"

   Case 4890
      Get_Rom = "HL_END"

   Case 4893
      Get_Rom = "HL_AGAIN"

   Case 4897
      Get_Rom = "LET"

   Case 4909
      Get_Rom = "L_EACH_CH"

   Case 4910
      Get_Rom = "L_NO_SP"

   Case 4939
      Get_Rom = "L_CHAR"

   Case 4953
      Get_Rom = "L_SINGLE"

   Case 4961
      Get_Rom = "L_NUMERIC"

   Case 4974
      Get_Rom = "L_EXISTS"

   Case 4986
      Get_Rom = "L_DELETE_STR"

   Case 5027
      Get_Rom = "L_LENGTH"

   Case 5035
      Get_Rom = "L_IN_W_S"

   Case 5038
      Get_Rom = "L_ENTER"

   Case 5047
      Get_Rom = "L_ADD_STR"

   Case 5064
      Get_Rom = "L_NEW_STR"

   Case 5070
      Get_Rom = "L_STRING"

   Case 5095
      Get_Rom = "L_FIRST"

   Case 5112
      Get_Rom = "STK_FETCH"

   Case 5129
      Get_Rom = "DIM"

   Case 5132
      Get_Rom = "D_RPORT_C"

   Case 5148
      Get_Rom = "D_RUN"

   Case 5158
      Get_Rom = "D_LETTER"

   Case 5172
      Get_Rom = "D_SIZE"

   Case 5173
      Get_Rom = "D_NO_LOOP"

   Case 5247
      Get_Rom = "DIM_SIZES"

   Case 5256
      Get_Rom = "RESERVE"

   Case 5274
      Get_Rom = "CLEAR"

   Case 5283
      Get_Rom = "X_TEMP"

   Case 5286
      Get_Rom = "SET_STK_B"

   Case 5289
      Get_Rom = "SET_STK_E"

   Case 5293
      Get_Rom = "CURSOR_IN"

   Case 5308
      Get_Rom = "SET_MIN"

   Case 5319
      Get_Rom = "REC_V80"

   Case 5326
      Get_Rom = "ALPHA"

   Case 5330
      Get_Rom = "ALPHANUM"

   Case 5332
      Get_Rom = "ALPHA_2"

   Case 5337
      Get_Rom = "DEC_TO_FP"

   Case 5349
      Get_Rom = "NXT_DGT_1"

   Case 5365
      Get_Rom = "E_FORMAT"

   Case 5384
      Get_Rom = "SIGN_DONE"

   Case 5385
      Get_Rom = "ST_E_PART"

   Case 5393
      Get_Rom = "E_POSTVE"

   Case 5396
      Get_Rom = "STK_DIGIT"

   Case 5405
      Get_Rom = "STACK_A"

   Case 5408
      Get_Rom = "STACK_BC"

   Case 5430
      Get_Rom = "STK_BC_2"

   Case 5448
      Get_Rom = "INT_TO_FP"

   Case 5453
      Get_Rom = "NXT_DGT_2"

   Case 5466
      Get_Rom = "E_TO_FP"

   Case 5472
      Get_Rom = "E_LOOP"

   Case 5498
      Get_Rom = "E_LOW"

   Case 5501
      Get_Rom = "E_CHUNK"

   Case 5507
      Get_Rom = "E_DIVSN"

   Case 5508
      Get_Rom = "E_SWAP"

   Case 5511
      Get_Rom = "E_END"

   Case 5514
      Get_Rom = "FP_TO_BC"

   Case 5525
      Get_Rom = "FPBC_NZRO"

   Case 5551
      Get_Rom = "BIG_INT"

   Case 5557
      Get_Rom = "FPBC_NORM"

   Case 5564
      Get_Rom = "EXP_ZERO"

   Case 5574
      Get_Rom = "FPBC_END"

   Case 5581
      Get_Rom = "FP_TO_A"

   Case 5593
      Get_Rom = "FP_A_END"

   Case 5595
      Get_Rom = "PRINT_FP"

   Case 5610
      Get_Rom = "PF_NEGTVE"

   Case 5616
      Get_Rom = "PF_POSTVE"

   Case 5653
      Get_Rom = "PF_LOOP"

   Case 5676
      Get_Rom = "PF_NULL"

   Case 5689
      Get_Rom = "PF_RND_LP"

   Case 5707
      Get_Rom = "PF_ZERO_6"

   Case 5723
      Get_Rom = "PF_POS"

   Case 5727
      Get_Rom = "GET_FIRST"

   Case 5755
      Get_Rom = "PF_NIB_LP"

   Case 5762
      Get_Rom = "PF_E_FMT"

   Case 5784
      Get_Rom = "PF_E_POS"

   Case 5786
      Get_Rom = "PF_E_SIGN"

   Case 5790
      Get_Rom = "PF_E_TENS"

   Case 5805
      Get_Rom = "PF_E_LOW"

   Case 5810
      Get_Rom = "PF_ZEROS"

   Case 5818
      Get_Rom = "PF_ZRO_LP"

   Case 5823
      Get_Rom = "PF_ZERO_1"

   Case 5826
      Get_Rom = "PF_DC_OUT"

   Case 5832
      Get_Rom = "PF_FRAC_LP"

   Case 5840
      Get_Rom = "PF_NIBBLE"

   Case 5848
      Get_Rom = "PREP_ADD"

   Case 5868
      Get_Rom = "NEG_BYTE"

   Case 5879
      Get_Rom = "FETCH_TWO"

   Case 5914
      Get_Rom = "SHIFT_FP"

   Case 5922
      Get_Rom = "ONE_SHIFT"

   Case 5942
      Get_Rom = "ADDEND_0"

   Case 5944
      Get_Rom = "ZEROS_4_5"

   Case 5953
      Get_Rom = "ADD_BACK"

   Case 5962
      Get_Rom = "ALL_ADDED"

   Case 5964
      Get_Rom = "SUBTRACT"

   Case 5973
      Get_Rom = "ADDITION"

   Case 5993
      Get_Rom = "SHIFT_LEN"

   Case 6032
      Get_Rom = "TEST_NEG"

   Case 6067
      Get_Rom = "ADD_REP_6"

   Case 6071
      Get_Rom = "END_COMPL"

   Case 6073
      Get_Rom = "GO_NC_MLT"

   Case 6076
      Get_Rom = "PREP_M_D"

   Case 6086
      Get_Rom = "MULTIPLY"

   Case 6119
      Get_Rom = "MLT_LOOP"

   Case 6126
      Get_Rom = "NO_ADD"

   Case 6136
      Get_Rom = "STRT_MLT"

   Case 6158
      Get_Rom = "MAKE_EXPT"

   Case 6160
      Get_Rom = "DIVN_EXPT"

   Case 6169
      Get_Rom = "OFLW1_CLR"

   Case 6180
      Get_Rom = "OFLW2_CLR"

   Case 6184
      Get_Rom = "TEST_NORM"

   Case 6188
      Get_Rom = "NEAR_ZERO"

   Case 6192
      Get_Rom = "ZERO_RSLT"

   Case 6193
      Get_Rom = "SKIP_ZERO"

   Case 6207
      Get_Rom = "NORMALIZE"

   Case 6209
      Get_Rom = "SHIFT_ONE"

   Case 6233
      Get_Rom = "NORML_NOW"

   Case 6248
      Get_Rom = "OFLOW_CLR"

   Case 6272
      Get_Rom = "REPORT_6"

   Case 6274
      Get_Rom = "DIVISION"

   Case 6306
      Get_Rom = "DIV_LOOP"

   Case 6315
      Get_Rom = "DIV_34TH"

   Case 6322
      Get_Rom = "DIV_START"

   Case 6338
      Get_Rom = "SUBN_ONLY"

   Case 6345
      Get_Rom = "NO_RSTORE"

   Case 6346
      Get_Rom = "COUNT_ONE"

   Case 6372
      Get_Rom = "TRUNCATE"

   Case 6383
      Get_Rom = "T_GR_ZERO"

   Case 6388
      Get_Rom = "NIL_BYTES"

   Case 6400
      Get_Rom = "BYTE_ZERO"

   Case 6405
      Get_Rom = "BITS_ZERO"

   Case 6412
      Get_Rom = "LESS_MASK"

   Case 6418
      Get_Rom = "IX_END"

   Case 6421
      Get_Rom = "STK_ZERO"

   Case 6424
      Get_Rom = "STK_ONE"

   Case 6426
      Get_Rom = "STK_HALF"

   Case 6428
      Get_Rom = "STK_PI_2"

   Case 6433
      Get_Rom = "STK_TEN"

   Case 6435
      Get_Rom = "TBL_ADDRS"

   Case 6557
      Get_Rom = "CALCULATE"

   Case 6560
      Get_Rom = "GEN_ENT_1"

   Case 6564
      Get_Rom = "GEN_ENT_2"

   Case 6567
      Get_Rom = "RE_ENTRY"

   Case 6574
      Get_Rom = "SCAN_ENT"

   Case 6594
      Get_Rom = "FIRST_3D"

   Case 6606
      Get_Rom = "DOUBLE_A"

   Case 6608
      Get_Rom = "ENT_TABLE"

   Case 6627
      Get_Rom = "DELETE"

   Case 6628
      Get_Rom = "FP_CALC_2"

   Case 6635
      Get_Rom = "TEST_5_SP"

   Case 6646
      Get_Rom = "MOVE_FP"

   Case 6652
      Get_Rom = "STK_DATA"

   Case 6654
      Get_Rom = "STK_CONST"

   Case 6676
      Get_Rom = "FORM_EXP"

   Case 6695
      Get_Rom = "STK_ZEROS"

   Case 6701
      Get_Rom = "SKIP_CONS"

   Case 6702
      Get_Rom = "SKIP_NEXT"

   Case 6716
      Get_Rom = "LOC_MEM"

   Case 6725
      Get_Rom = "GET_MEM_XX"

   Case 6737
      Get_Rom = "STK_CONST_XX"

   Case 6755
      Get_Rom = "ST_MEM_XX"

   Case 6770
      Get_Rom = "EXCHANGE"

   Case 6772
      Get_Rom = "SWAP_BYTE"

   Case 6783
      Get_Rom = "SERIES_XX"

   Case 6793
      Get_Rom = "G_LOOP"

   Case 6816
      Get_Rom = "NEGATE"

   Case 6826
      Get_Rom = "ABS"

   Case 6831
      Get_Rom = "SGN"

   Case 6846
      Get_Rom = "PEEK"

   Case 6850
      Get_Rom = "IN_PK_STK"

   Case 6853
      Get_Rom = "USR_NO"

   Case 6862
      Get_Rom = "GREATER_0"

   Case 6869
      Get_Rom = "NOT"

   Case 6875
      Get_Rom = "LESS_0"

   Case 6876
      Get_Rom = "SIGN_TO_C"

   Case 6880
      Get_Rom = "FP_0_1"

   Case 6883
      Get_Rom = "FP_LOOP"

   Case 6893
      Get_Rom = "OR"

   Case 6899
      Get_Rom = "NO_&_NO"

   Case 6904
      Get_Rom = "STR_&_NO"

   Case 6915
      Get_Rom = "NO_L_EQL"

   Case 6923
      Get_Rom = "EX_OR_NOT"

   Case 6934
      Get_Rom = "NU_OR_STR"

   Case 6945
      Get_Rom = "STRINGS"

   Case 6956
      Get_Rom = "BYTE_COMP"

   Case 6963
      Get_Rom = "SECND_LOW"

   Case 6970
      Get_Rom = "BOTH_NULL"

   Case 6973
      Get_Rom = "SEC_PLUS"

   Case 6989
      Get_Rom = "FRST_LESS"

   Case 6992
      Get_Rom = "STR_TEST"

   Case 6996
      Get_Rom = "END_TESTS"

   Case 7010
      Get_Rom = "STRS_ADD"

   Case 7037
      Get_Rom = "OTHER_STR"

   Case 7045
      Get_Rom = "STK_PNTRS"

   Case 7055
      Get_Rom = "CHRS"

   Case 7074
      Get_Rom = "REPORT_BD"

   Case 7076
      Get_Rom = "VAL"

   Case 7125
      Get_Rom = "STR_STR"

   Case 7174
      Get_Rom = "CODE"

   Case 7182
      Get_Rom = "STK_CODE"

   Case 7185
      Get_Rom = "LEN"

   Case 7191
      Get_Rom = "DEC_JR_NZ"

   Case 7203
      Get_Rom = "JUMP"

   Case 7204
      Get_Rom = "JUMP_2"

   Case 7211
      Get_Rom = "JUMP_3"

   Case 7215
      Get_Rom = "JUMP_TRUE"

   Case 7223
      Get_Rom = "N_MOD_M"

   Case 7238
      Get_Rom = "INT"

   Case 7246
      Get_Rom = "X_NEG"

   Case 7257
      Get_Rom = "EXIT"

   Case 7259
      Get_Rom = "EXP"

   Case 7321
      Get_Rom = "REPORT_6B"

   Case 7323
      Get_Rom = "N_NEGTV"

   Case 7330
      Get_Rom = "RESULT_OK"

   Case 7332
      Get_Rom = "RSLT_ZERO"

   Case 7337
      Get_Rom = "LN"

   Case 7343
      Get_Rom = "REPORT_AB"

   Case 7345
      Get_Rom = "VALID"

   Case 7378
      Get_Rom = "GRE_8"

   Case 7448
      Get_Rom = "GET_ARGT"

   Case 7477
      Get_Rom = "ZPLUS"

   Case 7484
      Get_Rom = "YNEG"

   Case 7486
      Get_Rom = "COS"

   Case 7497
      Get_Rom = "SIN"

   Case 7499
      Get_Rom = "C_ENT"

   Case 7534
      Get_Rom = "TAN"

   Case 7542
      Get_Rom = "ATN"

   Case 7561
      Get_Rom = "SMALL"

   Case 7563
      Get_Rom = "CASES"

   Case 7620
      Get_Rom = "ASN"

   Case 7636
      Get_Rom = "ACS"

   Case 7643
      Get_Rom = "SQR"

   Case 7650
      Get_Rom = "TO_POWER"

   Case 7662
      Get_Rom = "XISO"

   Case 7675
      Get_Rom = "ONE"

   Case 7677
      Get_Rom = "LAST"

End Select
If Get_Rom = "" And Address >= 0 Then DecOffset = DecOffset + 1: Address = Address - 1: GoTo ReScan
'If Get_Rom = "" Then Get_Rom = "$" & Hex16(Address)

End Function

Function Get_Ram(Address As Long, DecOffset As Integer) As String

DecOffset = 0

' 16384 to 16507
ReScan:
Select Case Address
   Case 16384
      Get_Ram = "RAM_ERR_NR"

   Case 16385
      Get_Ram = "RAM_FLAGS"

   Case 16386
      Get_Ram = "RAM_ERR_SP"

   Case 16388
      Get_Ram = "RAM_RAMTOP"

   Case 16390
      Get_Ram = "RAM_MODE"

   Case 16391
      Get_Ram = "RAM_PPC"

   Case 16393
      Get_Ram = "RAM_VERSN"

   Case 16394
      Get_Ram = "RAM_E_PPC"

   Case 16396
      Get_Ram = "RAM_D_FILE"

   Case 16398
      Get_Ram = "RAM_DF_CC"

   Case 16400
      Get_Ram = "RAM_VARS"

   Case 16402
      Get_Ram = "RAM_DEST"

   Case 16404
      Get_Ram = "RAM_E_LINE"

   Case 16406
      Get_Ram = "RAM_CH_ADD"

   Case 16408
      Get_Ram = "RAM_X_PTR"

   Case 16410
      Get_Ram = "RAM_STKBOT"

   Case 16412
      Get_Ram = "RAM_STKEND"

   Case 16414
      Get_Ram = "RAM_BERG"

   Case 16415
      Get_Ram = "RAM_MEM"

   Case 16417
      Get_Ram = "RAM_SPARE1"

   Case 16418
      Get_Ram = "RAM_DF_SZ"

   Case 16419
      Get_Ram = "RAM_S_TOP"

   Case 16421
      Get_Ram = "RAM_LAST_K"

   Case 16423
      Get_Ram = "RAM_DBOUNCE"

   Case 16424
      Get_Ram = "RAM_MARGIN"

   Case 16425
      Get_Ram = "RAM_NXTLIN"

   Case 16427
      Get_Ram = "RAM_OLDPPC"

   Case 16429
      Get_Ram = "RAM_FLAGX"

   Case 16430
      Get_Ram = "RAM_STRLEN"

   Case 16432
      Get_Ram = "RAM_T_ADDR"

   Case 16434
      Get_Ram = "RAM_SEED"

   Case 16436
      Get_Ram = "RAM_FRAMES"

   Case 16438
      Get_Ram = "RAM_COORDS"

   Case 16440
      Get_Ram = "RAM_PR_CC"

   Case 16441
      Get_Ram = "RAM_S_POSN"

   Case 16443
      Get_Ram = "RAM_CDFLAG"

   Case 16444 To 16476
      Get_Ram = "RAM_PRBUFF" & Hex8(Address - 16444)

   Case 16477 To 16506
      Get_Ram = "RAM_MEMBOT" & Hex8(Address - 16477)

   Case 16507
      Get_Ram = "RAM_SPARE2"
End Select
If Get_Ram = "" Then DecOffset = DecOffset + 1: Address = Address - 1: GoTo ReScan

'If Get_Ram = "" Then Get_Ram = "$" & Hex16(Address)
End Function
