Attribute VB_Name = "ModWin"
' *******************************************************************************
' VB81 XuR
' ModWin.BAS - Added by XavSnap. (2007)
' *******************************************************************************
Const NONESSENTIAL = &H0
Const MAX_PATH = 145
Const OFFSET_4 = 4294967296#
Const MAXINT_4 = 2147483647
Const OFFSET_2 = 65536
Const MAXINT_2 = 32767


' Declare Unsigned integer allow to use and write an interger to &hFFFF
' Interger declaration allow a value to 32767 (&h7FFF) without the Bit15
' Used to set a positive or a negative value.
Type Uinteger
        Lbyte As Byte '&H00FF
        Hbyte As Byte '&HFF00
End Type

' Computer and User constants
Public Enum CSIDL
    CSIDL_DESKTOP = &H0
    CSIDL_INTERNET = &H1
    CSIDL_PROGRAMS = &H2
    CSIDL_CONTROLS = &H3
    CSIDL_PRINTERS = &H4
    CSIDL_PERSONAL = &H5
    CSIDL_FAVORITES = &H6
    CSIDL_STARTUP = &H7
    CSIDL_RECENT = &H8
    CSIDL_SENDTO = &H9
    CSIDL_BITBUCKET = &HA
    CSIDL_STARTMENU = &HB
    CSIDL_DESKTOPDIRECTORY = &H10
    CSIDL_DRIVES = &H11
    CSIDL_NETWORK = &H12
    CSIDL_NETHOOD = &H13
    CSIDL_FONTS = &H14
    CSIDL_TEMPLATES = &H15
    CSIDL_COMMON_STARTMENU = &H16
    CSIDL_COMMON_PROGRAMS = &H17
    CSIDL_COMMON_STARTUP = &H18
    CSIDL_COMMON_DESKTOPDIRECTORY = &H19
    CSIDL_APPDATA = &H1A
    CSIDL_LOCAL_APPDATA = &H1B
    CSIDL_ALTSTARTUP = &H1D
    CSIDL_COMMON_ALTSTARTUP = &H1E
    CSIDL_COMMON_FAVORITES = &H1F
    CSIDL_INTERNET_CACHE = &H20
    CSIDL_COOKIES = &H21
    CSIDL_HISTORY = &H22
    CSIDL_COMMON_APPDATA = &H23
    CSIDL_WINDOWS = &H24
    CSIDL_SYSTEM = &H25
    CSIDL_PROGRAM_FILES = &H26
    CSIDL_MYPICTURES = &H27
    CSIDL_PROFILE = &H28
    CSIDL_SYSTEMX86 = &H29
    CSIDL_PROGRAM_FILESX86 = &H2A
    CSIDL_PROGRAM_FILES_COMMON = &H2B
    CSIDL_PROGRAM_FILES_COMMONX86 = &H2C
    CSIDL_COMMON_TEMPLATES = &H2D
    CSIDL_COMMON_DOCUMENTS = &H2E
    CSIDL_COMMON_ADMINTOOLS = &H2F
    CSIDL_ADMINTOOLS = &H30
End Enum

Public Enum CSIDL_FOLDERPATH
    SHGFP_TYPE_CURRENT = &H0
    SHGFP_TYPE_DEFAULT = &H1
End Enum

' VB App_Path leek
Private Declare Function GetShortPathNameA Lib "kernel32.dll" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Private Declare Function GetLongPathNameA Lib "kernel32" (ByVal lpszShortPath As String, ByVal lpszLongPath As String, ByVal cchBuffer As Long) As Long
Private Declare Function GetVersion Lib "kernel32" () As Long
Private Declare Function GetWindowsDirectory Lib "kernel32" Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function GetSystemDirectory Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long
Private Declare Function SHGetFolderPath Lib "shfolder" Alias "SHGetFolderPathA" _
    (ByVal hWndOwner As Long, ByVal nFolder As CSIDL, ByVal hToken As Long, _
    ByVal dwFlags As CSIDL_FOLDERPATH, ByVal pszPath As String) As Long

'''sndPlaySound Constants
Const SND_ALIAS = &H10000
Const SND_ASYNC = &H1
Const SND_FILENAME = &H20000
Const SND_LOOP = &H8
Const SND_MEMORY = &H4
Const SND_NODEFAULT = &H2
Const SND_NOSTOP = &H10
Const SND_SYNC = &H0

' High level sound support API
#If Win32 Then
    Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" _
        (ByVal lpszSoundName As Any, ByVal uFlags As Long) As Long
#Else
    Declare Function sndPlaySound Lib "MMSYSTEM.DLL" _
        (ByVal lpszSoundName As Any, ByVal wFlags As Integer) As Integer
#End If

Global SoundBuffer As String

' adjust a long path name in a text or a label control (".../file.txt")
Public Function truncatepath$(TPath$, TForm As Form, TControl As Control)
Dim lTempLong As Long

Dim FirstSlash%
    On Error GoTo TPathError
    TPath = Trim(TPath): ' "H" in string = ???
    FirstSlash = InStr(3, TPath, "\")
    Do Until TForm.TextWidth(TPath) * Screen.TwipsPerPixelY <= TControl.width
        lTempLong = InStr(FirstSlash + 5, TPath, "\")
        If lTempLong = 0 Then Exit Do
        TPath = Left$(TPath, FirstSlash) & "..." & Mid$(TPath, lTempLong, Len(TPath) - lTempLong + 1)
    Loop
TooLong:
On Error GoTo StillError
If TForm.TextWidth(TPath) > TControl.width Then
    Do Until TForm.TextWidth(TPath) <= TControl.width
        TPath = Left$(TPath, Len(TPath) - 1)
    Loop
    TPath = Left$(TPath, Len(TPath) - 3) & "..."
End If
FinishAnyWay:
    truncatepath = TPath
    Exit Function
TPathError:
    Resume TooLong
StillError:
    Resume FinishAnyWay
End Function

'Get a file CRC32.
Public Function Get_CRC32(file_name As String) As Long


  Dim cStream As New cBinaryFileStream
   cStream.File = file_name
   
   Dim cCRC32 As New cCRC32
   Dim lCRC32 As Long

   lCRC32 = cCRC32.GetFileCrc32(cStream)
   
   Get_CRC32 = lCRC32

End Function

'Get an array CRC32.
Public Function Get_CRC32_ARR(Byte_ArrAy() As Byte) As Long

   Dim cCRC32 As New cCRC32
   Dim lCRC32 As Long

   lCRC32 = cCRC32.GetByteArrayCrc32(Byte_ArrAy())
   
   Get_CRC32_ARR = lCRC32

End Function


' Get the path of a specified file name.( "c:\vb\tmp\file.txt" -> "c:\vb\tmp" )
Public Function Cut_Path_Name(Long_name_file As String) As String
On Error GoTo endfnc
Dim LastSlash, scan_path As Integer
Dim char_path As String * 1
If Long_name_file = "" Then Cut_Path_Name = "": Exit Function
    scan_path = Len(Long_name_file)
    
Do While scan_path <> 1
    char_path = Mid(Long_name_file, scan_path, 1)
    If InStr(char_path, "\") <> 0 Then LastSlash = scan_path: Exit Do
    scan_path = scan_path - 1
Loop
If LastSlash <= 1 Then GoTo endfnc
Cut_Path_Name = Left(Long_name_file, LastSlash - 1)
Exit Function
endfnc:
Cut_Path_Name = Long_name_file
End Function

' Retrive name in a long file name string ( "c:\vb\tmp\file.txt" -> "file.txt" )
Public Function Cut_Name(Ln_file As String) As String
Dim LastSlash, scan_path As Integer
Dim char_path As String * 1
Dim lng_file As String

If Trim(GetLongPathName(Ln_file)) <> "" Then
lng_file = GetLongPathName(Ln_file)
End If


'If Ln_file = "" Then Cut_Name = "": Exit Function
If InStr(Ln_file, "\") = 0 Then Cut_Name = Ln_file: Exit Function
   
    scan_path = Len(Ln_file)
    Do While InStr(1, Mid(Ln_file, scan_path, 1), "\", vbBinaryCompare) = 0
     scan_path = scan_path - 1
    Loop
 LastSlash = scan_path
Cut_Name = Trim(Right(Ln_file, Len(Ln_file) - LastSlash))

End Function

' Internal function cut attributes "disk.TXT" = "disk"
Public Function Cut_attr(char As String) As String
For cmp = Len(char) To 1 Step -1
If Mid(char, cmp, 1) = "." Then Cut_attr = Mid(char, 1, cmp - 1): Exit For
If Mid(char, cmp, 1) = "\" Then Cut_attr = char: Exit For
Next cmp
End Function

Public Function GetLongPathName(Shortpath As String) As String
   Dim s As String
   Dim i As Long
   Dim ret As Long
   
   i = 1024
   s = String(i, 0)
   ret = GetLongPathNameA(Shortpath, s, i)
   
   GetLongPathName = Left$(s, InStr(s, Chr$(0)) - 1)
End Function

' Fonction de conversion en integer
Public Function Cunt(value As Uinteger) As Long
Cunt = (CLng(value.Hbyte) * 256) + CLng(value.Lbyte)
End Function


Public Sub Save2BytesPicture(Name As String)
Dim ln As Long
Dim hFile As Integer, RevCNT As Integer, U As Integer
Dim Header As String, ColorSTR As String
Dim gcBufferBitsRev() As Byte, gcBufferBitsMat() As Byte
ReDim gcBufferBitsMat(UBound(gcBufferBits))
ReDim gcBufferBitsRev(UBound(gcBufferBits))

CopyMemory gcBufferBitsMat(0), gcBufferBits(0), UBound(gcBufferBits)

'' Apply a Xor
RevCNT = 0
Do While RevCNT <= UBound(gcBufferBitsMat)
gcBufferBitsMat(RevCNT) = gcBufferBitsMat(RevCNT) Xor &HFF
RevCNT = RevCNT + 1
Loop

'Reverse lines ( 1 line = 34 bytes = 256+16 pixels = 272 pixels)
' horizontal mirroring.
RevCNT = 0 ' Dest.
t = UBound(gcBufferBitsMat) - 36 ' Source.
Do While t > -7
If t <= 0 Or RevCNT >= UBound(gcBufferBitsRev) - 36 Then
Debug.Print
End If
CopyMemory gcBufferBitsRev(RevCNT), gcBufferBitsMat(t), 36
RevCNT = RevCNT + 36
t = t - 36
Loop


ColorSTR = Chr((colors(1) And &HFF&)) & Chr((colors(1) And &HFF00&) \ 256) & Chr((colors(1) And &HFF0000) \ 65536)
ColorSTR = ColorSTR + Chr((colors(0) And &HFF&)) & Chr((colors(0) And &HFF00&) \ 256) & Chr((colors(0) And &HFF0000) \ 65536) & Chr(&H0)

Header = Chr(&H42) & Chr(&H4D) & Chr(&HE) & Chr(&H1B) & Chr(&H0) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H3E) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H28) & Chr(&H0) & Chr(&H0) & _
Chr(&H0) & Chr(&H10) & Chr(&H1) & Chr(&H0) & Chr(&H0) & Chr(&HC0) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H1) & Chr(&H0) & Chr(&H1) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & _
Chr(&H1B) & Chr(&H0) & Chr(&H0) & Chr(&H11) & Chr(&H17) & Chr(&H0) & _
Chr(&H0) & Chr(&H11) & Chr(&H17) & Chr(&H0) & Chr(&H0) & Chr(&H0) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & _
Chr(&H0) & Chr(&H0)

hFile = FreeFile
On Error GoTo exit_sub
     Open Name For Binary Access Write Lock Write As #hFile
     Put #hFile, 1, Header
     Put #hFile, Len(Header) + 1, ColorSTR
     Put #hFile, Len(Header) + Len(ColorSTR) + 1, gcBufferBitsRev
exit_sub:
    Close #hFile

End Sub

Public Sub Save2BytesPictureHRG(Name As String)
Dim ln As Long
Dim hFile As Integer, RevCNT As Integer, U As Integer
Dim Header As String, ColorSTR As String
Dim gcBufferBitsRev() As Byte, gcBufferBitsMat() As Byte
ReDim gcBufferBitsMat(UBound(gcBufferBits))
ReDim gcBufferBitsRev(UBound(gcBufferBits))

CopyMemory gcBufferBitsMat(0), gcBufferBits(0), UBound(gcBufferBits)

' Apply a Xor
RevCNT = 0
Do While RevCNT <= UBound(gcBufferBitsMat)
gcBufferBitsMat(RevCNT) = gcBufferBitsMat(RevCNT) Xor &HFF
RevCNT = RevCNT + 1
Loop

'Reverse lines ( 1 line = 32 bytes = 256 pixel)
RevCNT = 0
t = UBound(gcBufferBitsMat) - (32 * 26)
Do While t > -32
If t <= 0 Or RevCNT >= UBound(gcBufferBitsRev) - 32 Then
Debug.Print
End If
CopyMemory gcBufferBitsRev(RevCNT), gcBufferBitsMat(t), 32
RevCNT = RevCNT + 32
t = t - 32
Loop


ColorSTR = Chr((colors(1) And &HFF&)) & Chr((colors(1) And &HFF00&) \ 256) & Chr((colors(1) And &HFF0000) \ 65536)
ColorSTR = ColorSTR + Chr((colors(0) And &HFF&)) & Chr((colors(0) And &HFF00&) \ 256) & Chr((colors(0) And &HFF0000) \ 65536) & Chr(&H0)

Header = Chr(&H42) & Chr(&H4D) & Chr(&HE) & Chr(&H18) & Chr(&H0) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H3E) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H28) & Chr(&H0) & Chr(&H0) & _
Chr(&H0) & Chr(&H0) & Chr(&H1) & Chr(&H0) & Chr(&H0) & Chr(&HC0) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H1) & Chr(&H0) & Chr(&H1) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & _
Chr(&H1A) & Chr(&H0) & Chr(&H0) & Chr(&H88) & Chr(&HB) & Chr(&H0) & _
Chr(&H0) & Chr(&H88) & Chr(&HB) & Chr(&H0) & Chr(&H0) & Chr(&H0) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & _
Chr(&H0) & Chr(&H0)

hFile = FreeFile
On Error GoTo exit_sub
     Open Name For Binary Access Write Lock Write As #hFile
     Put #hFile, 1, Header
     Put #hFile, Len(Header) + 1, ColorSTR
     Put #hFile, Len(Header) + Len(ColorSTR) + 1, gcBufferBitsRev
exit_sub:
    Close #hFile

End Sub
Public Sub Save2BytesPictureC(Name As String)
Dim ln As Long
Dim hFile As Integer, RevCNT As Integer, U As Integer
Dim Header As String, ColorSTR As String
Dim gcBufferBitsRev() As Byte, gcBufferBitsMat() As Byte

ReDim gcBufferBitsRev(UBound(gcBufferBits))
ReDim gcBufferBitsMat(UBound(gcBufferBits))

RevCNT = 0 ' source (34)
RevCNT2 = 0 'dest (32)

Do
CopyMemory gcBufferBitsMat(RevCNT2), gcBufferBits(RevCNT), 32
RevCNT2 = RevCNT2 + 32
RevCNT = RevCNT + 36
Loop Until RevCNT > UBound(gcBufferBits)

ReDim Preserve gcBufferBitsMat(32 * 24 * 8)

' Apply a Xor
RevCNT = 0
Do While RevCNT <= UBound(gcBufferBitsMat)
gcBufferBitsMat(RevCNT) = gcBufferBitsMat(RevCNT) Xor &HFF
RevCNT = RevCNT + 1
Loop

ReDim Preserve gcBufferBitsRev(32 * 24 * 8)

'Reverse lines ( 1 line = 32 bytes = 256 pixel)
RevCNT = 0
t = UBound(gcBufferBitsMat) - 32
Do While t > -32
If t <= 0 Or RevCNT >= UBound(gcBufferBitsRev) - 32 Then
'Debug.Print
End If
CopyMemory gcBufferBitsRev(RevCNT), gcBufferBitsMat(t), 32
RevCNT = RevCNT + 32
t = t - 32
Loop


ColorSTR = Chr((colors(1) And &HFF&)) & Chr((colors(1) And &HFF00&) \ 256) & Chr((colors(1) And &HFF0000) \ 65536)
ColorSTR = ColorSTR + Chr((colors(0) And &HFF&)) & Chr((colors(0) And &HFF00&) \ 256) & Chr((colors(0) And &HFF0000) \ 65536) & Chr(&H0)

Header = Chr(&H42) & Chr(&H4D) & Chr(&HE) & Chr(&H18) & Chr(&H0) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H3E) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H28) & Chr(&H0) & Chr(&H0) & _
Chr(&H0) & Chr(&H0) & Chr(&H1) & Chr(&H0) & Chr(&H0) & Chr(&HC0) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H1) & Chr(&H0) & Chr(&H1) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & _
Chr(&H1A) & Chr(&H0) & Chr(&H0) & Chr(&H88) & Chr(&HB) & Chr(&H0) & _
Chr(&H0) & Chr(&H88) & Chr(&HB) & Chr(&H0) & Chr(&H0) & Chr(&H0) & _
Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & Chr(&H0) & _
Chr(&H0) & Chr(&H0)

hFile = FreeFile
On Error GoTo exit_sub
     Open Name For Binary Access Write Lock Write As #hFile
     Put #hFile, 1, Header
     Put #hFile, Len(Header) + 1, ColorSTR
     Put #hFile, Len(Header) + Len(ColorSTR) + 1, gcBufferBitsRev
exit_sub:
    Close #hFile

End Sub


Public Function ConvBin(value As Double, Optional longueur As Integer) As String
    
    On Error GoTo err
    'Convertir l'entier long en chane binaire
    ' Value#  - Entier long !(double prcision, pour viter les dbordements
    ' Longueur% - Longueur totale de la chane  gnrer
    '           (par exemple 32 caractres pour un entier long en 32 Bits)
    ' Bin$    - Chane binaire, par exemple "0100011101010", exploitation au niveau des bits
    'Ne travailler qu'avec des valeurs positives
    Dim x As Long, y As Long, dummy As Double
    Dim max As Long, rest As Double
    Dim res As String, Resultat As String
    Dim bLen As Integer, RestLen As Integer
    
    value = Abs(value)
    x = -1
    While dummy <= value
        x = x + 1
        dummy = 2 ^ x
    Wend
    max = x - 1
    rest = value
    'Construire la chane binaire
    For y = max To 0 Step -1
        rest = rest - (1 * 2 ^ y)
        If rest >= 0 Then res$ = "1"
        If rest < 0 Then
            rest = rest + (1 * 2 ^ y)
            res$ = "0"
        End If
        Resultat = Resultat + res
    Next y
    If Resultat = "" Then Resultat = "0"
    'Retourner rsultat
    If longueur = 0 Then
        'Retourtner rsultat (Longueur variable)
        ConvBin = Resultat
    Else
        'Complter  la longueur voulue (optionnel)
        bLen = Len(Resultat)
        RestLen = longueur - bLen
        ConvBin = String(RestLen, "0") & Resultat
    End If
    Exit Function
err:
    ConvBin = 0
End Function
Public Function FileExists(ByVal sFile As String, ByRef lErr As Long) As Boolean
   
   lErr = 0
   On Error Resume Next
   Dim sDir As String
      sDir = Dir(sFile)
   lErr = err.number
   On Error GoTo 0
   
   If (lErr = 0) Then
      If (Len(sDir) > 0) Then
         FileExists = True
      Else
         lErr = 53
      End If
   End If
   
End Function
' Internal function !
Function Format_Right(char As Long) As String

Select Case char
Case 0 To 9
Format_Right = Space(4) & Str(char)

Case 10 To 99
Format_Right = Space(3) & Str(char)

Case 100 To 999
Format_Right = Space(2) & Str(char)

Case 1000 To 9999
Format_Right = Space(1) & Str(char)

Case 10000 To 99999
Format_Right = Str(char)

End Select

End Function

' Internal function change a Null as a CrLf charcode!
Function Cut_o_arg(char As String) As String
Dim cmp As Integer
tmpchar = ""
For cmp = 1 To Len(char)
If Mid(char, cmp, 1) <> Chr(0) Then tmpchar = tmpchar + Mid(char, cmp, 1)
Next cmp
Cut_o_arg = tmpchar
End Function

' Internal function !
Function Comp_Str(char As String, longueur As Integer) As String

If longueur <= Len(char) Then Comp_Str = Right(char, longueur): Exit Function
Comp_Str = char + Space(longueur - Len(char))

End Function

Function Hex16(value As Long) As String
If value >= &H10000 Then Hex16 = "FFFF": Exit Function
If value < &H10 Then
   Hex16 = "000" & Hex(value): Exit Function
ElseIf value < &H100 Then
   Hex16 = "00" & Hex(value): Exit Function
ElseIf value < &H1000 Then
   Hex16 = "0" & Hex(value): Exit Function
End If
Hex16 = Hex8(value \ &H100) & Hex8(value - (value \ &H100) * &H100)
End Function

Function Hex8(value As Long) As String
If value >= &H100 Then Hex8 = "FF": Exit Function
If value < &H10 Then
Hex8 = "0" & Hex(value)
Else
Hex8 = Hex(value)
End If

End Function

Function DecFormat(value As Long) As String

Select Case value
Case Is < 10
DecFormat = "  " & Trim(Str(value))
Case Is < 99
DecFormat = " " & Trim(Str(value))
Case Else
DecFormat = Trim(Str(value))
End Select

End Function

Function ASChex(Strhex As String) As Single
If Len(Strhex) >= 8 Then ASChex = 65535: Exit Function

Dim multi As String
Dim a As Integer
multi = 0
ASChex = 0
If Strhex = "" Then Exit Function

For a = Len(Strhex) To 1 Step -1
ASChex = ASChex + (CSng(val("&h" & Mid(Strhex, a, 1))) * CSng((16 ^ multi)))
multi = multi + 1
Next

End Function

Public Function AdvHEX(dec As Long) As String
AdvHEX = ""
If dec > &HFFFF Then AdvHEX = Hex((dec And &HFFFF0000) \ 10000)
AdvHEX = AdvHEX + Hex((dec And &HFFFF))
End Function

Function BinToDbl(value As String) As Double
    'Convertir chane binaire en entier long
    '  Value$ - chane binaire , par exemple "0110101"
    '  Dez#   - Entier long (Type Double)
    Dim Dezimal As Double
    Dim MaxLen As Integer
    Dim b As Integer, x As Integer
  
    MaxLen = Len(value)
    For x = 1 To MaxLen
        b = val(Mid$(value, x, 1))
        Dezimal = Dezimal + b * 2 ^ (MaxLen - x)
    Next
    BinToDbl = Dezimal
End Function

Function Is_DEC(Key As Integer) As Boolean

Is_DEC = True
If Key = vbKeyReturn Or Key = vbKeyLeft Or Key = vbKeyRight Or Key = vbKeyBack Or Key = vbKeyDelete Or Key = vbKeyInsert Then Exit Function
If (Key < &H30 Or Key > &H39) Then Is_DEC = False

End Function
Function Is_HEX(Key As Integer) As Boolean
Is_HEX = True
If Key = vbKeyReturn Or Key = vbKeyLeft Or Key = vbKeyRight Or Key = vbKeyBack Or Key = vbKeyDelete Or Key = vbKeyInsert Then Exit Function
If Not (Asc(UCase(Chr(Key))) > &H40 And Asc(UCase(Chr(Key))) < &H47) _
And Not (Key > &H2F And Key < &H3A) Then Is_HEX = False: GoTo Key_is_ok
If (Asc(UCase(Chr(Key))) > &H40 And Asc(UCase(Chr(Key))) < &H47) Then KeyAscii = Asc(UCase(Chr(KeyAscii)))

Key_is_ok:
End Function

Function Hex2Dec(HexValue As String) As Integer
  Dim lsChar As String
  Dim liHBit As Integer
  Dim liLBit As Integer
  
  ' H Byte
  lsChar = Mid(HexValue, 1, 1)
  Select Case Asc(lsChar)
    Case 48 To 57 '0..9
      liHBit = val(lsChar) * 16
    Case 65 To 70 'A..F
      liHBit = (((65 - Asc(lsChar)) * -1) + 10) * 16
  End Select
    
  ' L Byte
  lsChar = Mid(HexValue, 2, 1)
  Select Case Asc(lsChar)
    Case 48 To 57 '0..9
      liLBit = val(lsChar)
    Case 65 To 70 'A..F
      liLBit = (65 - Asc(lsChar)) * -1 + 10
  End Select
  
  Hex2Dec = liHBit + liLBit
End Function

Function AdvHEXSgl(dec As Single) As String
AdvHEXSgl = ""
If dec > &HFFFF Then AdvHEXSgl = Hex16Dbl((dec And &HFFFF0000) \ 10000) Else AdvHEXSgl = "0000"
AdvHEXSgl = AdvHEXSgl + Hex16Dbl((dec And &HFFFF))
End Function

Function Hex16Dbl(value As Double) As String
Dim lValue As Integer
Dim StrValue As String
StrValue = Hex(value)
lValue = Len(StrValue)
If lValue < 2 Then
   Hex16Dbl = "000" & StrValue: Exit Function
ElseIf lValue < 3 Then
   Hex16Dbl = "00" & StrValue: Exit Function
ElseIf lValue < 4 Then
   Hex16Dbl = "0" & StrValue: Exit Function
End If
Hex16Dbl = Hex(value And 65535)
' Hex8(value / &H100) & Hex8(value - (value / &H100) * &H100)
End Function




Function WindowsVersion()
Dim Ver As Long, WinVer As Long
    Ver = GetVersion()
    WinVer = Ver And &HFFFF&
    WindowsVersion = Format((WinVer Mod 256) + ((WinVer \ 256) / 100), "Fixed")
End Function

Function SystemDirectory() As String
Dim WinPath As String
    WinPath = String(145, Chr(0))
    SystemDirectory = Left(WinPath, GetSystemDirectory(WinPath, InStr(WinPath, Chr(0)) - 1))
End Function

Function WindowsDirectory() As String
Dim WinPath As String
Dim temp
    WinPath = String(145, Chr(0))
    temp = GetWindowsDirectory(WinPath, 145)
    WindowsDirectory = Left(WinPath, InStr(WinPath, Chr(0)) - 1)
End Function

Private Function GetFolderLocation(ByVal FolderID As CSIDL) As String
    Dim localDir As String, lRet As Long
    localDir = String$(MAX_PATH, vbNullChar)
      
    lRet = SHGetFolderPath(NONESSENTIAL, FolderID, NONESSENTIAL, _
        SHGFP_TYPE_CURRENT, localDir)
      
    localDir = TrimNull(localDir)
    GetFolderLocation = localDir
End Function

Public Function Desktop_Path() As String
    Desktop_Path = GetFolderLocation(CSIDL_DESKTOP)
End Function
Public Function TrimNull(ByVal Item As String) As String
    Dim nPos As Long
    nPos = InStr(Item, Chr$(0))
    If nPos Then Item = Left$(Item, nPos - 1)
    TrimNull = Item
End Function

Function StoUint(value As Long) As Uinteger
StoUint.Hbyte = CByte((value And 65280) \ 256)
StoUint.Lbyte = CByte(value And 255)
End Function

Function UinttoS(value As Uinteger) As Long
UinttoS = (CLng(value.Hbyte) * 256) + CLng(value.Lbyte)
End Function

Function Remove_tabs(LineText As String) As String
Dim TmpLineText As String
Dim TabLoc As Long

TmpLineText = ""
TabLoc = 1

Do
TabLoc = InStr(TabLoc, LineText, vbTab)
If TabLoc = 0 Then Exit Do
If TabLoc <> 1 Then TmpLineText = TmpLineText & Left(LineText, TabLoc - 1) & " " Else TmpLineText = TmpLineText & " "
LineText = Right(LineText, Len(LineText) - TabLoc)
TabLoc = 1
Loop While TabLoc > 0
Remove_tabs = TmpLineText & LineText
End Function

Public Function UnsignedToLong(value As Double) As Long
    If value < 0 Or value >= OFFSET_4 Then Error 6
    
    If value <= MAXINT_4 Then
        UnsignedToLong = value
    Else
        UnsignedToLong = value - OFFSET_4
    End If
End Function

Function Is_BIN(Key As Integer) As Boolean
Is_BIN = True
If Key = vbKeyReturn Or Key = vbKeyLeft Or Key = vbKeyRight Or Key = vbKeyBack Or Key = vbKeyDelete Or Key = vbKeyInsert Then Exit Function
If Not (Key = vbKey0 Or Key = vbKey1 Or Key = vbKeyNumpad0 Or Key = vbKeyNumpa1) Then Is_BIN = False
End Function

' Load a Text file in a TextBox.
Public Sub Load_Text(Tbox As TextBox, file_name As String)
Dim Lix As Integer, lsTransTextSTR As String
reset
  Lix = FreeFile
  Open file_name For Binary Access Read As #Lix

    ' Load the file
    If LOF(Lix) >= 32760 Then
    lsTransTextSTR = Space$(32750)
    Get #Lix, , lsTransTextSTR
    Tbox.text = lsTransTextSTR & vbCrLf & "<CUT: File too big to be previewed in this box.>"
    Else
    lsTransTextSTR = Space$(LOF(Lix))
    Get #Lix, , lsTransTextSTR
    Tbox.text = lsTransTextSTR & vbCrLf & "<EOF>"
    End If

  Close #Lix

End Sub
Public Sub FindTag(MyLV As ListView, StrTag As String)
'MyLV.
End Sub

Public Function Get_LastPath() As String
Get_LastPath = GetSetting("Grok", "vb81", "LastPath", App.path)
If Right(Get_LastPath, 1) <> "\" Then Get_LastPath = Get_LastPath & "\"
End Function

Sub BeginPlaySound(ByVal ResourceId As Integer, SYNC As Boolean)
    Dim ret As Variant

        ' Important: The returned string is converted to Unicode
        SoundBuffer = StrConv(LoadResData(ResourceId + 4000, "SPO_SOUND"), vbUnicode)
    bSPO = True
        FrmMainWnd.SPOTimer.Enabled = True
        DoEvents
        ret = sndPlaySound(SoundBuffer, IIf(SYNC, SND_SYNC, SND_ASYNC) Or SND_NODEFAULT Or SND_MEMORY)
        ' Important: This function is neccessary for playing sound asynchronously
        DoEvents

End Sub
