Attribute VB_Name = "ModZXUtil"
' *******************************************************************************
' VB81 XuR
' ModZXUTIL.BAS - Added by XavSnap. (2007)
' *******************************************************************************

Sub Enum_REM_in_Mem(CmbBox As Control)

'// Declaration
Dim Offset As Long
Dim Cur_Line As Long
Dim Cur_Len As Long
Dim Cur_Arm As Long

CmbBox.Clear
CmbBox.AddItem "USER"

' // Scan memory to find REMs
Offset = &H407D

On Error GoTo End_Scan

Do
Cur_Line = (CLng(MEM(Offset)) * 256) + CLng(MEM(Offset + 1))
Cur_Len = peekw(Offset + 2)
Cur_Arm = CLng(MEM(Offset + 4))
If Cur_Arm = 234 Then CmbBox.AddItem Format_DEC(Cur_Line) & " REM: " & Format_DEC(Cur_Len - 2) & " Bytes@" & Hex16(Offset + 5) & "-" & Hex16(Offset + 2 + Cur_Len)
Offset = Offset + Cur_Len + 4
If Offset > 65532 Then Exit Do
Loop Until MEM(Offset) = 118

End_Scan:
'Attics lines numbers (exit)
End Sub


Private Function Hex16(Value As Long) As String
If Value < &H10 Then
   Hex16 = "000" & Hex(Value): Exit Function
ElseIf Value < &H100 Then
   Hex16 = "00" & Hex(Value): Exit Function
ElseIf Value < &H1000 Then
   Hex16 = "0" & Hex(Value): Exit Function
End If
Hex16 = Hex(Value)
End Function

Private Function Format_DEC(number As Long) As String
Dim TmpStr As String, Len_STR As Integer
TmpStr = Trim(Str(number))
Len_STR = Len(TmpStr)

If Len_STR = 4 Then
   Format_DEC = " " & TmpStr: Exit Function
ElseIf Len_STR = 3 Then
   Format_DEC = "  " & TmpStr: Exit Function
ElseIf Len_STR = 2 Then
   Format_DEC = "   " & TmpStr: Exit Function
ElseIf Len_STR = 1 Then
   Format_DEC = "    " & TmpStr: Exit Function
ElseIf Len_STR = 0 Then
   Format_DEC = "    0" & TmpStr: Exit Function
End If

Format_DEC = TmpStr

End Function
' Main frame sub-routine
Sub load_D_File(File_Name As String)
   Dim D_FILE As Long
   D_FILE = ((CLng(MEM(16397)) * 256) + CLng(MEM(16396))) + 1
    On Error Resume Next
    If Dir$(File_Name) = "" Then
        MsgBox "Error: Could not find required D_file file '" & File_Name & "'.", vbOKOnly Or vbCritical, "vb81"
        Exit Sub
    End If
    
Load_File_In_Mem File_Name, D_FILE, 791

End Sub
' File exporer frame sub-routine
Sub load_D_File_Exp(File_Name As String, datas() As Byte)

    If Dir$(File_Name) = "" Then
        MsgBox "Error: Could not find required D_file file '" & File_Name & "'.", vbOKOnly Or vbCritical, "vb81"
        Exit Sub
    End If
    
Dim ln As Long
Dim hFile As Integer

hFile = FreeFile
On Error GoTo exit_sub
     Open File_Name For Binary Access Read Lock Read As #hFile
         ln = LOF(hFile)
         Get #hFile, 1, datas
    Close #hFile
      
    Exit Sub
exit_sub:
    On Error Resume Next
    Close #hFile


End Sub
'Main frame sub-routine.
Sub load_D_File_fromPfiles(File_Name As String)
   
    On Error Resume Next
    If Dir$(File_Name) = "" Then
        MsgBox "Error: Could not find required P file '" & File_Name & "'.", vbOKOnly Or vbCritical, "vb81"
        Exit Sub
    End If
    
Dim m_iLen, m_iFile, P_header As P_header
Dim a, File_matrix As String
Dim V_tag As Byte
Dim H_V_tag As String * 2
Dim Add_D_File
Dim Cut_Data As String * 32
Dim Cut_Data_34 As String * 34
Dim End_Screen As String * 4
Dim Tmp_D_File(0 To 792) As Byte

On Error GoTo IO_Error

m_iFile = FreeFile

   '//   Load P file.
    
      Open File_Name For Binary Access Read Lock Write As #m_iFile
       Get #m_iFile, 1, P_header
      Add_D_File = (UinttoS(P_header.D_FILE) - 16509) + 117
       
' // Check D_file integrity. (START)
 Get #m_iFile, Add_D_File - 1, H_V_tag
       If H_V_tag <> Chr(118) & Chr(118) Then
       'Unable to find the end of Basic memory Bloc.
        MsgBox "D_file Address corrut !", vbExclamation, "P file corrupt !"
        Exit Sub
       End If
       
' // Check D_file integrity. (CONTENT)
   Dim Scan_Rc_offset
   Scan_Rc_offset = Add_D_File
   
   For a = 0 To 24
   Get #m_iFile, Scan_Rc_offset + (33 * a), V_tag
       If V_tag <> 118 Then
       'End of D_file not tagged.
        MsgBox "Illegal D_file lenght, End tag not found !", vbExclamation, "P file corrupt !"
       Exit Sub
       End If
   Debug.Print V_tag; ":"; Scan_Rc_offset + (33 * a)
   Next a
   
   '// get D_file !
   Get #m_iFile, (UinttoS(P_header.D_FILE) - 16509) + 118, Tmp_D_File
   
   Close #m_iFile
      
Debug.Print "D_FILE :"; (UinttoS(P_header.D_FILE) - 16509) + 117

' // Copy D_File in Zx81/timex 1000 memory bloc.
   Dim D_FILE As Long
   D_FILE = ((CLng(MEM(16397)) * 256) + CLng(MEM(16396))) + 1

CopyMemory MEM(D_FILE), Tmp_D_File(0), 791

 Exit Sub
 
IO_Error:
        MsgBox "File access error.", vbExclamation, "I/O error !"


End Sub
' File explorer sub-routine
Sub load_D_File_fromPfiles_Exp(File_Name As String, datas() As Byte)
   
    On Error Resume Next
    If Dir$(File_Name) = "" Then
        MsgBox "Error: Could not find required P file '" & File_Name & "'.", vbOKOnly Or vbCritical, "vb81"
        Exit Sub
    End If
    
Dim m_iLen, m_iFile, P_header As P_header
Dim a, File_matrix As String
Dim V_tag As Byte
Dim H_V_tag As String * 2
Dim Add_D_File
Dim End_Screen As String * 4


On Error GoTo IO_Error

m_iFile = FreeFile

   '//   Load P file.
    
      Open File_Name For Binary Access Read Lock Write As #m_iFile
       Get #m_iFile, 1, P_header
      Add_D_File = (UinttoS(P_header.D_FILE) - 16509) + 117
       
' // Check D_file integrity. (START)
 Get #m_iFile, Add_D_File - 1, H_V_tag
       If H_V_tag <> Chr(118) & Chr(118) Then
       'Unable to find the end of Basic memory Bloc.
        MsgBox "D_file Address corrut !", vbExclamation, "P file corrupt !"
        Close #m_iFile
        Exit Sub
       End If
       
' // Check D_file integrity. (CONTENT)
   
   For a = 0 To 24
   Get #m_iFile, Add_D_File + (33 * a), V_tag
       If V_tag <> 118 Then
       'End of D_file not tagged.
        MsgBox "Illegal D_file lenght, End tag not found !", vbExclamation, "P file corrupt !"
       Close #m_iFile
       Exit Sub
       End If
   Next a
   
   '// get D_file !
   Get #m_iFile, (UinttoS(P_header.D_FILE) - 16509) + 118, datas
   
   Close #m_iFile
      
 Exit Sub
 
IO_Error:
        MsgBox "File access error.", vbExclamation, "I/O error !"
        On Error Resume Next
Close #m_iFile

End Sub
Sub Save_D_File(File_Name As String)

Dim Tmp_D_File(0 To 790) As Byte
Dim ln As Long
Dim hFile As Integer

   Dim D_FILE As Long
   D_FILE = ((CLng(MEM(16397)) * 256) + CLng(MEM(16396))) + 1


 'Copy D_FILE
CopyMemory Tmp_D_File(0), MEM(D_FILE), 793

hFile = FreeFile
On Error GoTo err_1
     Open File_Name For Binary Access Write Lock Write As #hFile
     Put #hFile, 1, Tmp_D_File
    Close #hFile
    
err_1:
On Error Resume Next
Close #hFile
End Sub

Sub save_DFile2file(File_Name As String, datas() As Byte)
' criture de l'OFFset 122  870. (34x22=748)
Dim m_iLen, m_iFile, P_header As P_header
Dim a, File_matrix As String  'data() As Byte,
Dim V_tag As Byte
Dim H_V_tag As String * 2
Dim Add_D_File As Long
Dim End_Screen As String * 4


On Error GoTo Erreur_Fichier

m_iFile = FreeFile
      
Open File_Name For Binary Access Read Lock Write As #m_iFile
 Get #m_iFile, 1, P_header
 Add_D_File = (UinttoS(P_header.D_FILE) - 16509) + 117
       
' Verification de l'intgrit du fichier.
 Get #m_iFile, Add_D_File - 1, H_V_tag
       If H_V_tag <> Chr(118) & Chr(118) Then
       'Le D_file ne trouve pas la fin de la partie Basic dans le fichier
        MsgBox "Corrupt display memory segment !", vbExclamation, "Corrupted P file structure !"
        Close #m_iFile
        Exit Sub
       End If
       
 ' Verification de la rservation du D_file dans le fichier.
   Dim Scan_Rc_offset
   Scan_Rc_offset = Add_D_File
   
   For a = 0 To 24
   Get #m_iFile, Scan_Rc_offset + (33 * a), V_tag
       If V_tag <> 118 Then
       'Le D_file ne trouve pas la fin de la partie Basic dans le fichier
        MsgBox "Display memory segment not found!" & vbCrLf & "Perhaps, a 1kb file or a compressed D_file segment.", vbExclamation, "Corrupted P file structure !"
       Close #m_iFile
       Exit Sub
       End If
   Next a
   
      Close #m_iFile
      
' Ready to Save the DFile!
m_iFile = FreeFile
      
Open File_Name For Binary Access Write Lock Write As #m_iFile
m_iLen = LOF(m_iFile)
' 32 colonnes x24
Put #m_iFile, Add_D_File + 1, datas
Close #m_iFile
 
 Exit Sub
Erreur_Fichier:
        MsgBox "Erreur d'accs au fichier.", vbExclamation, "Fichier .P corrompu !"
        On Error Resume Next
Close #m_iFile
End Sub
Sub Clr_D_File()

   Dim D_FILE As Long
   D_FILE = ((CLng(MEM(16397)) * 256) + CLng(MEM(16396))) + 1


 'CLS D_FILE
CopyMemory MEM(D_FILE), D_FileCLR(0), 793

End Sub

Sub Save_memory(File_Name As String, Offset As Long, lenght As Long)

Dim Tmp_byte() As Byte
Dim ln As Long
Dim hFile As Integer

ReDim Tmp_byte(0 To lenght - 1)
CopyMemory Tmp_byte(0), MEM(Offset), lenght

hFile = FreeFile
On Error GoTo err_1
     Open File_Name For Binary Access Write Lock Write As #hFile
     Put #hFile, 1, Tmp_byte
    Close #hFile
    
err_1:
Close #hFile
End Sub

Function GetMemName() As String
On Error Resume Next

'Scan basic programme to find the SAVE"" name.
Dim Sca_off As Long
Dim Line_S As Integer
Dim Str_Tmp As String
Dim cmp As Long

Sca_off = peekw(&H4029) - 2
If Sca_off > 2 Then
Do While Sca_off > 0
If peekb(Sca_off) = &H76 Then Exit Do Else Sca_off = Sca_off - 1
Loop
If peekb(Sca_off + 5) = &HF8 Or peekb(Sca_off + 5) = &H62 Then
Line_S = peekb(Sca_off + 1) * 256 + peekb(Sca_off + 2)
For a = Sca_off + 7 To peekw(&H4029) - 3
If MEM(a) <> 11 Then Str_Tmp = Str_Tmp + ZXCharToASCII(MEM(a), False)
Str_Tmp = Trim(Str_Tmp)
Next
GetMemName = " SAVE" & Chr(34) & Str_Tmp & Chr(34) & " Line " & Trim(val(Line_S))
If peekb(Sca_off + 5) = &H62 Then GetMemName = GetMemName & "(Xtender)"
Exit Function
End If
End If
GetMemName = ""

If MEM(&H403F) <> 0 Then
For a = &H403F To &H405B
If MEM(a) = 0 Then Exit For
GetMemName = GetMemName + ZXCharToASCII(MEM(a), False)
GetMemName = Trim(GetMemName)
Next
Else

cmp = &H407F

' // Empty basic memory segment => D_File
If MEM(cmp - 2) = &H76 Then GetMemName = " Empty Basic Segment.": Exit Function

Do
If cmp + 4 >= UBound(MEM) Then Exit Function
If MEM(cmp + 2) = &HF8 And MEM(cmp + 3) = &HB Then
Str_Tmp = " Line " & (MEM(cmp - 1) + (MEM(cmp - 2) * 256))
cmp = cmp + 4
Exit Do
End If
cmp = cmp + peekw(cmp) + 4
If cmp > SRamLim Then Exit Function
If (MEM(cmp - 3) = &H76 And MEM(cmp - 2) = &H76) Then Exit Function
Loop



GetMemName = ""
Do
GetMemName = GetMemName + ZXCharToASCII(MEM(cmp), False)
cmp = cmp + 1
Loop Until MEM(cmp) = &HB

GetMemName = " SAVE" & Chr(34) & GetMemName & Chr(34) & Str_Tmp
End If
'end select
End Function


Function get_memoVar() As Long


Dim retLngZX As Double


Vars_Offset = peekw(&H4010)
E_Line = peekw(&H4014)
Tmp_Str = ""

DoEvents

Do While Vars_Offset < E_Line
    Scan_VARs = MEM(Vars_Offset)
    Vars_Offset = Vars_Offset + 1

    ' Null char test!
    If Scan_VARs = 128 Then Exit Do
    
    Buff_VARs = Buff_VARs + ZXCharToASCII(Scan_VARs And 63 Or 32)
    Tmp_Str = Tmp_Str + ZXCharToASCII(Scan_VARs And 63 Or 32)


    l0062 = Scan_VARs And 224
    
    If Scan_VARs = 32 Then
    l007A = l007A + 1
    End If
    
 If l0062 = 96 Then
    If Tmp_Str = "V" Then
        l007E$ = Chr(MEM(Vars_Offset)) + Chr(MEM(Vars_Offset + 1)) + Chr(MEM(Vars_Offset + 2)) + Chr(MEM(Vars_Offset + 3)) + Chr(MEM(Vars_Offset + 4)) 'Mid$(l0046$, Vars_Offset, 5)
        If l007E$ = String$(5, Chr$(0)) Then
            l0080 = 0
            Else
                l0084 = Asc(Left$(l007E$, 1)) - 128
                l007E$ = Right$(l007E$, 4)
                l0088$ = ""
                For l0068 = 1 To 4
                    l008A = Asc(Mid$(l007E$, l0068, 1))
                    For l008E = 7 To 0 Step -1
                        If l008A And (2 ^ l008E) Then
                            l0088$ = l0088$ + "1"
                        Else: l0088$ = l0088$ + "0"
                        End If
                    Next l008E
                Next l0068
        End If
        
        l0092$ = Chr(MEM(Vars_Offset)) + Chr(MEM(Vars_Offset + 1)) + Chr(MEM(Vars_Offset + 2)) + Chr(MEM(Vars_Offset + 3)) + Chr(MEM(Vars_Offset + 4)) 'Mid$(l0046$, Vars_Offset, 5)
        Call FrmMainWnd.DecodeLngZX(l0092$, retLngZX)
        get_memoVar = retLngZX
         Tmp_Str = ""
        Vars_Offset = Vars_Offset + 5
  End If
 
 End If
Tmp_Str = ""
Loop

L2B30:

End Function
Function ReSet_memoVar() As Boolean

'Dim l0042 As Variant
'Dim l0046 As String
'Dim l0048 As String

'Dim l004E As Variant
'Dim l0052 As Variant

'Dim Scan_VARs As Byte
'Dim STR_Width As Long
'Dim l0062 As Variant
'Dim l0066 As String
'Dim l0068 As Variant
'Dim l006C As String
'Dim l0078 As String
'Dim l007A As Variant
'Dim l007E As String
'Dim l0080 As Variant
'Dim l0084 As Variant
'Dim l0088 As String
'Dim l008A As Variant
'Dim l008E As Variant
'Dim l0092 As String
'Dim retLngZX As Variant
'Dim l0098 As Variant
'Dim Vars_Offset As Long
'Dim Buff_VARs As String
'Dim E_Line As Long
'Dim tmp_str As String ' // local Temporary buffer for the ListView
'Dim Tmp_Cmp As Integer
'Dim Tmp_Cmp2 As Integer
'Dim Tmp_Array As String
'Dim a As Integer

Vars_Offset = peekw(&H4010)
E_Line = peekw(&H4014)

 ReSet_memoVar = False
 
DoEvents

Tmp_Str = ""

Do While Vars_Offset < E_Line
    Scan_VARs = MEM(Vars_Offset)
    Vars_Offset = Vars_Offset + 1
    
    ' Null char test!
    If Scan_VARs = 128 Then Exit Do
    
    Buff_VARs = Buff_VARs + ZXCharToASCII(Scan_VARs And 63 Or 32)
    Tmp_Str = Tmp_Str + ZXCharToASCII(Scan_VARs And 63 Or 32)


    l0062 = Scan_VARs And 224
    
    If Scan_VARs = 32 Then
    l007A = l007A + 1
    End If
    
 If l0062 = 96 Then
    If Tmp_Str = "V" Then
        MEM(Vars_Offset) = 0
        MEM(Vars_Offset + 1) = 0
        MEM(Vars_Offset + 2) = 0
        MEM(Vars_Offset + 3) = 0
        MEM(Vars_Offset + 4) = 0
        Tmp_Str = ""
        ReSet_memoVar = True
        Vars_Offset = Vars_Offset + 5
  End If
 End If
Loop

L2B30:

End Function

' Memotech HRG sub-Runtimes.

Sub Memo_refresh(Memoffset As Long)
If Memoffset < 0 Then Exit Sub
Dim Offset As Long, offset2 As Long, glOffset As Integer
glOffset = 0

For Offset = Memoffset + 1 To Memoffset + 6336 Step 33
CopyMemory gcBufferBits(glOffset), MEM(Offset), 33
glOffset = glOffset + 32
Next Offset

End Sub

' Memotech page inversion.
Sub InvertHrgMemo(Memoffset As Long)

Dim Offset As Long, offset2 As Long, glOffset As Integer
glOffset = 0
Memoffset = Memoffset + 33
For Offset = Memoffset + 1 To Memoffset + 6336 Step 33
For a = 0 To 32
 MEM(Offset + a) = MEM(Offset + a) Xor &HFF
Next
glOffset = glOffset + 32
Next Offset


'For a = 0 To 6528
'gcBufferBits(a) = gcBufferBits(a) Xor &HFF
'Next
End Sub

' Memotech page inversion.
Sub InvertScreen()
Dim a As Integer
For a = 0 To UBound(gcBufferBits) - 1
gcBufferBits(a) = gcBufferBits(a) Xor &HFF
Next
End Sub

' G007 HRG sub-Runtimes.

Sub G007_refresh(G007_Offset As Long)

If Memoffset < 0 Then Exit Sub
Dim Offset As Long, offset2 As Long, glOffset As Integer
glOffset = 0

For Offset = G007_Offset To G007_Offset + 6528 Step 34
CopyMemory gcBufferBits(glOffset), MEM(Offset), 32
glOffset = glOffset + 32
Next Offset

End Sub

' WRX HRG sub-Runtimes.

Sub WRX_refresh() 'WRX_Offset As Long

'If Memoffset < 0 Then Exit Sub
Dim Offset As Long, offset2 As Long, glOffset As Integer
Offset = (intI * 256) + intR
glOffset = 0 ' ((intI * 256) + intR)
'For Offset = WRX_Offset To WRX_Offset + 6528 Step 34
CopyMemory gcBufferBits(glOffset), MEM(Offset), 32
'glOffset = glOffset + 32
'Next Offset

End Sub

' Memotech tool, to fill S$ with BMP picture.
Sub Load_BMP2S(Filename As String, S_Offset As Long)
Dim Cnt As Long
Dim hFile As Integer
'Dim buffer(0 To 5951 + 32) As Byte

Dim buffer(0 To 6142) As Byte
Dim Revbuffer(0 To 6142) As Byte

Dim RevCNT As Long

'dim de 6337b (5952-6337)=385b de controls

hFile = FreeFile
'On Error GoTo exit_sub
     Open Filename For Binary Access Read Lock Read As #hFile
         Get #hFile, 63, buffer
    Close #hFile
    
' Apply a Xor
RevCNT = 0
Do While RevCNT <= UBound(buffer)
buffer(RevCNT) = buffer(RevCNT) Xor &HFF
RevCNT = RevCNT + 1
Loop

'Reverse lines ( 1 line = 31 bytes = 248 pixel)
RevCNT = 0
t = UBound(buffer) - 30
Do
CopyMemory Revbuffer(RevCNT), buffer(t), 32
RevCNT = RevCNT + 32
t = t - 32
Loop While t >= 0

    
S_Offset = S_Offset + 5
    
    For Cnt = 0 To 6142 Step 32
    MEM(S_Offset) = &H76
    MEM(S_Offset + 1) = &H0
    CopyMemory MEM(S_Offset + 2), Revbuffer(Cnt), 31
    S_Offset = S_Offset + 33
    Next Cnt
    MEM(S_Offset) = &H76
    Exit Sub
exit_sub:

    Close #hFile
End Sub

Function Scan_S_String() As Long

Dim retLngZX As Long

Vars_Offset = peekw(&H4010)
E_Line = peekw(&H4014)
Tmp_Str = ""

On Error GoTo err_scan

Scan_S_String = False


Do While Vars_Offset < E_Line
    Scan_VARs = MEM(Vars_Offset)
    Vars_Offset = Vars_Offset + 1

    ' Null char test!
    If Scan_VARs = 128 Then Exit Do
    
    Buff_VARs = Buff_VARs + ZXCharToASCII(Scan_VARs And 63 Or 32)
    Tmp_Str = Tmp_Str + ZXCharToASCII(Scan_VARs And 63 Or 32)


    l0062 = Scan_VARs And 224
    
    If Scan_VARs = 32 Then
    l007A = l007A + 1
    End If
    
 If l0062 = 192 Then
    If Tmp_Str = "S" Then
    Scan_S_String = Vars_Offset
    End If
    Tmp_Str = ""
    Vars_Offset = Vars_Offset + 5
   
 End If
Tmp_Str = ""
Loop
Exit Function
'L2B30:
err_scan:
Scan_S_String = False
End Function

' ZX-Tricator HRG sub-Runtimes.

Sub ZxTric_refresh(Memoffset As Long)
If Memoffset < 0 Then Exit Sub
Dim Offset As Long, offset2 As Long, glOffset As Integer
glOffset = 0

For Offset = Memoffset + 3 To Memoffset + 6765 Step 35
CopyMemory gcBufferBits(glOffset), MEM(Offset), 32
glOffset = glOffset + 32
Next Offset

End Sub

Function Round(number As Double) As Double
Round = Int((number * 10 ^ 7)) / 10 ^ 7
End Function

'//
'// Get the real ZX81 NAME:
'// Search the SAVE"xxx" line in the Basic programme and return the name.

Function GetZXName(File_Name As String) As String
'// Load P File.
Dim ln As Long
Dim hFile As Integer
Dim CRC32 As String
Dim buffer2() As Byte
Dim D_FILE As Long
Dim Bas_Start As Long
Dim err As Long

If Not FileExists(File_Name, err) Then Exit Function

hFile = FreeFile
'On Error GoTo exit_sub
On Error GoTo 0
 Open File_Name For Binary Access Read Lock Read As #hFile

         ln = LOF(hFile)
         If ln = 0 Or ln > 65536 Then GoTo exit_sub
         ReDim buffer(0 To ln - 1) As Byte
         Get #hFile, , buffer
         
 Close #hFile
 

 D_FILE = GetW(3, buffer) - &H4009 ' Offset 400Ch
 If D_FILE > 65536 Or D_FILE < 0 Or D_FILE > ln Then GoTo exit_sub
 
 'Retrieve then Basic CRC.
' Bas_Start = 122 ' Offset 40D7h
'If D_File - Bas_Start < 0 Then GoTo exit_sub
' ReDim buffer2(0 To D_File - Bas_Start) As Byte
' CopyMemory buffer2(0), buffer(122), D_File - Bas_Start + 1
  
' Ignored in VB XuR !
'
'CRC32 = Hex(Get_CRC32_ARR(buffer2))
'If Len(CRC32) < 8 Then
'CRC32 = CRC_LEN(CRC32)
'End If

 
' ??? Yu've got an Apple directory name on your hard disk ???
If InStr(1, File_Name, ".", vbBinaryCompare) = 0 Then File_Name = File_Name + ".###"

Dim Sca_off As Long
Dim Str_Tmp As String
Dim Cnt As Long

'Get Next_Line Offset
Sca_off = GetW(&H20, buffer) - &H4007
If Sca_off >= ln Then GoTo exit_sub
'
'Scan the basic program to find the SAVE"" name.
'using the auto-loder (NXT-LINE) pointer.

If Sca_off > 2 Then
   'Find the Ret char. code &h76 to locate the start address.
   Do While Sca_off > 0
     If buffer(Sca_off) = &H76 Or Sca_off = &H73 Then Exit Do Else Sca_off = Sca_off - 1
   Loop
   'Ok ... &hF8=SAVE basic function. &h62=Anything.
   On Error GoTo 0
        If buffer(Sca_off + 5) = &HF8 Or buffer(Sca_off + 5) = &H62 Then
        
        '// Saved With a variable! (the Name is in the vars ... Bhaaa! Basta...)
        If buffer(Sca_off + 6) <> &HB Then
        GetZXName = Left(UCase(Cut_Name(File_Name)), InStr(1, Cut_Name(File_Name), ".", vbBinaryCompare) - 1)
        Exit Function
        '// Unlucky ...
        End If
        
        ' Get name string...
        Str_Tmp = ""
        For a = Sca_off + 7 To GetW(&H20, buffer) - &H4006
        Str_Tmp = Str_Tmp + ZXCharToASCII(buffer(a), False)
        Next
        
        If Str_Tmp = "" Or Len(Str_Tmp) > 25 Then GoTo Force_Scan
        
        'Cut and retieve the ZX file name.
        GetZXName = Str_Tmp ' & ".P"
        
        ' Haaarg! A SAVE"SAVE:P:NAME:" from Xtender ... later versions!
        ' MAGIC couic , couic ...
        If buffer(Sca_off + 5) = &H62 Then
        GetZXName = Right(Str_Tmp, Len(Str_Tmp) - (InStr(1, Str_Tmp, "P") + 1))
        GetZXName = Left(GetZXName, Len(GetZXName) - 1) ' & ".P"
        ' Tadaaaa !
        ' Thanks every body! Thanks!
        End If
        
        Exit Function
        End If
        
End If

Force_Scan:

'
' Now try to Scan the old Xtender backup (available in ROM address):
' Print rand usr 8192;"Save:p:..."
'
For Sca_off = &H73 To UBound(buffer) - 12
If buffer(Sca_off) = &H38 And buffer(Sca_off + 1) = &H26 And _
buffer(Sca_off + 2) = &H3B And buffer(Sca_off + 5) = &H35 Then Exit For
Next

If Sca_off = UBound(buffer) - 11 Then GoTo Force_Scan2

Str_Tmp = ""
Sca_off = Sca_off + 7
If Sca_off >= UBound(buffer) Then Exit Function
Do While buffer(Sca_off) <> &HB
Str_Tmp = Str_Tmp + ZXCharToASCII(buffer(Sca_off), False)
If Sca_off = ln - 1 Then Exit Do
Sca_off = Sca_off + 1
Loop

GetZXName = Left(Str_Tmp, Len(Str_Tmp) - 1) ' + ".P"
Exit Function

Force_Scan2:

' //
' // Force Basic Reading.
' //

'Deep Scan NXT_Line = D_file (Saved under basic Prompt).
'a Save"GAME" exist in the back-up ... Somewhere...
'It will scan all of this (@!$$$##&)  file!

If GetZXName = "" Then
For Sca_off = &H73 To UBound(buffer) - 6
If buffer(Sca_off) = 0 And buffer(Sca_off + 1) = &HF8 And buffer(Sca_off + 2) = &HB Then Exit For
Next
If Sca_off = UBound(buffer) + 5 Then GoTo Force_Scan3
Str_Tmp = ""
Sca_off = Sca_off + 3

Do While buffer(Sca_off) <> &HB
Str_Tmp = Str_Tmp + ZXCharToASCII(buffer(Sca_off), False)
If Sca_off = ln - 1 Then Exit Do
Sca_off = Sca_off + 1
Loop

    If Str_Tmp <> "" And Len(Str_Tmp) < 25 And InStr(1, Str_Tmp, "_") = 0 Then
    GetZXName = Str_Tmp ' + ".P"
    Exit Function
    End If
End If

Force_Scan3:
Str_Tmp = ""

'Last TesT...
'The name is in the printer buffer??? (old emulators)
GetZXName = ""
For a = &H36 To &H52
GetZXName = GetZXName + ZXCharToASCII(buffer(a), False)
Next
GetZXName = Trim(GetZXName)

' Nothing ... "SUPER MEGA COMBO HIT of the death! You Loose!" ... Nada!

If InStr(1, GetZXName, "_") > 0 Or GetZXName = "" Then
GetZXName = Left(UCase(Cut_Name(File_Name)), InStr(1, Cut_Name(File_Name), ".", vbBinaryCompare) - 1)
End If


ReDim buffer(0)
'end select
Exit Function

exit_sub:
Close #hFile
End Function

Public Function GetW(Offset As Long, buffer() As Byte) As Long
If Offset >= UBound(buffer) Then GetW = 0: Exit Function
    GetW = buffer(Offset) Or (buffer(Offset + 1) * 256&)
End Function

Sub Put_PRN_Buffer(Filename As String, Mytext As String)
Dim BytesBuffer(31) As Byte
Dim Cnt As Integer, hFilep As Integer

For Cnt = 0 To 31
BytesBuffer(Cnt) = ASCIICharToZX(Left(Mytext, 1))
If Len(Mytext) = 1 Then Cnt = Cnt + 1: Exit For
Mytext = Right(Mytext, Len(Mytext) - 1)
Next
If Cnt < 31 Then
For Cnt2 = Cnt To 31
BytesBuffer(Cnt2) = 0
Next
End If
hFilep = FreeFile
Open Filename For Binary Access Write Lock Write As #hFilep
     Put #hFilep, 52, BytesBuffer
Close #hFilep

End Sub

Sub Init_SyS_VARS(SYSVARS As SYSVARS, ZxOffset As Long)

' Init System variables.
    DFiles = (ZxOffset) + &H407D ' Address of D_FILE
   
    ' E_PPC    - Line number of line which has the edit cursor.
    SYSVARS.E_PPC = 0

    ' D_FILE   - Address of display file
    SYSVARS.D_FILE = DFiles
        
    ' DF_CC    - Address of print position in display file
    SYSVARS.DF_CC = DFiles
    
    DFiles = DFiles + 793 ' = Address of VARS area.
    
    ' VARS     - Address of program variables
    SYSVARS.VARS = DFiles

    ' E_LINE   - Pointer to line edit buffer
    SYSVARS.E_Line = DFiles
    
    ' CH_ADD   - Address of the next character to be interpreted
    SYSVARS.CH_ADD = DFiles
    
    ' STKBOT   - Points to the bottom of the calculator stack AND...
    SYSVARS.STKBOT = DFiles
    
    ' STKEND   - Points to the end of the calculator stack
    SYSVARS.STKEND = DFiles

    ' MEM      - Address of area used for calculator's memory (we point this at MEMBOT 0x405D */
    SYSVARS.MEM = &H405D
    
    ' DF_SZ       - Number of lines (including 1 blank line) in lower part of the screen */
    SYSVARS.DF_SZ = 2
    
    ' LAST_K      - Shows which keys are pressed
    SYSVARS.LAST_K = &HFFFF
    
    ' DEBOUNCE    - Debounce status of keyboard
    SYSVARS.DEBOUNCE = &HF
    
    ' MARGIN      - Number of scanlines before start of display (55=PAL, 31=NTSC)
    SYSVARS.MARGIN = 55
    
    ' NXTLINE  - Address of next program line to be executed
    SYSVARS.Nxt_line = SYSVARS.E_PPC
    
    ' T_ADDR      - Address of next item in syntax table
    SYSVARS.T_ADDR = &HC6B
    
    ' FRAMES      - Seed for random number generation. Set by RAND
    SYSVARS.FRAMES = &HFD7D
    
    ' PR_CC       - Least significant byte of address of next position for LPRINT to print
    SYSVARS.PR_CC = &HBC
    
    ' S_POSN x    - Column number for print position
    ' S_POSN y    - Row number for print position
    SYSVARS.S_POSN = &H1821
    
    ' CDFLAG      - Various flags. Bit 7 is set during SLOW mode, Bit 6 is the true fast/slow flag
    SYSVARS.CDFLAG = &H40
    
    ' PRBUF      - Printer buffer (33 bytes, 33rd is NEWLINE)
    SYSVARS.PRBUFEND = 118
End Sub
 
Function dbl2zx81(Num As Double) As Zx81_Long
 
' * Converts a double to an inline-basic-style ZX81 floating point number.
' *
' * IN:      num  - Number to convert (dbl)
' * OUT:     &exp - Exponent (integer)
' * OUT:     &man - Mantissa (char)
' *
' Avec l'aide de Whismeril
' sur le forum https://codes-sources.commentcamarche.net/forum

Dim IntNum As Double
Dim tmpint1 As Double
Dim tmpint2 As Double
Dim TmpVal As String
Dim Expon As Double

'    /* Special case for zero */
    If Num = 0 Then
    dbl2zx81.Exp = 0#
    dbl2zx81.man = 0#
     Exit Function
    End If
    

    
'    /* If negative work with the absolute value */
Num = Abs(Num)

dbl2zx81.Exp = Int(Log(Num) / Log(2))


If dbl2zx81.Exp < -128 Or dbl2zx81.Exp > 127 Then Exit Function

IntNum = ((Num / (2# ^ (dbl2zx81.Exp + Expon#))) * 2147483648#)

' 65536=&h10000
' 32767=&h7FFF


tmpint2 = IntNum - (Int(IntNum / 65536#) * 65536#)

tmpint1 = Int(IntNum / 65536#) And 32767#

If tmpint2 < 0 Then tmpint2 = 0

TmpVal = Hex16(UnsignedToLong(tmpint1)) & Hex16(UnsignedToLong(tmpint2))
    
    dbl2zx81.man = TmpVal
    dbl2zx81.Exp = dbl2zx81.Exp + 129#
    Exit Function

Dbl_ERR:
    Disp_Err 11, Str(Num)
End Function
Public Function ZXCharToASCII(ByVal cZX As Byte, Optional Func As Boolean = True, Optional ASM As Boolean = False) As String
' Convert ZX characters codes to PC Codes.
' Zx81 Memory to Pc Display.

' func =>
    If (cZX > 127 And cZX < 192) Then cZX = cZX And 63
     

 
    Select Case cZX
    Case 0 ' // SPACE
        ZXCharToASCII = " "
    Case 11
        ' 11 = 34   "
        ZXCharToASCII = Chr(34)
    Case 12
        ' 12 = 35  /#
        ZXCharToASCII = ""
    Case 13
        ' 13 = 36  $
        ZXCharToASCII = "$"
    Case 14
        ' 14 = :
        ZXCharToASCII = ":"
    Case 15
        ' 15 = ?
        ZXCharToASCII = "?"
    Case 16
        ' 16 = (
        ZXCharToASCII = "("
    Case 17
        ' 17 = )
        ZXCharToASCII = ")"
    Case 18
        ' 18 = >
        ZXCharToASCII = ">"
    Case 19
        ' 19 = <
        ZXCharToASCII = "<"
    Case 20
        ' 20 = =
        ZXCharToASCII = "="
    Case 21
        ' 21 = +
        ZXCharToASCII = "+"
    Case 22
        ' 22 = -
        ZXCharToASCII = "-"
    Case 23
        ' 23 = *
        ZXCharToASCII = "*"
    Case 24
        ' 24 = /
        ZXCharToASCII = "/"
    Case 25
        ' 25 = ;
        ZXCharToASCII = ";"
    Case 26
         ' 26 = ,
        ZXCharToASCII = ","
    Case 27
        ' 27 = .
        ZXCharToASCII = "."
    Case 28 To 37
        ZXCharToASCII = Chr$(cZX + 20)
    Case 38 To 63
        ZXCharToASCII = Chr$(cZX + 27)
    Case 82, 2
        If ASM Then ZXCharToASCII = "@" Else ZXCharToASCII = "_"
    Case 118
        If Not Func Then
        ZXCharToASCII = "_"
        Else
        If Not ASM Then ZXCharToASCII = "N/L" Else ZXCharToASCII = vbCrLf & vbTab
        End If
    Case 192 And Func
        ' 192 = "''"
        ZXCharToASCII = Chr$(34)
    Case 195 And Func
        ' 195 = "?"
        ZXCharToASCII = "?"
     Case 216 And Func
        ' 216 = "**"
        ZXCharToASCII = "**"
    Case 219 And Func
        ' 219 = "<="
        ZXCharToASCII = "<="
     Case 220 And Func
        ' 220 = ">="
        ZXCharToASCII = ">="
     Case 221 And Func
        ' 221 = "<>"
        ZXCharToASCII = "<>"
    Case Else
        ZXCharToASCII = "_"
    End Select
End Function


Public Function ASCIICharToZX(ByVal cZX As String, Optional Func As Boolean = True, Optional bCase As Boolean = False) As Byte
    If cZX = "" Or cZX = Chr(224) Or cZX = Chr(255) Then ASCIICharToZX = 143: Exit Function
    
' Convert PC Codes to ZX characters codes.
'  Pc Display to Zx81 Memory.
    
    Dim cZX_Asc As Byte
    cZX_Asc = Asc(cZX)
    
    Select Case cZX_Asc
    Case &H30 To &H39
        ASCIICharToZX = cZX_Asc - 20: Exit Function
        
    Case &H41 To &H5A
        ASCIICharToZX = cZX_Asc - 27: Exit Function
        
    Case &H61 To &H7A
        ASCIICharToZX = cZX_Asc + 69: Exit Function
        
    Case Asc(&HD) ' , Asc(&HA)  '"N/L" vbCrLf
        ASCIICharToZX = 118: Exit Function

    Case Asc(" ") ' // SPACE
        ASCIICharToZX = 0: Exit Function
    Case 34 To 36
        ' 11 = 34   "
        ' 12 = 35  /#
        ' 13 = 36  $
        ASCIICharToZX = cZX_Asc - 23: Exit Function
    Case Asc(":")
        ' 14 = :
        ASCIICharToZX = 14: Exit Function
    Case Asc("?")
        ' 15 = ?
        ASCIICharToZX = 15: Exit Function
    Case Asc("(")
        ' 16 = (
        ASCIICharToZX = 16: Exit Function
    Case Asc(")")
        ' 17 = )
        ASCIICharToZX = 17: Exit Function
    Case Asc(">")
        ' 18 = >
        ASCIICharToZX = 18: Exit Function
    Case Asc("<")
        ' 19 = <
        ASCIICharToZX = 19: Exit Function
    Case Asc("=")
        ' 20 = =
        ASCIICharToZX = 20: Exit Function
    Case Asc("+")
        ' 21 = +
        ASCIICharToZX = 21: Exit Function
    Case Asc("-")
        ' 22 = -
        ASCIICharToZX = 22: Exit Function
    Case Asc("*")
        ' 23 = *
        ASCIICharToZX = 23: Exit Function
    Case Asc("/")
        ' 24 = /
        ASCIICharToZX = 24: Exit Function
    Case Asc(";")
        ' 25 = ;
        ASCIICharToZX = 25: Exit Function
    Case Asc(",")
         ' 26 = ,
        ASCIICharToZX = 26: Exit Function
    Case Asc(".")
        ' 27 = .
        ASCIICharToZX = 27: Exit Function
        
        
  ' ZxDraw ASCII chars.
  
  'Invert chars
  Case &H86 To &HA0
      Debug.Print ZXCharToASCII(cZX_Asc + 5)
  ASCIICharToZX = cZX_Asc + 5: Exit Function
  
  Case &HA3
  ASCIICharToZX = 12: Exit Function
  
  '  "\" + Chr(&H22)+ Chr(&H22)
  Case &HC0
  ASCIICharToZX = 192: Exit Function
  
  '  "\' "
  Case &HB6
  ASCIICharToZX = 1: Exit Function
  
  '  "\ '"
    Case &HB7
  ASCIICharToZX = 2: Exit Function
    
  '  "\''"
   Case &HB8
  ASCIICharToZX = 3: Exit Function

  '  "\. "
  
  Case &HB9
  ASCIICharToZX = 4: Exit Function

  '  "\: "
  Case &HBA
  ASCIICharToZX = 5: Exit Function

  '  "\.'"
  Case &HBB
  ASCIICharToZX = 6: Exit Function

  '  "\:'"
  Case &HBC
  ASCIICharToZX = 7: Exit Function

  '  "\##"
  Case &HBD
  ASCIICharToZX = 8: Exit Function

  '  "\,,"
  Case &HBE
  ASCIICharToZX = 9: Exit Function

  '  "\~~"
  Case &HBF
  ASCIICharToZX = 10: Exit Function

  '  "\::"
  Case &HAB
  ASCIICharToZX = &H80: Exit Function

  '  "\.:"
  Case &HAC
  ASCIICharToZX = &H81: Exit Function

  '  "\:."
  Case &HAD, &HAA
  ASCIICharToZX = &H82: Exit Function

  '  "\.."
  Case &HAE
  ASCIICharToZX = &H83: Exit Function

  '  "\':"
  Case &HAF
  ASCIICharToZX = &H84: Exit Function
  
   '  "\ :"
  Case &HB0
  ASCIICharToZX = &H85: Exit Function

  '  "\'."
  Case &HB1
  ASCIICharToZX = &H86: Exit Function

   '  "\ ."
  Case &HB2
  ASCIICharToZX = &H87: Exit Function

   '  "\@@"
  Case &HB3
  ASCIICharToZX = &H88: Exit Function

  '  "\;;"
  Case &HB4
  ASCIICharToZX = &H89: Exit Function

  '  "\!!"
  Case &HB5
  ASCIICharToZX = &H8A: Exit Function

    Case Else
    
        ' While Ascii scan, don't bother the "[" symbol. (The next Char. scan in variables names)
      If cZX <> "[" And cZX <> "\" And cZX <> "%" Then
      Disp_Err 4
      End If
      ASCIICharToZX = 143
    End Select
End Function
Public Function IsZxChar(MyOffset) As Boolean
On Error GoTo EMPTYARRAY
If UBound(ZXbuffer) = 0 Then GoTo EMPTYARRAY

IsZxChar = False

If MyOffset > UBound(ZXbuffer) Then Exit Function
If (ZXbuffer(MyOffset) > 37 And ZXbuffer(MyOffset) < 64) Or (ZXbuffer(MyOffset) > 165 And ZXbuffer(MyOffset) < 192) Then IsZxChar = True
err.Clear
EMPTYARRAY:

End Function


Public Function IsZXLetter(Mychr As Byte) As Boolean
IsZXLetter = False
On Error Resume Next
If (Mychr > 37 And Mychr < 64) Or (Mychr > 165 And Mychr < 192) Then IsZXLetter = True
End Function

Sub Load_Bmp2VM(Filename As String)

Dim Cnt, a, b, c, t

Cnt = 0

Dim buffer(0 To 6143) As Byte
Dim Revbuffer(0 To 6143) As Byte
Dim RevCNT As Long
 
 m_iFile = FreeFile
 Open Filename For Binary Access Read Lock Write As #m_iFile
 Get #m_iFile, 63, buffer
 Close #m_iFile
 
 
'dim de 6337b (5952-6337)=385b de controls

' Apply a Xor
RevCNT = 0
Do While RevCNT <= UBound(buffer)
buffer(RevCNT) = buffer(RevCNT) Xor 255
RevCNT = RevCNT + 1
Loop

'Reverse lines ( 1 line = 32 bytes = 256 pixel)
RevCNT = 0
t = UBound(buffer) - 31
Do
CopyMemory Revbuffer(RevCNT), buffer(t), 32
RevCNT = RevCNT + 32
t = t - 32
Loop While t >= 0

For Cnt = 0 To 6143:  pokeb 40960 + Cnt, CLng(Revbuffer(Cnt)): Next

EXt:
reset
End Sub

Public Function Zx2ASCII(MemData As Byte) As String
Dim TMP_CHAR

Select Case MemData

'Conversion Ascii ZX vers PC
Case 0
TMP_CHAR = " "
Case 1
TMP_CHAR = Chr(&HB6)
Case 2
TMP_CHAR = Chr(&HB7)
Case 3
TMP_CHAR = Chr(&HB8)
Case 4
TMP_CHAR = Chr(&HB9)
Case 5
TMP_CHAR = Chr(&HBA)
Case 6
TMP_CHAR = Chr(&HBB)
Case 7
TMP_CHAR = Chr(&HBC)
Case 8
TMP_CHAR = Chr(&HBD)
Case 9
TMP_CHAR = Chr(&HBE)
Case 10
TMP_CHAR = Chr(&HBF)
Case 11
TMP_CHAR = Chr(&H22)
Case 12
TMP_CHAR = Chr(&HA3)
Case 13
TMP_CHAR = "$"
Case 14
TMP_CHAR = ":"
Case 15
TMP_CHAR = "?"
Case 16
TMP_CHAR = "("
Case 17
TMP_CHAR = ")"
Case 18
TMP_CHAR = ">"
Case 19
TMP_CHAR = "<"
Case 20
TMP_CHAR = "="
Case 21
TMP_CHAR = "+"
Case 22
TMP_CHAR = "-"
Case 23
TMP_CHAR = "*"
Case 24
TMP_CHAR = "/"
Case 25
TMP_CHAR = ";"
Case 26
TMP_CHAR = ","
Case 27
TMP_CHAR = "."
Case 28
TMP_CHAR = "0"
Case 29
TMP_CHAR = "1"
Case 30
TMP_CHAR = "2"
Case 31
TMP_CHAR = "3"
Case 32
TMP_CHAR = "4"
Case 33
TMP_CHAR = "5"
Case 34
TMP_CHAR = "6"
Case 35
TMP_CHAR = "7"
Case 36
TMP_CHAR = "8"
Case 37
TMP_CHAR = "9"
Case 38
TMP_CHAR = "A"
Case 39
TMP_CHAR = "B"
Case 40
TMP_CHAR = "C"
Case 41
TMP_CHAR = "D"
Case 42
TMP_CHAR = "E"
Case 43
TMP_CHAR = "F"
Case 44
TMP_CHAR = "G"
Case 45
TMP_CHAR = "H"
Case 46
TMP_CHAR = "I"
Case 47
TMP_CHAR = "J"
Case 48
TMP_CHAR = "K"
Case 49
TMP_CHAR = "L"
Case 50
TMP_CHAR = "M"
Case 51
TMP_CHAR = "N"
Case 52
TMP_CHAR = "O"
Case 53
TMP_CHAR = "P"
Case 54
TMP_CHAR = "Q"
Case 55
TMP_CHAR = "R"
Case 56
TMP_CHAR = "S"
Case 57
TMP_CHAR = "T"
Case 58
TMP_CHAR = "U"
Case 59
TMP_CHAR = "V"
Case 60
TMP_CHAR = "W"
Case 61
TMP_CHAR = "X"
Case 62
TMP_CHAR = "Y"
Case 63
TMP_CHAR = "Z"
Case 64
TMP_CHAR = "RND"
Case 65
TMP_CHAR = "INKEY$"
Case 66
TMP_CHAR = "PI"
Case 67 To 127
TMP_CHAR = "?"
Case 128
TMP_CHAR = Chr(&HAB)
Case 129
TMP_CHAR = Chr(&HAC)
Case 130
TMP_CHAR = Chr(&HAA)
Case 131
TMP_CHAR = Chr(&HAE)
Case 132
TMP_CHAR = Chr(&HAF)
Case 133
TMP_CHAR = Chr(&HB0)
Case 134
TMP_CHAR = Chr(&HB1)
Case 135
TMP_CHAR = Chr(&HB2)
Case 136
TMP_CHAR = Chr(&HB3)
Case 137
TMP_CHAR = Chr(&HB4)
Case 138
TMP_CHAR = Chr(&HB5)
Case 139
TMP_CHAR = Chr(&H86)
Case 140
TMP_CHAR = Chr(&H87)
Case 141
TMP_CHAR = Chr(&H88)
Case 142
TMP_CHAR = Chr(&H89)
Case 143
TMP_CHAR = Chr(&H8A)
Case 144
TMP_CHAR = Chr(&H8B)
Case 145
TMP_CHAR = Chr(&H8C)
Case 146
TMP_CHAR = Chr(&H8D)
Case 147
TMP_CHAR = Chr(&H8E)
Case 148
TMP_CHAR = Chr(&H8F)
Case 149
TMP_CHAR = Chr(&H90)
Case 150
TMP_CHAR = Chr(&H91)
Case 151
TMP_CHAR = Chr(&H92)
Case 152
TMP_CHAR = Chr(&H93)
Case 153
TMP_CHAR = Chr(&H94)
Case 154
TMP_CHAR = Chr(143)
Case 155
TMP_CHAR = Chr(150)
Case 156
TMP_CHAR = Chr(151)
Case 157
TMP_CHAR = Chr(152)
Case 158
TMP_CHAR = Chr(153)
Case 159
TMP_CHAR = Chr(154)
Case 160
TMP_CHAR = Chr(155)
Case 161
TMP_CHAR = Chr(156)
Case 162
TMP_CHAR = Chr(157)
Case 163
TMP_CHAR = Chr(158)
Case 164
TMP_CHAR = Chr(159)
Case 165
TMP_CHAR = Chr(160)
Case 166
TMP_CHAR = "a"
Case 167
TMP_CHAR = "b"
Case 168
TMP_CHAR = "c"
Case 169
TMP_CHAR = "d"
Case 170
TMP_CHAR = "e"
Case 171
TMP_CHAR = "f"
Case 172
TMP_CHAR = "g"
Case 173
TMP_CHAR = "h"
Case 174
TMP_CHAR = "i"
Case 175
TMP_CHAR = "j"
Case 176
TMP_CHAR = "k"
Case 177
TMP_CHAR = "l"
Case 178
TMP_CHAR = "m"
Case 179
TMP_CHAR = "n"
Case 180
TMP_CHAR = "o"
Case 181
TMP_CHAR = "p"
Case 182
TMP_CHAR = "q"
Case 183
TMP_CHAR = "r"
Case 184
TMP_CHAR = "s"
Case 185
TMP_CHAR = "t"
Case 186
TMP_CHAR = "u"
Case 187
TMP_CHAR = "v"
Case 188
TMP_CHAR = "w"
Case 189
TMP_CHAR = "x"
Case 190
TMP_CHAR = "y"
Case 191
TMP_CHAR = "z"
Case 192
TMP_CHAR = Chr(&HC0)
Case 193
TMP_CHAR = "AT "
Case 194
TMP_CHAR = "TAB "
Case 195
TMP_CHAR = "?"
Case 196
TMP_CHAR = "CODE "
Case 197
TMP_CHAR = "VAL "
Case 198
TMP_CHAR = "LEN "
Case 199
TMP_CHAR = "SIN "
Case 200
TMP_CHAR = "COS "
Case 201
TMP_CHAR = "TAN "
Case 202
TMP_CHAR = "ASN "
Case 203
TMP_CHAR = "ACS "
Case 204
TMP_CHAR = "ATN "
Case 205
TMP_CHAR = "LN "
Case 206
TMP_CHAR = "EXP "
Case 207
TMP_CHAR = "INT "
Case 208
TMP_CHAR = "SQR "
Case 209
TMP_CHAR = "SGN "
Case 210
TMP_CHAR = "ABS "
Case 211
TMP_CHAR = "PEEK "
Case 212
TMP_CHAR = "USR "
Case 213
TMP_CHAR = "STR$ "
Case 214
TMP_CHAR = "CHR$ "
Case 215
TMP_CHAR = "NOT "
Case 216
TMP_CHAR = "**"
Case 217
TMP_CHAR = " OR "
Case 218
TMP_CHAR = " AND "
Case 219
TMP_CHAR = "<="
Case 220
TMP_CHAR = ">="
Case 221
TMP_CHAR = "<>"
Case 222
TMP_CHAR = " THEN "
Case 223
TMP_CHAR = " TO "
Case 224
TMP_CHAR = " STEP "
Case 225
TMP_CHAR = "LPRINT "
Case 226
TMP_CHAR = "LLIST "
Case 227
TMP_CHAR = "STOP "
Case 228
TMP_CHAR = "SLOW "
Case 229
TMP_CHAR = "FAST "
Case 230
TMP_CHAR = "NEW "
Case 231
TMP_CHAR = "SCROLL "
Case 232
TMP_CHAR = "CONT "
Case 233
TMP_CHAR = "DIM "
Case 234
TMP_CHAR = " REM"
Case 235
TMP_CHAR = "FOR "
Case 236
TMP_CHAR = "GOTO "
Case 237
TMP_CHAR = "GOSUB "
Case 238
TMP_CHAR = "INPUT "
Case 239
TMP_CHAR = "LOAD "
Case 240
TMP_CHAR = "LIST "
Case 241
TMP_CHAR = "LET "
Case 242
TMP_CHAR = "PAUSE "
Case 243
TMP_CHAR = "NEXT "
Case 244
TMP_CHAR = "POKE "
Case 245
TMP_CHAR = "PRINT "
Case 246
TMP_CHAR = "PLOT "
Case 247
TMP_CHAR = "RUN "
Case 248
TMP_CHAR = "SAVE "
Case 249
TMP_CHAR = "RAND "
Case 250
TMP_CHAR = "IF "
Case 251
TMP_CHAR = "CLS "
Case 252
TMP_CHAR = "UNPLOT "
Case 253
TMP_CHAR = "CLEAR "
Case 254
TMP_CHAR = "RETURN "
Case 255
TMP_CHAR = "COPY "
End Select

Zx2ASCII = TMP_CHAR

End Function
