Attribute VB_Name = "ModTASM"
Option Explicit

Function DisaTASM(addr As Long) As String

        Dim Opcode As Byte
        Dim p As Integer
        Dim Val_nnnn As Long
        Dim StrAddr As String
        Dim StrCode As String
        Dim StrText As String
        Dim StrComment As String
        Dim bINOUTinfo As Boolean
        Dim IOTAG As String
        Dim IOinfo As String
        

        
        bINOUTinfo = False
        
       
        If addr < LBound(MEM) Or addr > UBound(MEM) Then Exit Function
        Opcode = MEM(addr)
        StrAddr = "$" + Hex16(CLng(addr))
        
ReScan:
        
        Select Case Distag
        Case show_hex_val
         StrCode = Hex8(CLng(Opcode))
        Case show_dec_val
         StrCode = Opcode
        Case show_str_val
               Select Case Opcode
                Case &H7C, 0
                 StrCode = StrCode & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & Chr(&H22) & Chr(Opcode) & Chr(&H22)
               End Select

        End Select
       
        

        addr = addr + 1
        
CharLoop:
  '      If (addr > (SRamLim + 1) And Not (Opcode And 64)) Then StrText = "*NOP*": GoTo End_Of_OpCode

'If addr > &H4000 And addr < &H407E Then StrText = "' SYSTEM :": GoTo End_Of_OpCode

        Select Case Opcode
        
        Case &H0
                   StrText = "NOP": GoTo End_Of_OpCode
        Case &H1
                   StrText = "LD BC,nnnn": GoTo End_Of_OpCode
        Case &H2
                   StrText = "LD (BC),A": GoTo End_Of_OpCode
        Case &H3
                   StrText = "INC BC": GoTo End_Of_OpCode
        Case &H4
                   StrText = "INC B": GoTo End_Of_OpCode
        Case &H5
                   StrText = "DEC B": GoTo End_Of_OpCode
        Case &H6
                   StrText = "LD B,nn": GoTo End_Of_OpCode
        Case &H7
                   StrText = "RLCA": GoTo End_Of_OpCode
        Case &H8
                   StrText = "EX AF,AF'": GoTo End_Of_OpCode
        Case &H9
                   StrText = "ADD HL,BC": GoTo End_Of_OpCode
        Case &HA
                   StrText = "LD A,(BC)": GoTo End_Of_OpCode
        Case &HB
                   StrText = "DEC BC": GoTo End_Of_OpCode
        Case &HC
                   StrText = "INC C": GoTo End_Of_OpCode
        Case &HD
                   StrText = "DEC C": GoTo End_Of_OpCode
        Case &HE
                   StrText = "LD C,nn": GoTo End_Of_OpCode
        Case &HF
                   StrText = "RRCA": GoTo End_Of_OpCode
        Case &H10
                   StrText = "DJNZ fz": GoTo End_Of_OpCode
        Case &H11
                   StrText = "LD DE,nnnn": GoTo End_Of_OpCode
        Case &H12
                   StrText = "LD (DE),A": GoTo End_Of_OpCode
        Case &H13
                   StrText = "INC DE": GoTo End_Of_OpCode
        Case &H14
                   StrText = "INC D": GoTo End_Of_OpCode
        Case &H15
                   StrText = "DEC D": GoTo End_Of_OpCode
        Case &H16
                   StrText = "LD D,nn": GoTo End_Of_OpCode
        Case &H17
                   StrText = "RLA": GoTo End_Of_OpCode
        Case &H18
                   StrText = "JR fz": GoTo End_Of_OpCode
        Case &H19
                   StrText = "ADD HL,DE": GoTo End_Of_OpCode
        Case &H1A
                   StrText = "LD A,(DE)": GoTo End_Of_OpCode
        Case &H1B
                   StrText = "DEC DE": GoTo End_Of_OpCode
        Case &H1C
                   StrText = "INC E": GoTo End_Of_OpCode
        Case &H1D
                   StrText = "DEC E": GoTo End_Of_OpCode
        Case &H1E
                   StrText = "LD E,nn": GoTo End_Of_OpCode
        Case &H1F
                   StrText = "RRA": GoTo End_Of_OpCode
        Case &H20
                   StrText = "JR NZ,fz": GoTo End_Of_OpCode
        Case &H21
                   StrText = "LD HL,nnnn": GoTo End_Of_OpCode
        Case &H22
                   StrText = "LD (nnnn),HL": GoTo End_Of_OpCode
        Case &H23
                   StrText = "INC HL": GoTo End_Of_OpCode
        Case &H24
                   StrText = "INC H": GoTo End_Of_OpCode
        Case &H25
                   StrText = "DEC H": GoTo End_Of_OpCode
        Case &H26
                   StrText = "LD H,nn": GoTo End_Of_OpCode
        Case &H27
                   StrText = "DAA": GoTo End_Of_OpCode
        Case &H28
                   StrText = "JR Z,fz": GoTo End_Of_OpCode
        Case &H29
                   StrText = "ADD HL,HL": GoTo End_Of_OpCode
        Case &H2A
                   StrText = "LD HL,(nnnn)": GoTo End_Of_OpCode
        Case &H2B
                   StrText = "DEC HL": GoTo End_Of_OpCode
        Case &H2C
                   StrText = "INC L": GoTo End_Of_OpCode
        Case &H2D
                   StrText = "DEC L": GoTo End_Of_OpCode
        Case &H2E
                   StrText = "LD L,nn": GoTo End_Of_OpCode
        Case &H2F
                   StrText = "CPL": GoTo End_Of_OpCode
        Case &H30
                   StrText = "JR NC,fz": GoTo End_Of_OpCode
        Case &H31
                   StrText = "LD SP,nnnn": GoTo End_Of_OpCode
        Case &H32
                   StrText = "LD (nnnn),A": GoTo End_Of_OpCode
        Case &H33
                   StrText = "INC SP": GoTo End_Of_OpCode
        Case &H34
                   StrText = "INC (HL)": GoTo End_Of_OpCode
        Case &H35
                   StrText = "DEC (HL)": GoTo End_Of_OpCode
        Case &H36
                   StrText = "LD (HL),nn": GoTo End_Of_OpCode
        Case &H37
                   StrText = "SCF": GoTo End_Of_OpCode
        Case &H38
                   StrText = "JR C,fz": GoTo End_Of_OpCode
        Case &H39
                   StrText = "ADD HL,SP": GoTo End_Of_OpCode
        Case &H3A
                   StrText = "LD A,(nnnn)": GoTo End_Of_OpCode
        Case &H3B
                   StrText = "DEC SP": GoTo End_Of_OpCode
        Case &H3C
                   StrText = "INC A": GoTo End_Of_OpCode
        Case &H3D
                   StrText = "DEC A": GoTo End_Of_OpCode
        Case &H3E
                   StrText = "LD A,nn": GoTo End_Of_OpCode
        Case &H3F
                   StrText = "CCF": GoTo End_Of_OpCode
        Case &H40
                   StrText = "LD B,B": GoTo End_Of_OpCode
        Case &H41
                   StrText = "LD B,C": GoTo End_Of_OpCode
        Case &H42
                   StrText = "LD B,D": GoTo End_Of_OpCode
        Case &H43
                   StrText = "LD B,E": GoTo End_Of_OpCode
        Case &H44
                   StrText = "LD B,H": GoTo End_Of_OpCode
        Case &H45
                   StrText = "LD B,L": GoTo End_Of_OpCode
        Case &H46
                   StrText = "LD B,(HL)": GoTo End_Of_OpCode
        Case &H47
                   StrText = "LD B,A": GoTo End_Of_OpCode
        Case &H48
                   StrText = "LD C,B": GoTo End_Of_OpCode
        Case &H49
                   StrText = "LD C,C": GoTo End_Of_OpCode
        Case &H4A
                   StrText = "LD C,D": GoTo End_Of_OpCode
        Case &H4B
                   StrText = "LD C,E": GoTo End_Of_OpCode
        Case &H4C
                   StrText = "LD C,H": GoTo End_Of_OpCode
        Case &H4D
                   StrText = "LD C,L": GoTo End_Of_OpCode
        Case &H4E
                   StrText = "LD C,(HL)": GoTo End_Of_OpCode
        Case &H4F
                   StrText = "LD C,A": GoTo End_Of_OpCode
        Case &H50
                   StrText = "LD D,B": GoTo End_Of_OpCode
        Case &H51
                   StrText = "LD D,C": GoTo End_Of_OpCode
        Case &H52
                   StrText = "LD D,D": GoTo End_Of_OpCode
        Case &H53
                   StrText = "LD D,E": GoTo End_Of_OpCode
        Case &H54
                   StrText = "LD D,H": GoTo End_Of_OpCode
        Case &H55
                   StrText = "LD D,L": GoTo End_Of_OpCode
        Case &H56
                   StrText = "LD D,(HL)": GoTo End_Of_OpCode
        Case &H57
                   StrText = "LD D,A": GoTo End_Of_OpCode
        Case &H58
                   StrText = "LD E,B": GoTo End_Of_OpCode
        Case &H59
                   StrText = "LD E,C": GoTo End_Of_OpCode
        Case &H5A
                   StrText = "LD E,D": GoTo End_Of_OpCode
        Case &H5B
                   StrText = "LD E,E": GoTo End_Of_OpCode
        Case &H5C
                   StrText = "LD E,H": GoTo End_Of_OpCode
        Case &H5D
                   StrText = "LD E,L": GoTo End_Of_OpCode
        Case &H5E
                   StrText = "LD E,(HL)": GoTo End_Of_OpCode
        Case &H5F
                   StrText = "LD E,A": GoTo End_Of_OpCode
        Case &H60
                   StrText = "LD H,B": GoTo End_Of_OpCode
        Case &H61
                   StrText = "LD H,C": GoTo End_Of_OpCode
        Case &H62
                   StrText = "LD H,D": GoTo End_Of_OpCode
        Case &H63
                   StrText = "LD H,E": GoTo End_Of_OpCode
        Case &H64
                   StrText = "LD H,H": GoTo End_Of_OpCode
        Case &H65
                   StrText = "LD H,L": GoTo End_Of_OpCode
        Case &H66
                   StrText = "LD H,(HL)": GoTo End_Of_OpCode
        Case &H67
                   StrText = "LD H,A": GoTo End_Of_OpCode
        Case &H68
                   StrText = "LD L,B": GoTo End_Of_OpCode
        Case &H69
                   StrText = "LD L,C": GoTo End_Of_OpCode
        Case &H6A
                   StrText = "LD L,D": GoTo End_Of_OpCode
        Case &H6B
                   StrText = "LD L,E": GoTo End_Of_OpCode
        Case &H6C
                   StrText = "LD L,H": GoTo End_Of_OpCode
        Case &H6D
                   StrText = "LD L,L": GoTo End_Of_OpCode
        Case &H6E
                   StrText = "LD L,(HL)": GoTo End_Of_OpCode
        Case &H6F
                   StrText = "LD L,A": GoTo End_Of_OpCode
        Case &H70
                   StrText = "LD (HL),B": GoTo End_Of_OpCode
        Case &H71
                   StrText = "LD (HL),C": GoTo End_Of_OpCode
        Case &H72
                   StrText = "LD (HL),D": GoTo End_Of_OpCode
        Case &H73
                   StrText = "LD (HL),E": GoTo End_Of_OpCode
        Case &H74
                   StrText = "LD (HL),H": GoTo End_Of_OpCode
        Case &H75
                   StrText = "LD (HL),L": GoTo End_Of_OpCode
        Case &H76
                   StrText = "HALT": GoTo End_Of_OpCode
        Case &H77
                   StrText = "LD (HL),A": GoTo End_Of_OpCode
        Case &H78
                   StrText = "LD A,B": GoTo End_Of_OpCode
        Case &H79
                   StrText = "LD A,C": GoTo End_Of_OpCode
        Case &H7A
                   StrText = "LD A,D": GoTo End_Of_OpCode
        Case &H7B
                   StrText = "LD A,E": GoTo End_Of_OpCode
        Case &H7C
                   StrText = "LD A,H": GoTo End_Of_OpCode
        Case &H7D
                   StrText = "LD A,L": GoTo End_Of_OpCode
        Case &H7E
                   StrText = "LD A,(HL)": GoTo End_Of_OpCode
        Case &H7F
                   StrText = "LD A,A": GoTo End_Of_OpCode
        Case &H80
                   StrText = "ADD A,B": GoTo End_Of_OpCode
        Case &H81
                   StrText = "ADD A,C": GoTo End_Of_OpCode
        Case &H82
                   StrText = "ADD A,D": GoTo End_Of_OpCode
        Case &H83
                   StrText = "ADD A,E": GoTo End_Of_OpCode
        Case &H84
                   StrText = "ADD A,H": GoTo End_Of_OpCode
        Case &H85
                   StrText = "ADD A,L": GoTo End_Of_OpCode
        Case &H86
                   StrText = "ADD A,(HL)": GoTo End_Of_OpCode
        Case &H87
                   StrText = "ADD A": GoTo End_Of_OpCode
        Case &H88
                   StrText = "ADC A,B": GoTo End_Of_OpCode
        Case &H89
                   StrText = "ADC A,C": GoTo End_Of_OpCode
        Case &H8A
                   StrText = "ADC A,D": GoTo End_Of_OpCode
        Case &H8B
                   StrText = "ADC A,E": GoTo End_Of_OpCode
        Case &H8C
                   StrText = "ADC A,H": GoTo End_Of_OpCode
        Case &H8D
                   StrText = "ADC A,L": GoTo End_Of_OpCode
        Case &H8E
                   StrText = "ADC A,(HL)": GoTo End_Of_OpCode
        Case &H8F
                   StrText = "ADC A": GoTo End_Of_OpCode
        Case &H90
                   StrText = "SUB B": GoTo End_Of_OpCode
        Case &H91
                   StrText = "SUB C": GoTo End_Of_OpCode
        Case &H92
                   StrText = "SUB D": GoTo End_Of_OpCode
        Case &H93
                   StrText = "SUB E": GoTo End_Of_OpCode
        Case &H94
                   StrText = "SUB H": GoTo End_Of_OpCode
        Case &H95
                   StrText = "SUB L": GoTo End_Of_OpCode
        Case &H96
                   StrText = "SUB (HL)": GoTo End_Of_OpCode
        Case &H97
                   StrText = "SUB A": GoTo End_Of_OpCode
        Case &H98
                   StrText = "SBC A,B": GoTo End_Of_OpCode
        Case &H99
                   StrText = "SBC A,C": GoTo End_Of_OpCode
        Case &H9A
                   StrText = "SBC A,D": GoTo End_Of_OpCode
        Case &H9B
                   StrText = "SBC A,E": GoTo End_Of_OpCode
        Case &H9C
                   StrText = "SBC A,H": GoTo End_Of_OpCode
        Case &H9D
                   StrText = "SBC A,L": GoTo End_Of_OpCode
        Case &H9E
                   StrText = "SBC A,(HL)": GoTo End_Of_OpCode
        Case &H9F
                   StrText = "SBC A,A": GoTo End_Of_OpCode
        Case &HA0
                   StrText = "AND B": GoTo End_Of_OpCode
        Case &HA1
                   StrText = "AND C": GoTo End_Of_OpCode
        Case &HA2
                   StrText = "AND D": GoTo End_Of_OpCode
        Case &HA3
                   StrText = "AND E": GoTo End_Of_OpCode
        Case &HA4
                   StrText = "AND H": GoTo End_Of_OpCode
        Case &HA5
                   StrText = "AND L": GoTo End_Of_OpCode
        Case &HA6
                   StrText = "AND (HL)": GoTo End_Of_OpCode
        Case &HA7
                   StrText = "AND A": GoTo End_Of_OpCode
        Case &HA8
                   StrText = "XOR B": GoTo End_Of_OpCode
        Case &HA9
                   StrText = "XOR C": GoTo End_Of_OpCode
        Case &HAA
                   StrText = "XOR D": GoTo End_Of_OpCode
        Case &HAB
                   StrText = "XOR E": GoTo End_Of_OpCode
        Case &HAC
                   StrText = "XOR H": GoTo End_Of_OpCode
        Case &HAD
                   StrText = "XOR L": GoTo End_Of_OpCode
        Case &HAE
                   StrText = "XOR (HL)": GoTo End_Of_OpCode
        Case &HAF
                   StrText = "XOR A": GoTo End_Of_OpCode
        Case &HB0
                   StrText = "OR B": GoTo End_Of_OpCode
        Case &HB1
                   StrText = "OR C": GoTo End_Of_OpCode
        Case &HB2
                   StrText = "OR D": GoTo End_Of_OpCode
        Case &HB3
                   StrText = "OR E": GoTo End_Of_OpCode
        Case &HB4
                   StrText = "OR H": GoTo End_Of_OpCode
        Case &HB5
                   StrText = "OR L": GoTo End_Of_OpCode
        Case &HB6
                   StrText = "OR (HL)": GoTo End_Of_OpCode
        Case &HB7
                   StrText = "OR A": GoTo End_Of_OpCode
        Case &HB8
                   StrText = "CP B": GoTo End_Of_OpCode
        Case &HB9
                   StrText = "CP C": GoTo End_Of_OpCode
        Case &HBA
                   StrText = "CP D": GoTo End_Of_OpCode
        Case &HBB
                   StrText = "CP E": GoTo End_Of_OpCode
        Case &HBC
                   StrText = "CP H": GoTo End_Of_OpCode
        Case &HBD
                   StrText = "CP L": GoTo End_Of_OpCode
        Case &HBE
                   StrText = "CP (HL)": GoTo End_Of_OpCode
        Case &HBF
                   StrText = "CP A": GoTo End_Of_OpCode
        Case &HC0
                   StrText = "RET NZ": GoTo End_Of_OpCode
        Case &HC1
                   StrText = "POP BC": GoTo End_Of_OpCode
        Case &HC2
                   StrText = "JP NZ,nnnn": GoTo End_Of_OpCode
        Case &HC3
                   StrText = "JP nnnn": GoTo End_Of_OpCode
        Case &HC4
                   StrText = "CALL NZ,nnnn": GoTo End_Of_OpCode
        Case &HC5
                   StrText = "PUSH BC": GoTo End_Of_OpCode
        Case &HC6
                   StrText = "ADD nn": GoTo End_Of_OpCode
        Case &HC7
                   StrText = "RST 00H": GoTo End_Of_OpCode
        Case &HC8
                   StrText = "RET Z": GoTo End_Of_OpCode
        Case &HC9
                   StrText = "RET": GoTo End_Of_OpCode
        Case &HCA
                   StrText = "JP Z,nnnn": GoTo End_Of_OpCode
        Case &HCB
                Opcode = MEM(addr)
                If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
                

                        
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(Opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & Opcode
        Case show_str_val
               Select Case Opcode
                Case &H7C, 0
                 StrCode = StrCode & ";" & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & ";" & Chr(&H22) & Chr(Opcode) & Chr(&H22)
               End Select

     End Select
        
                addr = addr + 1

                Select Case Opcode
                
                Case &H0
                   StrText = "RLC B": GoTo End_Of_OpCode
                Case &H1
                   StrText = "RLC C": GoTo End_Of_OpCode
                Case &H2
                   StrText = "RLC D": GoTo End_Of_OpCode
                Case &H3
                   StrText = "RLC E": GoTo End_Of_OpCode
                Case &H4
                   StrText = "RLC H": GoTo End_Of_OpCode
                Case &H5
                   StrText = "RLC L": GoTo End_Of_OpCode
                Case &H6
                   StrText = "RLC (HL)": GoTo End_Of_OpCode
                Case &H7
                   StrText = "RLC A": GoTo End_Of_OpCode
                Case &H8
                   StrText = "RRC B": GoTo End_Of_OpCode
                Case &H9
                   StrText = "RRC C": GoTo End_Of_OpCode
                Case &HA
                   StrText = "RRC D": GoTo End_Of_OpCode
                Case &HB
                   StrText = "RRC E": GoTo End_Of_OpCode
                Case &HC
                   StrText = "RRC H": GoTo End_Of_OpCode
                Case &HD
                   StrText = "RRC L": GoTo End_Of_OpCode
                Case &HE
                   StrText = "RRC (HL)": GoTo End_Of_OpCode
                Case &HF
                   StrText = "RRC A": GoTo End_Of_OpCode
                Case &H10
                   StrText = "RL B": GoTo End_Of_OpCode
                Case &H11
                   StrText = "RL C": GoTo End_Of_OpCode
                Case &H12
                   StrText = "RL D": GoTo End_Of_OpCode
                Case &H13
                   StrText = "RL E": GoTo End_Of_OpCode
                Case &H14
                   StrText = "RL H": GoTo End_Of_OpCode
                Case &H15
                   StrText = "RL L": GoTo End_Of_OpCode
                Case &H16
                   StrText = "RL (HL)": GoTo End_Of_OpCode
                Case &H17
                   StrText = "RL A": GoTo End_Of_OpCode
                Case &H18
                   StrText = "RR B": GoTo End_Of_OpCode
                Case &H19
                   StrText = "RR C": GoTo End_Of_OpCode
                Case &H1A
                   StrText = "RR D": GoTo End_Of_OpCode
                Case &H1B
                   StrText = "RR E": GoTo End_Of_OpCode
                Case &H1C
                   StrText = "RR H": GoTo End_Of_OpCode
                Case &H1D
                   StrText = "RR L": GoTo End_Of_OpCode
                Case &H1E
                   StrText = "RR (HL)": GoTo End_Of_OpCode
                Case &H1F
                   StrText = "RR A": GoTo End_Of_OpCode
                Case &H20
                   StrText = "SLA B": GoTo End_Of_OpCode
                Case &H21
                   StrText = "SLA C": GoTo End_Of_OpCode
                Case &H22
                   StrText = "SLA D": GoTo End_Of_OpCode
                Case &H23
                   StrText = "SLA E": GoTo End_Of_OpCode
                Case &H24
                   StrText = "SLA H": GoTo End_Of_OpCode
                Case &H25
                   StrText = "SLA L": GoTo End_Of_OpCode
                Case &H26
                   StrText = "SLA (HL)": GoTo End_Of_OpCode
                Case &H27
                   StrText = "SLA A": GoTo End_Of_OpCode
                Case &H28
                   StrText = "SRA B": GoTo End_Of_OpCode
                Case &H29
                   StrText = "SRA C": GoTo End_Of_OpCode
                Case &H2A
                   StrText = "SRA D": GoTo End_Of_OpCode
                Case &H2B
                   StrText = "SRA E": GoTo End_Of_OpCode
                Case &H2C
                   StrText = "SRA H": GoTo End_Of_OpCode
                Case &H2D
                   StrText = "SRA L": GoTo End_Of_OpCode
                Case &H2E
                   StrText = "SRA (HL)": GoTo End_Of_OpCode
                Case &H2F
                   StrText = "SRA A": GoTo End_Of_OpCode
                Case &H30
                   StrText = "SLL B": GoTo End_Of_OpCode
                Case &H31
                   StrText = "SLL C": GoTo End_Of_OpCode
                Case &H32
                   StrText = "SLL D": GoTo End_Of_OpCode
                Case &H33
                   StrText = "SLL E": GoTo End_Of_OpCode
                Case &H34
                   StrText = "SLL H": GoTo End_Of_OpCode
                Case &H35
                   StrText = "SLL L": GoTo End_Of_OpCode
                Case &H36
                   StrText = "SLL (HL)": GoTo End_Of_OpCode
                Case &H37
                   StrText = "SLL A": GoTo End_Of_OpCode
                Case &H38
                   StrText = "SRL B": GoTo End_Of_OpCode
                Case &H39
                   StrText = "SRL C": GoTo End_Of_OpCode
                Case &H3A
                   StrText = "SRL D": GoTo End_Of_OpCode
                Case &H3B
                   StrText = "SRL E": GoTo End_Of_OpCode
                Case &H3C
                   StrText = "SRL H": GoTo End_Of_OpCode
                Case &H3D
                   StrText = "SRL L": GoTo End_Of_OpCode
                Case &H3E
                   StrText = "SRL (HL)": GoTo End_Of_OpCode
                Case &H3F
                   StrText = "SRL A": GoTo End_Of_OpCode
                Case &H40
                   StrText = "BIT 0,B": GoTo End_Of_OpCode
                Case &H41
                   StrText = "BIT 0,C": GoTo End_Of_OpCode
                Case &H42
                   StrText = "BIT 0,D": GoTo End_Of_OpCode
                Case &H43
                   StrText = "BIT 0,E": GoTo End_Of_OpCode
                Case &H44
                   StrText = "BIT 0,H": GoTo End_Of_OpCode
                Case &H45
                   StrText = "BIT 0,L": GoTo End_Of_OpCode
                Case &H46
                   StrText = "BIT 0,(HL)": GoTo End_Of_OpCode
                Case &H47
                   StrText = "BIT 0,A": GoTo End_Of_OpCode
                Case &H48
                   StrText = "BIT 1,B": GoTo End_Of_OpCode
                Case &H49
                   StrText = "BIT 1,C": GoTo End_Of_OpCode
                Case &H4A
                   StrText = "BIT 1,D": GoTo End_Of_OpCode
                Case &H4B
                   StrText = "BIT 1,E": GoTo End_Of_OpCode
                Case &H4C
                   StrText = "BIT 1,H": GoTo End_Of_OpCode
                Case &H4D
                   StrText = "BIT 1,L": GoTo End_Of_OpCode
                Case &H4E
                   StrText = "BIT 1,(HL)": GoTo End_Of_OpCode
                Case &H4F
                   StrText = "BIT 1,A": GoTo End_Of_OpCode
                Case &H50
                   StrText = "BIT 2,B": GoTo End_Of_OpCode
                Case &H51
                   StrText = "BIT 2,C": GoTo End_Of_OpCode
                Case &H52
                   StrText = "BIT 2,D": GoTo End_Of_OpCode
                Case &H53
                   StrText = "BIT 2,E": GoTo End_Of_OpCode
                Case &H54
                   StrText = "BIT 2,H": GoTo End_Of_OpCode
                Case &H55
                   StrText = "BIT 2,L": GoTo End_Of_OpCode
                Case &H56
                   StrText = "BIT 2,(HL)": GoTo End_Of_OpCode
                Case &H57
                   StrText = "BIT 2,A": GoTo End_Of_OpCode
                Case &H58
                   StrText = "BIT 3,B": GoTo End_Of_OpCode
                Case &H59
                   StrText = "BIT 3,C": GoTo End_Of_OpCode
                Case &H5A
                   StrText = "BIT 3,D": GoTo End_Of_OpCode
                Case &H5B
                   StrText = "BIT 3,E": GoTo End_Of_OpCode
                Case &H5C
                   StrText = "BIT 3,H": GoTo End_Of_OpCode
                Case &H5D
                   StrText = "BIT 3,L": GoTo End_Of_OpCode
                Case &H5E
                   StrText = "BIT 3,(HL)": GoTo End_Of_OpCode
                Case &H5F
                   StrText = "BIT 3,A": GoTo End_Of_OpCode
                Case &H60
                   StrText = "BIT 4,B": GoTo End_Of_OpCode
                Case &H61
                   StrText = "BIT 4,C": GoTo End_Of_OpCode
                Case &H62
                   StrText = "BIT 4,D": GoTo End_Of_OpCode
                Case &H63
                   StrText = "BIT 4,E": GoTo End_Of_OpCode
                Case &H64
                   StrText = "BIT 4,H": GoTo End_Of_OpCode
                Case &H65
                   StrText = "BIT 4,L": GoTo End_Of_OpCode
                Case &H66
                   StrText = "BIT 4,(HL)": GoTo End_Of_OpCode
                Case &H67
                   StrText = "BIT 4,A": GoTo End_Of_OpCode
                Case &H68
                   StrText = "BIT 5,B": GoTo End_Of_OpCode
                Case &H69
                   StrText = "BIT 5,C": GoTo End_Of_OpCode
                Case &H6A
                   StrText = "BIT 5,D": GoTo End_Of_OpCode
                Case &H6B
                   StrText = "BIT 5,E": GoTo End_Of_OpCode
                Case &H6C
                   StrText = "BIT 5,H": GoTo End_Of_OpCode
                Case &H6D
                   StrText = "BIT 5,L": GoTo End_Of_OpCode
                Case &H6E
                   StrText = "BIT 5,(HL)": GoTo End_Of_OpCode
                Case &H6F
                   StrText = "BIT 5,A": GoTo End_Of_OpCode
                Case &H70
                   StrText = "BIT 6,B": GoTo End_Of_OpCode
                Case &H71
                   StrText = "BIT 6,C": GoTo End_Of_OpCode
                Case &H72
                   StrText = "BIT 6,D": GoTo End_Of_OpCode
                Case &H73
                   StrText = "BIT 6,E": GoTo End_Of_OpCode
                Case &H74
                   StrText = "BIT 6,H": GoTo End_Of_OpCode
                Case &H75
                   StrText = "BIT 6,L": GoTo End_Of_OpCode
                Case &H76
                   StrText = "BIT 6,(HL)": GoTo End_Of_OpCode
                Case &H77
                   StrText = "BIT 6,A": GoTo End_Of_OpCode
                Case &H78
                   StrText = "BIT 7,B": GoTo End_Of_OpCode
                Case &H79
                   StrText = "BIT 7,C": GoTo End_Of_OpCode
                Case &H7A
                   StrText = "BIT 7,D": GoTo End_Of_OpCode
                Case &H7B
                   StrText = "BIT 7,E": GoTo End_Of_OpCode
                Case &H7C, 0
                   StrText = "BIT 7,H": GoTo End_Of_OpCode
                Case &H7D
                   StrText = "BIT 7,L": GoTo End_Of_OpCode
                Case &H7E
                   StrText = "BIT 7,(HL)": GoTo End_Of_OpCode
                Case &H7F
                   StrText = "BIT 7,A": GoTo End_Of_OpCode
                Case &H80
                   StrText = "RES 0,B": GoTo End_Of_OpCode
                Case &H81
                   StrText = "RES 0,C": GoTo End_Of_OpCode
                Case &H82
                   StrText = "RES 0,D": GoTo End_Of_OpCode
                Case &H83
                   StrText = "RES 0,E": GoTo End_Of_OpCode
                Case &H84
                   StrText = "RES 0,H": GoTo End_Of_OpCode
                Case &H85
                   StrText = "RES 0,L": GoTo End_Of_OpCode
                Case &H86
                   StrText = "RES 0,(HL)": GoTo End_Of_OpCode
                Case &H87
                   StrText = "RES 0,A": GoTo End_Of_OpCode
                Case &H88
                   StrText = "RES 1,B": GoTo End_Of_OpCode
                Case &H89
                   StrText = "RES 1,C": GoTo End_Of_OpCode
                Case &H8A
                   StrText = "RES 1,D": GoTo End_Of_OpCode
                Case &H8B
                   StrText = "RES 1,E": GoTo End_Of_OpCode
                Case &H8C
                   StrText = "RES 1,H": GoTo End_Of_OpCode
                Case &H8D
                   StrText = "RES 1,L": GoTo End_Of_OpCode
                Case &H8E
                   StrText = "RES 1,(HL)": GoTo End_Of_OpCode
                Case &H8F
                   StrText = "RES 1,A": GoTo End_Of_OpCode
                Case &H90
                   StrText = "RES 2,B": GoTo End_Of_OpCode
                Case &H91
                   StrText = "RES 2,C": GoTo End_Of_OpCode
                Case &H92
                   StrText = "RES 2,D": GoTo End_Of_OpCode
                Case &H93
                   StrText = "RES 2,E": GoTo End_Of_OpCode
                Case &H94
                   StrText = "RES 2,H": GoTo End_Of_OpCode
                Case &H95
                   StrText = "RES 2,L": GoTo End_Of_OpCode
                Case &H96
                   StrText = "RES 2,(HL)": GoTo End_Of_OpCode
                Case &H97
                   StrText = "RES 2,A": GoTo End_Of_OpCode
                Case &H98
                   StrText = "RES 3,B": GoTo End_Of_OpCode
                Case &H99
                   StrText = "RES 3,C": GoTo End_Of_OpCode
                Case &H9A
                   StrText = "RES 3,D": GoTo End_Of_OpCode
                Case &H9B
                   StrText = "RES 3,E": GoTo End_Of_OpCode
                Case &H9C
                   StrText = "RES 3,H": GoTo End_Of_OpCode
                Case &H9D
                   StrText = "RES 3,L": GoTo End_Of_OpCode
                Case &H9E
                   StrText = "RES 3,(HL)": GoTo End_Of_OpCode
                Case &H9F
                   StrText = "RES 3,A": GoTo End_Of_OpCode
                Case &HA0
                   StrText = "RES 4,B": GoTo End_Of_OpCode
                Case &HA1
                   StrText = "RES 4,C": GoTo End_Of_OpCode
                Case &HA2
                   StrText = "RES 4,D": GoTo End_Of_OpCode
                Case &HA3
                   StrText = "RES 4,E": GoTo End_Of_OpCode
                Case &HA4
                   StrText = "RES 4,H": GoTo End_Of_OpCode
                Case &HA5
                   StrText = "RES 4,L": GoTo End_Of_OpCode
                Case &HA6
                   StrText = "RES 4,(HL)": GoTo End_Of_OpCode
                Case &HA7
                   StrText = "RES 4,A": GoTo End_Of_OpCode
                Case &HA8
                   StrText = "RES 5,B": GoTo End_Of_OpCode
                Case &HA9
                   StrText = "RES 5,C": GoTo End_Of_OpCode
                Case &HAA
                   StrText = "RES 5,D": GoTo End_Of_OpCode
                Case &HAB
                   StrText = "RES 5,E": GoTo End_Of_OpCode
                Case &HAC
                   StrText = "RES 5,H": GoTo End_Of_OpCode
                Case &HAD
                   StrText = "RES 5,L": GoTo End_Of_OpCode
                Case &HAE
                   StrText = "RES 5,(HL)": GoTo End_Of_OpCode
                Case &HAF
                   StrText = "RES 5,A": GoTo End_Of_OpCode
                Case &HB0
                   StrText = "RES 6,B": GoTo End_Of_OpCode
                Case &HB1
                   StrText = "RES 6,C": GoTo End_Of_OpCode
                Case &HB2
                   StrText = "RES 6,D": GoTo End_Of_OpCode
                Case &HB3
                   StrText = "RES 6,E": GoTo End_Of_OpCode
                Case &HB4
                   StrText = "RES 6,H": GoTo End_Of_OpCode
                Case &HB5
                   StrText = "RES 6,L": GoTo End_Of_OpCode
                Case &HB6
                   StrText = "RES 6,(HL)": GoTo End_Of_OpCode
                Case &HB7
                   StrText = "RES 6,A": GoTo End_Of_OpCode
                Case &HB8
                   StrText = "RES 7,B": GoTo End_Of_OpCode
                Case &HB9
                   StrText = "RES 7,C": GoTo End_Of_OpCode
                Case &HBA
                   StrText = "RES 7,D": GoTo End_Of_OpCode
                Case &HBB
                   StrText = "RES 7,E": GoTo End_Of_OpCode
                Case &HBC
                   StrText = "RES 7,H": GoTo End_Of_OpCode
                Case &HBD
                   StrText = "RES 7,L": GoTo End_Of_OpCode
                Case &HBE
                   StrText = "RES 7,(HL)": GoTo End_Of_OpCode
                Case &HBF
                   StrText = "RES 7,A": GoTo End_Of_OpCode
                Case &HC0
                   StrText = "SET 0,B": GoTo End_Of_OpCode
                Case &HC1
                   StrText = "SET 0,C": GoTo End_Of_OpCode
                Case &HC2
                   StrText = "SET 0,D": GoTo End_Of_OpCode
                Case &HC3
                   StrText = "SET 0,E": GoTo End_Of_OpCode
                Case &HC4
                   StrText = "SET 0,H": GoTo End_Of_OpCode
                Case &HC5
                   StrText = "SET 0,L": GoTo End_Of_OpCode
                Case &HC6
                   StrText = "SET 0,(HL)": GoTo End_Of_OpCode
                Case &HC7
                   StrText = "SET 0,A": GoTo End_Of_OpCode
                Case &HC8
                   StrText = "SET 1,B": GoTo End_Of_OpCode
                Case &HC9
                   StrText = "SET 1,C": GoTo End_Of_OpCode
                Case &HCA
                   StrText = "SET 1,D": GoTo End_Of_OpCode
                Case &HCB
                   StrText = "SET 1,E": GoTo End_Of_OpCode
                Case &HCC
                   StrText = "SET 1,H": GoTo End_Of_OpCode
                Case &HCD
                   StrText = "SET 1,L": GoTo End_Of_OpCode
                Case &HCE
                   StrText = "SET 1,(HL)": GoTo End_Of_OpCode
                Case &HCF
                   StrText = "SET 1,A": GoTo End_Of_OpCode
                Case &HD0
                   StrText = "SET 2,B": GoTo End_Of_OpCode
                Case &HD1
                   StrText = "SET 2,C": GoTo End_Of_OpCode
                Case &HD2
                   StrText = "SET 2,D": GoTo End_Of_OpCode
                Case &HD3
                   StrText = "SET 2,E": GoTo End_Of_OpCode
                Case &HD4
                   StrText = "SET 2,H": GoTo End_Of_OpCode
                Case &HD5
                   StrText = "SET 2,L": GoTo End_Of_OpCode
                Case &HD6
                   StrText = "SET 2,(HL)": GoTo End_Of_OpCode
                Case &HD7
                   StrText = "SET 2,A": GoTo End_Of_OpCode
                Case &HD8
                   StrText = "SET 3,B": GoTo End_Of_OpCode
                Case &HD9
                   StrText = "SET 3,C": GoTo End_Of_OpCode
                Case &HDA
                   StrText = "SET 3,D": GoTo End_Of_OpCode
                Case &HDB
                   StrText = "SET 3,E": GoTo End_Of_OpCode
                Case &HDC
                   StrText = "SET 3,H": GoTo End_Of_OpCode
                Case &HDD
                   StrText = "SET 3,L": GoTo End_Of_OpCode
                Case &HDE
                   StrText = "SET 3,(HL)": GoTo End_Of_OpCode
                Case &HDF
                   StrText = "SET 3,A": GoTo End_Of_OpCode
                Case &HE0
                   StrText = "SET 4,B": GoTo End_Of_OpCode
                Case &HE1
                   StrText = "SET 4,C": GoTo End_Of_OpCode
                Case &HE2
                   StrText = "SET 4,D": GoTo End_Of_OpCode
                Case &HE3
                   StrText = "SET 4,E": GoTo End_Of_OpCode
                Case &HE4
                   StrText = "SET 4,H": GoTo End_Of_OpCode
                Case &HE5
                   StrText = "SET 4,L": GoTo End_Of_OpCode
                Case &HE6
                   StrText = "SET 4,(HL)": GoTo End_Of_OpCode
                Case &HE7
                   StrText = "SET 4,A": GoTo End_Of_OpCode
                Case &HE8
                   StrText = "SET 5,B": GoTo End_Of_OpCode
                Case &HE9
                   StrText = "SET 5,C": GoTo End_Of_OpCode
                Case &HEA
                   StrText = "SET 5,D": GoTo End_Of_OpCode
                Case &HEB
                   StrText = "SET 5,E": GoTo End_Of_OpCode
                Case &HEC
                   StrText = "SET 5,H": GoTo End_Of_OpCode
                Case &HED
                   StrText = "SET 5,L": GoTo End_Of_OpCode
                Case &HEE
                   StrText = "SET 5,(HL)": GoTo End_Of_OpCode
                Case &HEF
                   StrText = "SET 5,A": GoTo End_Of_OpCode
                Case &HF0
                   StrText = "SET 6,B": GoTo End_Of_OpCode
                Case &HF1
                   StrText = "SET 6,C": GoTo End_Of_OpCode
                Case &HF2
                   StrText = "SET 6,D": GoTo End_Of_OpCode
                Case &HF3
                   StrText = "SET 6,E": GoTo End_Of_OpCode
                Case &HF4
                   StrText = "SET 6,H": GoTo End_Of_OpCode
                Case &HF5
                   StrText = "SET 6,L": GoTo End_Of_OpCode
                Case &HF6
                   StrText = "SET 6,(HL)": GoTo End_Of_OpCode
                Case &HF7
                   StrText = "SET 6,A": GoTo End_Of_OpCode
                Case &HF8
                   StrText = "SET 7,B": GoTo End_Of_OpCode
                Case &HF9
                   StrText = "SET 7,C": GoTo End_Of_OpCode
                Case &HFA
                   StrText = "SET 7,D": GoTo End_Of_OpCode
                Case &HFB
                   StrText = "SET 7,E": GoTo End_Of_OpCode
                Case &HFC
                   StrText = "SET 7,H": GoTo End_Of_OpCode
                Case &HFD
                   StrText = "SET 7,L": GoTo End_Of_OpCode
                Case &HFE
                   StrText = "SET 7,(HL)": GoTo End_Of_OpCode
                Case &HFF
                   StrText = "SET 7,A": GoTo End_Of_OpCode
                End Select
                 GoTo End_Of_OpCode
        Case &HCC
                   StrText = "CALL Z,nnnn": GoTo End_Of_OpCode
        Case &HCD
                   StrText = "CALL nnnn": GoTo End_Of_OpCode
        Case &HCE
                   StrText = "ADC nn": GoTo End_Of_OpCode
        Case &HCF
                   StrText = "RST 8H": GoTo End_Of_OpCode
        Case &HD0
                   StrText = "RET NC": GoTo End_Of_OpCode
        Case &HD1
                   StrText = "POP DE": GoTo End_Of_OpCode
        Case &HD2
                   StrText = "JP NC,nnnn": GoTo End_Of_OpCode
        Case &HD3
                   StrText = "OUT (nn),A": bINOUTinfo = True: GoTo End_Of_OpCode
        Case &HD4
                   StrText = "CALL NC,nnnn": GoTo End_Of_OpCode
        Case &HD5
                   StrText = "PUSH DE": GoTo End_Of_OpCode
        Case &HD6
                   StrText = "SUB nn": GoTo End_Of_OpCode
        Case &HD7
                   StrText = "RST 10H": GoTo End_Of_OpCode
        Case &HD8
                   StrText = "RET C": GoTo End_Of_OpCode
        Case &HD9
                   StrText = "EXX": GoTo End_Of_OpCode
        Case &HDA
                   StrText = "JP C,nnnn": GoTo End_Of_OpCode
        Case &HDB
                   StrText = "IN A,(nn)": bINOUTinfo = True: GoTo End_Of_OpCode
        Case &HDC
                   StrText = "CALL C,nnnn": GoTo End_Of_OpCode
        Case &HDD
                Opcode = MEM(addr)
                If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
                
 

                                
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(Opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & Opcode
        Case show_str_val
               Select Case Opcode
                Case &H7C, 0
                 StrCode = StrCode & ";" & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & ";" & Chr(&H22) & Chr(Opcode) & Chr(&H22)
               End Select
         
     End Select
     
                addr = addr + 1

                Select Case Opcode
                
                Case &H9
                   StrText = "ADD IX,BC": GoTo End_Of_OpCode
                Case &H19
                   StrText = "ADD IX,DE": GoTo End_Of_OpCode
                Case &H21
                   StrText = "LD IX,nnnn": GoTo End_Of_OpCode
                Case &H22
                   StrText = "LD (nnnn),IX": GoTo End_Of_OpCode
                Case &H23
                   StrText = "INC IX": GoTo End_Of_OpCode
                Case &H24
                   StrText = "INC IXH": GoTo End_Of_OpCode
                Case &H25
                   StrText = "DEC IXH": GoTo End_Of_OpCode
                Case &H26
                   StrText = "LD IXH,nn": GoTo End_Of_OpCode
                Case &H29
                   StrText = "ADD IX,IX": GoTo End_Of_OpCode
                Case &H2A
                   StrText = "LD IX,(nnnn)": GoTo End_Of_OpCode
                Case &H2B
                   StrText = "DEC IX": GoTo End_Of_OpCode
                Case &H2C
                   StrText = "INC IXL": GoTo End_Of_OpCode
                Case &H2D
                   StrText = "DEC IXL": GoTo End_Of_OpCode
                Case &H2E
                   StrText = "LD IXL,nn": GoTo End_Of_OpCode
                Case &H34
                   StrText = "INC (IX+dd)": GoTo End_Of_OpCode
                Case &H35
                   StrText = "DEC (IX+dd)": GoTo End_Of_OpCode
                Case &H36
                   StrText = "LD (IX+dd),nn": GoTo End_Of_OpCode
                Case &H39
                   StrText = "ADD IX,SP": GoTo End_Of_OpCode
                Case &H44
                   StrText = "LD B,IXH": GoTo End_Of_OpCode
                Case &H45
                   StrText = "LD B,IXL": GoTo End_Of_OpCode
                Case &H46
                   StrText = "LD B,(IX+dd)": GoTo End_Of_OpCode
                Case &H4C
                   StrText = "LD C,IXH": GoTo End_Of_OpCode
                Case &H4D
                   StrText = "LD C,IXL": GoTo End_Of_OpCode
                Case &H4E
                   StrText = "LD C,(IX+dd)": GoTo End_Of_OpCode
                Case &H54
                   StrText = "LD D,IXH": GoTo End_Of_OpCode
                Case &H55
                   StrText = "LD D,IXL": GoTo End_Of_OpCode
                Case &H56
                   StrText = "LD D,(IX+dd)": GoTo End_Of_OpCode
                Case &H5C
                   StrText = "LD E,IXH": GoTo End_Of_OpCode
                Case &H5D
                   StrText = "LD E,IXL": GoTo End_Of_OpCode
                Case &H5E
                   StrText = "LD E,(IX+dd)": GoTo End_Of_OpCode
                Case &H60
                   StrText = "LD IXH,B": GoTo End_Of_OpCode
                Case &H61
                   StrText = "LD IXH,C": GoTo End_Of_OpCode
                Case &H62
                   StrText = "LD IXH,D": GoTo End_Of_OpCode
                Case &H63
                   StrText = "LD IXH,E": GoTo End_Of_OpCode
                Case &H64
                   StrText = "LD IXH,IXH": GoTo End_Of_OpCode
                Case &H65
                   StrText = "LD IXH,IXL": GoTo End_Of_OpCode
                Case &H66
                   StrText = "LD H,(IX+dd)": GoTo End_Of_OpCode
                Case &H67
                   StrText = "LD IXH,A": GoTo End_Of_OpCode
                Case &H68
                   StrText = "LD IXL,B": GoTo End_Of_OpCode
                Case &H69
                   StrText = "LD IXL,C": GoTo End_Of_OpCode
                Case &H6A
                   StrText = "LD IXL,D": GoTo End_Of_OpCode
                Case &H6B
                   StrText = "LD IXL,E": GoTo End_Of_OpCode
                Case &H6C
                   StrText = "LD IXL,IXH": GoTo End_Of_OpCode
                Case &H6D
                   StrText = "LD IXL,IXL": GoTo End_Of_OpCode
                Case &H6E
                   StrText = "LD L,(IX+dd)": GoTo End_Of_OpCode
                Case &H6F
                   StrText = "LD IXL,A": GoTo End_Of_OpCode
                Case &H70
                   StrText = "LD (IX+dd),B": GoTo End_Of_OpCode
                Case &H71
                   StrText = "LD (IX+dd),C": GoTo End_Of_OpCode
                Case &H72
                   StrText = "LD (IX+dd),D": GoTo End_Of_OpCode
                Case &H73
                   StrText = "LD (IX+dd),E": GoTo End_Of_OpCode
                Case &H74
                   StrText = "LD (IX+dd),H": GoTo End_Of_OpCode
                Case &H75
                   StrText = "LD (IX+dd),L": GoTo End_Of_OpCode
                Case &H77
                   StrText = "LD (IX+dd),A": GoTo End_Of_OpCode
                Case &H7C, 0
                   StrText = "LD A,IXH": GoTo End_Of_OpCode
                Case &H7D
                   StrText = "LD A,IXL": GoTo End_Of_OpCode
                Case &H7E
                   StrText = "LD A,(IX+dd)": GoTo End_Of_OpCode
                Case &H84
                   StrText = "ADD A,IXH": GoTo End_Of_OpCode
                Case &H85
                   StrText = "ADD A,IXL": GoTo End_Of_OpCode
                Case &H86
                   StrText = "ADD A,(IX+dd)": GoTo End_Of_OpCode
                Case &H8C
                   StrText = "ADC A,IXH": GoTo End_Of_OpCode
                Case &H8D
                   StrText = "ADC A,IXL": GoTo End_Of_OpCode
                Case &H8E
                   StrText = "ADC A,(IX+dd)": GoTo End_Of_OpCode
                Case &H94
                   StrText = "SUB A,IXH": GoTo End_Of_OpCode
                Case &H95
                   StrText = "SUB A,IXL": GoTo End_Of_OpCode
                Case &H96
                   StrText = "SUB A,(IX+dd)": GoTo End_Of_OpCode
                Case &H9C
                   StrText = "SBC A,IXH": GoTo End_Of_OpCode
                Case &H9D
                   StrText = "SBC A,IXL": GoTo End_Of_OpCode
                Case &H9E
                   StrText = "SBC A,(IX+dd)": GoTo End_Of_OpCode
                Case &HA4
                   StrText = "AND A,IXH": GoTo End_Of_OpCode
                Case &HA5
                   StrText = "AND A,IXL": GoTo End_Of_OpCode
                Case &HA6
                   StrText = "AND (IX+dd)": GoTo End_Of_OpCode
                Case &HAC
                   StrText = "XOR IXH": GoTo End_Of_OpCode
                Case &HAD
                   StrText = "XOR IXL": GoTo End_Of_OpCode
                Case &HAE
                   StrText = "XOR (IX+dd)": GoTo End_Of_OpCode
                Case &HB4
                   StrText = "OR A,IXH": GoTo End_Of_OpCode
                Case &HB5
                   StrText = "OR A,IXL": GoTo End_Of_OpCode
                Case &HB6
                   StrText = "OR (IX+dd)": GoTo End_Of_OpCode
                Case &HBC
                   StrText = "CP A,IXH": GoTo End_Of_OpCode
                Case &HBD
                   StrText = "CP A,IXL": GoTo End_Of_OpCode
                Case &HBE
                   StrText = "CP A,(IX+dd)": GoTo End_Of_OpCode
                Case &HCB
                
                Opcode = MEM(addr)
                If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
            


      
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(Opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & Opcode
        Case show_str_val
               Select Case Opcode
                Case &H7C, 0
                 StrCode = StrCode & ";" & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & ";" & Chr(&H22) & Chr(Opcode) & Chr(&H22)
               End Select

     End Select
     

                addr = addr + 1

                
                        Select Case Opcode
                        
                        Case &H0
                   StrText = "LD B,RLC (IX+dd)": GoTo End_Of_OpCode
                        Case &H1
                   StrText = "LD C,RLC (IX+dd)": GoTo End_Of_OpCode
                        Case &H2
                   StrText = "LD D,RLC (IX+dd)": GoTo End_Of_OpCode
                        Case &H3
                   StrText = "LD E,RLC (IX+dd)": GoTo End_Of_OpCode
                        Case &H4
                   StrText = "LD H,RLC (IX+dd)": GoTo End_Of_OpCode
                        Case &H5
                   StrText = "LD L,RLC (IX+dd)": GoTo End_Of_OpCode
                        Case &H6
                   StrText = "RLC (IX+dd)": GoTo End_Of_OpCode
                        Case &H7
                   StrText = "LD A,RLC (IX+dd)": GoTo End_Of_OpCode
                        Case &H8
                   StrText = "LD B,RRC (IX+dd)": GoTo End_Of_OpCode
                        Case &H9
                   StrText = "LD C,RRC (IX+dd)": GoTo End_Of_OpCode
                        Case &HA
                   StrText = "LD D,RRC (IX+dd)": GoTo End_Of_OpCode
                        Case &HB
                   StrText = "LD E,RRC (IX+dd)": GoTo End_Of_OpCode
                        Case &HC
                   StrText = "LD H,RRC (IX+dd)": GoTo End_Of_OpCode
                        Case &HD
                   StrText = "LD L,RRC (IX+dd)": GoTo End_Of_OpCode
                        Case &HE
                   StrText = "RRC (IX+dd)": GoTo End_Of_OpCode
                        Case &HF
                   StrText = "LD A,RRC (IX+dd)": GoTo End_Of_OpCode
                        Case &H10
                   StrText = "LD B,RL (IX+dd)": GoTo End_Of_OpCode
                        Case &H11
                   StrText = "LD C,RL (IX+dd)": GoTo End_Of_OpCode
                        Case &H12
                   StrText = "LD D,RL (IX+dd)": GoTo End_Of_OpCode
                        Case &H13
                   StrText = "LD E,RL (IX+dd)": GoTo End_Of_OpCode
                        Case &H14
                   StrText = "LD H,RL (IX+dd)": GoTo End_Of_OpCode
                        Case &H15
                   StrText = "LD L,RL (IX+dd)": GoTo End_Of_OpCode
                        Case &H16
                   StrText = "RL (IX+dd)": GoTo End_Of_OpCode
                        Case &H17
                   StrText = "LD A,RL (IX+dd)": GoTo End_Of_OpCode
                        Case &H18
                   StrText = "LD B,RR (IX+dd)": GoTo End_Of_OpCode
                        Case &H19
                   StrText = "LD C,RR (IX+dd)": GoTo End_Of_OpCode
                        Case &H1A
                   StrText = "LD D,RR (IX+dd)": GoTo End_Of_OpCode
                        Case &H1B
                   StrText = "LD E,RR (IX+dd)": GoTo End_Of_OpCode
                        Case &H1C
                   StrText = "LD H,RR (IX+dd)": GoTo End_Of_OpCode
                        Case &H1D
                   StrText = "LD L,RR (IX+dd)": GoTo End_Of_OpCode
                        Case &H1E
                   StrText = "RR (IX+dd)": GoTo End_Of_OpCode
                        Case &H1F
                   StrText = "LD A,RR (IX+dd)": GoTo End_Of_OpCode
                        Case &H20
                   StrText = "LD B,SLA (IX+dd)": GoTo End_Of_OpCode
                        Case &H21
                   StrText = "LD C,SLA (IX+dd)": GoTo End_Of_OpCode
                        Case &H22
                   StrText = "LD D,SLA (IX+dd)": GoTo End_Of_OpCode
                        Case &H23
                   StrText = "LD E,SLA (IX+dd)": GoTo End_Of_OpCode
                        Case &H24
                   StrText = "LD H,SLA (IX+dd)": GoTo End_Of_OpCode
                        Case &H25
                   StrText = "LD L,SLA (IX+dd)": GoTo End_Of_OpCode
                        Case &H26
                   StrText = "SLA (IX+dd)": GoTo End_Of_OpCode
                        Case &H27
                   StrText = "LD A,SLA (IX+dd)": GoTo End_Of_OpCode
                        Case &H28
                   StrText = "LD B,SRA (IX+dd)": GoTo End_Of_OpCode
                        Case &H29
                   StrText = "LD C,SRA (IX+dd)": GoTo End_Of_OpCode
                        Case &H2A
                   StrText = "LD D,SRA (IX+dd)": GoTo End_Of_OpCode
                        Case &H2B
                   StrText = "LD E,SRA (IX+dd)": GoTo End_Of_OpCode
                        Case &H2C
                   StrText = "LD H,SRA (IX+dd)": GoTo End_Of_OpCode
                        Case &H2D
                   StrText = "LD L,SRA (IX+dd)": GoTo End_Of_OpCode
                        Case &H2E
                   StrText = "SRA (IX+dd)": GoTo End_Of_OpCode
                        Case &H2F
                   StrText = "LD A,SRA (IX+dd)": GoTo End_Of_OpCode
                        Case &H30
                   StrText = "LD B,SLL (IX+dd)": GoTo End_Of_OpCode
                        Case &H31
                   StrText = "LD C,SLL (IX+dd)": GoTo End_Of_OpCode
                        Case &H32
                   StrText = "LD D,SLL (IX+dd)": GoTo End_Of_OpCode
                        Case &H33
                   StrText = "LD E,SLL (IX+dd)": GoTo End_Of_OpCode
                        Case &H34
                   StrText = "LD H,SLL (IX+dd)": GoTo End_Of_OpCode
                        Case &H35
                   StrText = "LD L,SLL (IX+dd)": GoTo End_Of_OpCode
                        Case &H36
                   StrText = "SLL (IX+dd)": GoTo End_Of_OpCode
                        Case &H37
                   StrText = "LD A,SLL (IX+dd)": GoTo End_Of_OpCode
                        Case &H38
                   StrText = "LD B,SRL (IX+dd)": GoTo End_Of_OpCode
                        Case &H39
                   StrText = "LD C,SRL (IX+dd)": GoTo End_Of_OpCode
                        Case &H3A
                   StrText = "LD D,SRL (IX+dd)": GoTo End_Of_OpCode
                        Case &H3B
                   StrText = "LD E,SRL (IX+dd)": GoTo End_Of_OpCode
                        Case &H3C
                   StrText = "LD H,SRL (IX+dd)": GoTo End_Of_OpCode
                        Case &H3D
                   StrText = "LD L,SRL (IX+dd)": GoTo End_Of_OpCode
                        Case &H3E
                   StrText = "SRL (IX+dd)": GoTo End_Of_OpCode
                        Case &H3F
                   StrText = "LD A,SRL (IX+dd)": GoTo End_Of_OpCode
                        Case &H40
                        Case &H41
                        Case &H42
                        Case &H43
                        Case &H44
                        Case &H45
                        Case &H46
                        Case &H47
                   StrText = "BIT 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &H48
                        Case &H49
                        Case &H4A
                        Case &H4B
                        Case &H4C
                        Case &H4D
                        Case &H4E
                        Case &H4F
                   StrText = "BIT 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &H50
                        Case &H51
                        Case &H52
                        Case &H53
                        Case &H54
                        Case &H55
                        Case &H56
                        Case &H57
                   StrText = "BIT 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &H58
                        Case &H59
                        Case &H5A
                        Case &H5B
                        Case &H5C
                        Case &H5D
                        Case &H5E
                        Case &H5F
                   StrText = "BIT 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &H60
                        Case &H61
                        Case &H62
                        Case &H63
                        Case &H64
                        Case &H65
                        Case &H66
                        Case &H67
                   StrText = "BIT 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &H68
                        Case &H69
                        Case &H6A
                        Case &H6B
                        Case &H6C
                        Case &H6D
                        Case &H6E
                        Case &H6F
                   StrText = "BIT 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &H70
                        Case &H71
                        Case &H72
                        Case &H73
                        Case &H74
                        Case &H75
                        Case &H76
                        Case &H77
                   StrText = "BIT 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &H78
                        Case &H79
                        Case &H7A
                        Case &H7B
                        Case &H7C, 0
                        Case &H7D
                        Case &H7E
                        Case &H7F
                   StrText = "BIT 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &H80
                   StrText = "LD B,RES 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &H81
                   StrText = "LD C,RES 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &H82
                   StrText = "LD D,RES 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &H83
                   StrText = "LD E,RES 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &H84
                   StrText = "LD H,RES 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &H85
                   StrText = "LD L,RES 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &H86
                   StrText = "RES 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &H87
                   StrText = "LD A,RES 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &H88
                   StrText = "LD B,RES 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &H89
                   StrText = "LD C,RES 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &H8A
                   StrText = "LD D,RES 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &H8B
                   StrText = "LD E,RES 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &H8C
                   StrText = "LD H,RES 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &H8D
                   StrText = "LD L,RES 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &H8E
                   StrText = "RES 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &H8F
                   StrText = "LD A,RES 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &H90
                   StrText = "LD B,RES 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &H91
                   StrText = "LD C,RES 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &H92
                   StrText = "LD D,RES 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &H93
                   StrText = "LD E,RES 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &H94
                   StrText = "LD H,RES 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &H95
                   StrText = "LD L,RES 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &H96
                   StrText = "RES 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &H97
                   StrText = "LD A,RES 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &H98
                   StrText = "LD B,RES 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &H99
                   StrText = "LD C,RES 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &H9A
                   StrText = "LD D,RES 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &H9B
                   StrText = "LD E,RES 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &H9C
                   StrText = "LD H,RES 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &H9D
                   StrText = "LD L,RES 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &H9E
                   StrText = "RES 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &H9F
                   StrText = "LD A,RES 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &HA0
                   StrText = "LD B,RES 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HA1
                   StrText = "LD C,RES 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HA2
                   StrText = "LD D,RES 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HA3
                   StrText = "LD E,RES 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HA4
                   StrText = "LD H,RES 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HA5
                   StrText = "LD L,RES 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HA6
                   StrText = "RES 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HA7
                   StrText = "LD A,RES 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HA8
                   StrText = "LD B,RES 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HA9
                   StrText = "LD C,RES 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HAA
                   StrText = "LD D,RES 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HAB
                   StrText = "LD E,RES 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HAC
                   StrText = "LD H,RES 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HAD
                   StrText = "LD L,RES 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HAE
                   StrText = "RES 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HAF
                   StrText = "LD A,RES 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HB0
                   StrText = "LD B,RES 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HB1
                   StrText = "LD C,RES 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HB2
                   StrText = "LD D,RES 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HB3
                   StrText = "LD E,RES 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HB4
                   StrText = "LD H,RES 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HB5
                   StrText = "LD L,RES 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HB6
                   StrText = "RES 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HB7
                   StrText = "LD A,RES 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HB8
                   StrText = "LD B,RES 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HB9
                   StrText = "LD C,RES 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HBA
                   StrText = "LD D,RES 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HBB
                   StrText = "LD E,RES 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HBC
                   StrText = "LD H,RES 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HBD
                   StrText = "LD L,RES 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HBE
                   StrText = "RES 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HBF
                   StrText = "LD A,RES 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HC0
                   StrText = "LD B,SET 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &HC1
                   StrText = "LD C,SET 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &HC2
                   StrText = "LD D,SET 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &HC3
                   StrText = "LD E,SET 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &HC4
                   StrText = "LD H,SET 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &HC5
                   StrText = "LD L,SET 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &HC6
                   StrText = "SET 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &HC7
                   StrText = "LD A,SET 0,(IX+dd)": GoTo End_Of_OpCode
                        Case &HC8
                   StrText = "LD B,SET 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &HC9
                   StrText = "LD C,SET 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &HCA
                   StrText = "LD D,SET 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &HCB
                   StrText = "LD E,SET 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &HCC
                   StrText = "LD H,SET 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &HCD
                   StrText = "LD L,SET 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &HCE
                   StrText = "SET 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &HCF
                   StrText = "LD A,SET 1,(IX+dd)": GoTo End_Of_OpCode
                        Case &HD0
                   StrText = "LD B,SET 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &HD1
                   StrText = "LD C,SET 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &HD2
                   StrText = "LD D,SET 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &HD3
                   StrText = "LD E,SET 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &HD4
                   StrText = "LD H,SET 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &HD5
                   StrText = "LD L,SET 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &HD6
                   StrText = "SET 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &HD7
                   StrText = "LD A,SET 2,(IX+dd)": GoTo End_Of_OpCode
                        Case &HD8
                   StrText = "LD B,SET 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &HD9
                   StrText = "LD C,SET 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &HDA
                   StrText = "LD D,SET 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &HDB
                   StrText = "LD E,SET 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &HDC
                   StrText = "LD H,SET 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &HDD
                   StrText = "LD L,SET 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &HDE
                   StrText = "SET 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &HDF
                   StrText = "LD A,SET 3,(IX+dd)": GoTo End_Of_OpCode
                        Case &HE0
                   StrText = "LD B,SET 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HE1
                   StrText = "LD C,SET 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HE2
                   StrText = "LD D,SET 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HE3
                   StrText = "LD E,SET 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HE4
                   StrText = "LD H,SET 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HE5
                   StrText = "LD L,SET 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HE6
                   StrText = "SET 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HE7
                   StrText = "LD A,SET 4,(IX+dd)": GoTo End_Of_OpCode
                        Case &HE8
                   StrText = "LD B,SET 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HE9
                   StrText = "LD C,SET 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HEA
                   StrText = "LD D,SET 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HEB
                   StrText = "LD E,SET 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HEC
                   StrText = "LD H,SET 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HED
                   StrText = "LD L,SET 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HEE
                   StrText = "SET 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HEF
                   StrText = "LD A,SET 5,(IX+dd)": GoTo End_Of_OpCode
                        Case &HF0
                   StrText = "LD B,SET 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HF1
                   StrText = "LD C,SET 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HF2
                   StrText = "LD D,SET 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HF3
                   StrText = "LD E,SET 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HF4
                   StrText = "LD H,SET 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HF5
                   StrText = "LD L,SET 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HF6
                   StrText = "SET 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HF7
                   StrText = "LD A,SET 6,(IX+dd)": GoTo End_Of_OpCode
                        Case &HF8
                   StrText = "LD B,SET 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HF9
                   StrText = "LD C,SET 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HFA
                   StrText = "LD D,SET 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HFB
                   StrText = "LD E,SET 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HFC
                   StrText = "LD H,SET 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HFD
                   StrText = "LD L,SET 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HFE
                   StrText = "SET 7,(IX+dd)": GoTo End_Of_OpCode
                        Case &HFF
                   StrText = "LD A,SET 7,(IX+dd)": GoTo End_Of_OpCode
                End Select
                GoTo End_Of_OpCode
                
                Case &HE1
                   StrText = "POP IX": GoTo End_Of_OpCode
                Case &HE3
                   StrText = "EX (SP),IX": GoTo End_Of_OpCode
                Case &HE5
                   StrText = "PUSH IX": GoTo End_Of_OpCode
                Case &HE9
                   StrText = "JP IX": GoTo End_Of_OpCode
                Case &HF9
                   StrText = "LD SP,IX": GoTo End_Of_OpCode
                End Select
                
        Case &HDE
                   StrText = "SBC A,nn": GoTo End_Of_OpCode
        Case &HDF
                   StrText = "RST 18H": GoTo End_Of_OpCode
        Case &HE0
                   StrText = "RET PO": GoTo End_Of_OpCode
        Case &HE1
                   StrText = "POP HL": GoTo End_Of_OpCode
        Case &HE2
                   StrText = "JP PO,nnnn": GoTo End_Of_OpCode
        Case &HE3
                   StrText = "EX (SP),HL": GoTo End_Of_OpCode
        Case &HE4
                   StrText = "CALL PO,nnnn": GoTo End_Of_OpCode
        Case &HE5
                   StrText = "PUSH HL": GoTo End_Of_OpCode
        Case &HE6
                   StrText = "AND nn": GoTo End_Of_OpCode
        Case &HE7
                   StrText = "RST 20H": GoTo End_Of_OpCode
        Case &HE8
                   StrText = "RET PE": GoTo End_Of_OpCode
        Case &HE9
                   StrText = "JP HL": GoTo End_Of_OpCode
        Case &HEA
                   StrText = "JP PE,nnnn": GoTo End_Of_OpCode
        Case &HEB
                   StrText = "EX DE,HL": GoTo End_Of_OpCode
        Case &HEC
                   StrText = "CALL PE,nnnn": GoTo End_Of_OpCode
        Case &HED
                Opcode = MEM(addr)
                If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
                


     
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(Opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & Opcode
        Case show_str_val
               Select Case Opcode
                Case &H7C, 0
                 StrCode = StrCode & ";" & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & ";" & Chr(&H22) & Chr(Opcode) & Chr(&H22)
               End Select

     End Select
     

                addr = addr + 1

                Select Case Opcode
                
                Case &H40
                   StrText = "IN B,(C)":  GoTo End_Of_OpCode
                Case &H41
                   StrText = "OUT (C),B": GoTo End_Of_OpCode
                Case &H42
                   StrText = "SBC HL,BC": GoTo End_Of_OpCode
                Case &H43
                   StrText = "LD (nnnn),BC": GoTo End_Of_OpCode
                Case &H44
                   StrText = "NEG": GoTo End_Of_OpCode
                Case &H45
                   StrText = "RETN": GoTo End_Of_OpCode
                Case &H46
                   StrText = "IM 0": GoTo End_Of_OpCode
                Case &H47
                   StrText = "LD I,A": GoTo End_Of_OpCode
                Case &H48 '72
                   StrText = "IN C,(nn)": bINOUTinfo = True: GoTo End_Of_OpCode
                Case &H49
                   StrText = "OUT (nn),C": bINOUTinfo = True: GoTo End_Of_OpCode
                Case &H4A '74
                   StrText = "ADC HL,BC": GoTo End_Of_OpCode
                Case &H4B '75
                   StrText = "LD BC,(nnnn)": GoTo End_Of_OpCode
                Case &H4C
                   StrText = "NEG": GoTo End_Of_OpCode
                Case &H4D '77
                   StrText = "RETI": GoTo End_Of_OpCode
                Case &H4E '78
                   StrText = "IM 0": GoTo End_Of_OpCode
                Case &H4F '79
                   StrText = "LD R,A": GoTo End_Of_OpCode
                Case &H50 '80
                   StrText = "IN D,(c)":  GoTo End_Of_OpCode
                Case &H51 '81
                   StrText = "OUT (c),D":  GoTo End_Of_OpCode
                Case &H52 '82
                   StrText = "SBC HL,DE": GoTo End_Of_OpCode
                Case &H53 '83
                   StrText = "LD (nnnn),DE": GoTo End_Of_OpCode
                Case &H54 '84
                   StrText = "NEG": GoTo End_Of_OpCode
                Case &H55 '85
                   StrText = "RETn": GoTo End_Of_OpCode
                Case &H56 '86
                   StrText = "IM 1": GoTo End_Of_OpCode
                Case &H57 '87
                   StrText = "LD A,I": GoTo End_Of_OpCode
                Case &H58 '88
                   StrText = "IN E,(c)": GoTo End_Of_OpCode
                Case &H59 '89
                   StrText = "OUT (c),E": GoTo End_Of_OpCode
                Case &H5A '90
                   StrText = "ADC HL,DE": GoTo End_Of_OpCode
                Case &H5B '91
                   StrText = "LD DE,(nnnn)": GoTo End_Of_OpCode
                Case &H5C '92
                   StrText = "NEG": GoTo End_Of_OpCode
                Case &H5D '93
                   StrText = "RETI": GoTo End_Of_OpCode
                Case &H5E '94
                   StrText = "IM 2": GoTo End_Of_OpCode
                Case &H5F '95
                   StrText = "LD A,R": GoTo End_Of_OpCode
                Case &H60 '96
                   StrText = "IN H,(c)":  GoTo End_Of_OpCode
                Case &H61 '97
                   StrText = "OUT (c),H": GoTo End_Of_OpCode
                Case &H62 '98
                   StrText = "SBC HL,HL": GoTo End_Of_OpCode
                Case &H63 '99
                   StrText = "LD (nnnn),HL": GoTo End_Of_OpCode
                Case &H64 '100
                   StrText = "NEG": GoTo End_Of_OpCode
                Case &H65 '101
                   StrText = "RETn": GoTo End_Of_OpCode
                Case &H66 '102
                   StrText = "IM 0": GoTo End_Of_OpCode
                Case &H67 '103
                   StrText = "RRD": GoTo End_Of_OpCode
                Case &H68 '104
                   StrText = "IN L,(c)":  GoTo End_Of_OpCode
                Case &H69 '105
                   StrText = "OUT (c),L": GoTo End_Of_OpCode
                Case &H6A '106
                   StrText = "ADC HL,HL": GoTo End_Of_OpCode
                Case &H6B '107
                   StrText = "LD HL,(nnnn)": GoTo End_Of_OpCode
                Case &H6C '108
                   StrText = "NEG": GoTo End_Of_OpCode
                Case &H6D '109
                   StrText = "RETI": GoTo End_Of_OpCode
                Case &H6E '110
                   StrText = "IM 0": GoTo End_Of_OpCode
                Case &H6F '111
                   StrText = "RLD": GoTo End_Of_OpCode
                Case &H70 '112
                   StrText = "IN (c)":  GoTo End_Of_OpCode
                Case &H71 '113
                   StrText = "OUT (c),0": GoTo End_Of_OpCode
                Case &H72 '114
                   StrText = "SBC HL,SP": GoTo End_Of_OpCode
                Case &H73 '115
                   StrText = "LD (nnnn),SP": GoTo End_Of_OpCode
                Case &H74 '116
                   StrText = "NEG": GoTo End_Of_OpCode
                Case &H75 '117
                   StrText = "RETn": GoTo End_Of_OpCode
                Case &H76 '118
                   StrText = "IM 1": GoTo End_Of_OpCode
                Case &H77 '119
                   StrText = "Unknown": GoTo End_Of_OpCode
                Case &H78 '120
                   StrText = "IN A,(c)":  GoTo End_Of_OpCode
                Case &H79 '121
                   StrText = "OUT (c),A": GoTo End_Of_OpCode
                Case &H80 '122
                   StrText = "ADC HL,SP": GoTo End_Of_OpCode
                Case &H81 '123
                   StrText = "LD SP,(nnnn)": GoTo End_Of_OpCode
                Case &H82 '124
                   StrText = "NEG": GoTo End_Of_OpCode
                Case &H83 '125
                   StrText = "RETI": GoTo End_Of_OpCode
                Case &H84 '126
                   StrText = "IM 2": GoTo End_Of_OpCode
                Case &H85 '127
                   StrText = "NOP": GoTo End_Of_OpCode
                Case &H6E
                   StrText = "IM 0": GoTo End_Of_OpCode
                Case &H47
                   StrText = "LD I,A": GoTo End_Of_OpCode
                Case &H48
                   StrText = "IN C,(C)":  GoTo End_Of_OpCode
                Case &H49
                   StrText = "OUT (C),C": GoTo End_Of_OpCode
                Case &H4A
                   StrText = "ADC HL,BC": GoTo End_Of_OpCode
                Case &H4B
                   StrText = "LD BC,(nnnn)": GoTo End_Of_OpCode
                Case &H4F
                   StrText = "LD R,A": GoTo End_Of_OpCode
                Case &H50
                   StrText = "IN D,(C)":  GoTo End_Of_OpCode
                Case &H51
                   StrText = "OUT (C),D": GoTo End_Of_OpCode
                Case &H52
                   StrText = "SBC HL,DE": GoTo End_Of_OpCode
                Case &H53
                   StrText = "LD (nnnn),DE": GoTo End_Of_OpCode
                Case &H56:
                Case &H76
                   StrText = "IM 1": GoTo End_Of_OpCode
                Case &H57
                   StrText = "LD A,I": GoTo End_Of_OpCode
                Case &H58
                   StrText = "IN E,(C)":  GoTo End_Of_OpCode
                Case &H59
                   StrText = "OUT (C),E": GoTo End_Of_OpCode
                Case &H5A
                   StrText = "ADC HL,DE": GoTo End_Of_OpCode
                Case &H5B
                   StrText = "LD DE,(nnnn)": GoTo End_Of_OpCode
                Case &H5E
                Case &H7E
                   StrText = "IM 2": GoTo End_Of_OpCode
                Case &H5F
                   StrText = "LD A,R": GoTo End_Of_OpCode
                Case &H60
                   StrText = "IN H,(C)":  GoTo End_Of_OpCode
                Case &H61
                   StrText = "OUT (C),H": GoTo End_Of_OpCode
                Case &H62
                   StrText = "SBC HL,HL": GoTo End_Of_OpCode
                Case &H63
                   StrText = "LD (nnnn),HL": GoTo End_Of_OpCode
                Case &H67
                   StrText = "RRD": GoTo End_Of_OpCode
                Case &H68
                   StrText = "IN L,(C)":  GoTo End_Of_OpCode
                Case &H69
                   StrText = "OUT (C),L": GoTo End_Of_OpCode
                Case &H6A
                   StrText = "ADC HL,HL": GoTo End_Of_OpCode
                Case &H6B
                   StrText = "LD HL,(nnnn)": GoTo End_Of_OpCode
                Case &H6F
                   StrText = "RLD": GoTo End_Of_OpCode
                Case &H70
                   StrText = "IN F,(C)":  GoTo End_Of_OpCode
                Case &H71
                   StrText = "OUT (C),0": GoTo End_Of_OpCode
                Case &H72
                   StrText = "SBC HL,SP": GoTo End_Of_OpCode
                Case &H73
                   StrText = "LD (nnnn),SP": GoTo End_Of_OpCode
                Case &H78
                   StrText = "IN A,(C)":  GoTo End_Of_OpCode
                Case &H79
                   StrText = "OUT (C),A": GoTo End_Of_OpCode
                Case &H7A
                   StrText = "ADC HL,SP": GoTo End_Of_OpCode
                Case &H7B
                   StrText = "LD SP,(nnnn)": GoTo End_Of_OpCode
                Case &HA0
                   StrText = "LDI": GoTo End_Of_OpCode
                Case &HA1
                   StrText = "CPI": GoTo End_Of_OpCode
                Case &HA2
                   StrText = "INI": GoTo End_Of_OpCode
                Case &HA3
                   StrText = "OUTI": GoTo End_Of_OpCode
                Case &HA8
                   StrText = "LDD": GoTo End_Of_OpCode
                Case &HA9
                   StrText = "CPD": GoTo End_Of_OpCode
                Case &HAA
                   StrText = "IND": GoTo End_Of_OpCode
                Case &HAB
                   StrText = "OUTD": GoTo End_Of_OpCode
                Case &HB0
                   StrText = "LDIR": GoTo End_Of_OpCode
                Case &HB1
                   StrText = "CPIR": GoTo End_Of_OpCode
                Case &HB2
                   StrText = "INIR": GoTo End_Of_OpCode
                Case &HB3
                   StrText = "OTIR": GoTo End_Of_OpCode
                Case &HB8
                   StrText = "LDDR": GoTo End_Of_OpCode
                Case &HB9
                   StrText = "CPDR": GoTo End_Of_OpCode
                Case &HBA
                   StrText = "INDR": GoTo End_Of_OpCode
                Case &HBB
                   StrText = "OTDR": GoTo End_Of_OpCode
                   
                Case &HFC
                   StrText = "???": GoTo End_Of_OpCode
                Case &HFD
                   StrText = "???": GoTo End_Of_OpCode
                
                Case &HFE
                   StrText = "???": GoTo End_Of_OpCode
                   
                Case &HFF
                   StrText = "???": GoTo End_Of_OpCode
                   
                
                End Select
                GoTo End_Of_OpCode
        Case &HEE
                   StrText = "XOR nn": GoTo End_Of_OpCode
        Case &HEF
                   StrText = "RST 28H": GoTo End_Of_OpCode
        Case &HF0
                   StrText = "RET P": GoTo End_Of_OpCode
        Case &HF1
                   StrText = "POP AF": GoTo End_Of_OpCode
        Case &HF2
                   StrText = "JP P,nnnn": GoTo End_Of_OpCode
        Case &HF3
                   StrText = "DI": GoTo End_Of_OpCode
        Case &HF4
                   StrText = "CALL P,nnnn": GoTo End_Of_OpCode
        Case &HF5
                   StrText = "PUSH AF": GoTo End_Of_OpCode
        Case &HF6
                   StrText = "OR nn": GoTo End_Of_OpCode
        Case &HF7
                   StrText = "RST 30H": GoTo End_Of_OpCode
        Case &HF8
                   StrText = "RET M": GoTo End_Of_OpCode
        Case &HF9
                   StrText = "LD SP,HL": GoTo End_Of_OpCode
        Case &HFA
                   StrText = "JP M,nnnn": GoTo End_Of_OpCode
        Case &HFB
                   StrText = "EI": GoTo End_Of_OpCode
        Case &HFC
                   StrText = "CALL M,nnnn": GoTo End_Of_OpCode
        Case &HFD
                Opcode = MEM(addr)
                If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
                  


                                   
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(Opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & Opcode
        Case show_str_val
               Select Case Opcode
                Case &H7C, 0
                 StrCode = StrCode & ";" & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & ";" & Chr(&H22) & Chr(Opcode) & Chr(&H22)
               End Select

     End Select
      
                addr = addr + 1


                Select Case Opcode
                
                Case &H9
                   StrText = "ADD IY,BC": GoTo End_Of_OpCode
                Case &H19
                   StrText = "ADD IY,DE": GoTo End_Of_OpCode
                Case &H21
                   StrText = "LD IY,nnnn": GoTo End_Of_OpCode
                Case &H22
                   StrText = "LD (nnnn),IY": GoTo End_Of_OpCode
                Case &H23
                   StrText = "INC IY": GoTo End_Of_OpCode
                Case &H24
                   StrText = "INC IYH": GoTo End_Of_OpCode
                Case &H25
                   StrText = "DEC IYH": GoTo End_Of_OpCode
                Case &H26
                   StrText = "LD IYH,nn": GoTo End_Of_OpCode
                Case &H29
                   StrText = "ADD IY,IY": GoTo End_Of_OpCode
                Case &H2A
                   StrText = "LD IY,(nnnn)": GoTo End_Of_OpCode
                Case &H2B
                   StrText = "DEC IY": GoTo End_Of_OpCode
                Case &H2C
                   StrText = "INC IYL": GoTo End_Of_OpCode
                Case &H2D
                   StrText = "DEC IYL": GoTo End_Of_OpCode
                Case &H2E
                   StrText = "LD IYL,nn": GoTo End_Of_OpCode
                Case &H34
                   StrText = "INC (IY+dd)": GoTo End_Of_OpCode
                Case &H35
                   StrText = "DEC (IY+dd)": GoTo End_Of_OpCode
                Case &H36
                   StrText = "LD (IY+dd),nn": GoTo End_Of_OpCode
                Case &H39
                   StrText = "ADD IY,SP": GoTo End_Of_OpCode
                Case &H44
                   StrText = "LD B,IYH": GoTo End_Of_OpCode
                Case &H45
                   StrText = "LD B,IYL": GoTo End_Of_OpCode
                Case &H46
                   StrText = "LD B,(IY+dd)": GoTo End_Of_OpCode
                Case &H4C
                   StrText = "LD C,IYH": GoTo End_Of_OpCode
                Case &H4D
                   StrText = "LD C,IYL": GoTo End_Of_OpCode
                Case &H4E
                   StrText = "LD C,(IY+dd)": GoTo End_Of_OpCode
                Case &H54
                   StrText = "LD D,IYH": GoTo End_Of_OpCode
                Case &H55
                   StrText = "LD D,IYL": GoTo End_Of_OpCode
                Case &H56
                   StrText = "LD D,(IY+dd)": GoTo End_Of_OpCode
                Case &H5C
                   StrText = "LD E,IYH": GoTo End_Of_OpCode
                Case &H5D
                   StrText = "LD E,IYL": GoTo End_Of_OpCode
                Case &H5E
                   StrText = "LD E,(IY+dd)": GoTo End_Of_OpCode
                Case &H60
                   StrText = "LD IYH,B": GoTo End_Of_OpCode
                Case &H61
                   StrText = "LD IYH,C": GoTo End_Of_OpCode
                Case &H62
                   StrText = "LD IYH,D": GoTo End_Of_OpCode
                Case &H63
                   StrText = "LD IYH,E": GoTo End_Of_OpCode
                Case &H64
                   StrText = "LD IYH,IYH": GoTo End_Of_OpCode
                Case &H65
                   StrText = "LD IYH,IYL": GoTo End_Of_OpCode
                Case &H66
                   StrText = "LD H,(IY+dd)": GoTo End_Of_OpCode
                Case &H67
                   StrText = "LD IYH,A": GoTo End_Of_OpCode
                Case &H68
                   StrText = "LD IYL,B": GoTo End_Of_OpCode
                Case &H69
                   StrText = "LD IYL,C": GoTo End_Of_OpCode
                Case &H6A
                   StrText = "LD IYL,D": GoTo End_Of_OpCode
                Case &H6B
                   StrText = "LD IYL,E": GoTo End_Of_OpCode
                Case &H6C
                   StrText = "LD IYL,IYH": GoTo End_Of_OpCode
                Case &H6D
                   StrText = "LD IYL,IYL": GoTo End_Of_OpCode
                Case &H6E
                   StrText = "LD L,(IY+dd)": GoTo End_Of_OpCode
                Case &H6F
                   StrText = "LD IYL,A": GoTo End_Of_OpCode
                Case &H70
                   StrText = "LD (IY+dd),B": GoTo End_Of_OpCode
                Case &H71
                   StrText = "LD (IY+dd),C": GoTo End_Of_OpCode
                Case &H72
                   StrText = "LD (IY+dd),D": GoTo End_Of_OpCode
                Case &H73
                   StrText = "LD (IY+dd),E": GoTo End_Of_OpCode
                Case &H74
                   StrText = "LD (IY+dd),H": GoTo End_Of_OpCode
                Case &H75
                   StrText = "LD (IY+dd),L": GoTo End_Of_OpCode
                Case &H77
                   StrText = "LD (IY+dd),A": GoTo End_Of_OpCode
                Case &H7C, 0
                   StrText = "LD A,IYH": GoTo End_Of_OpCode
                Case &H7D
                   StrText = "LD A,IYL": GoTo End_Of_OpCode
                Case &H7E
                   StrText = "LD A,(IY+dd)": GoTo End_Of_OpCode
                Case &H84
                   StrText = "ADD A,IYH": GoTo End_Of_OpCode
                Case &H85
                   StrText = "ADD A,IYL": GoTo End_Of_OpCode
                Case &H86
                   StrText = "ADD A,(IY+dd)": GoTo End_Of_OpCode
                Case &H8C
                   StrText = "ADC A,IYH": GoTo End_Of_OpCode
                Case &H8D
                   StrText = "ADC A,IYL": GoTo End_Of_OpCode
                Case &H8E
                   StrText = "ADC A,(IY+dd)": GoTo End_Of_OpCode
                Case &H94
                   StrText = "SUB A,IYH": GoTo End_Of_OpCode
                Case &H95
                   StrText = "SUB A,IYL": GoTo End_Of_OpCode
                Case &H96
                   StrText = "SUB A,(IY+dd)": GoTo End_Of_OpCode
                Case &H9C
                   StrText = "SBC A,IYH": GoTo End_Of_OpCode
                Case &H9D
                   StrText = "SBC A,IYL": GoTo End_Of_OpCode
                Case &H9E
                   StrText = "SBC A,(IY+dd)": GoTo End_Of_OpCode
                Case &HA4
                   StrText = "AND IYH": GoTo End_Of_OpCode
                Case &HA5
                   StrText = "AND IYL": GoTo End_Of_OpCode
                Case &HA6
                   StrText = "AND (IY+dd)": GoTo End_Of_OpCode
                Case &HAC
                   StrText = "XOR IYH": GoTo End_Of_OpCode
                Case &HAD
                   StrText = "XOR IYL": GoTo End_Of_OpCode
                Case &HAE
                   StrText = "XOR (IY+dd)": GoTo End_Of_OpCode
                Case &HB4
                   StrText = "OR IYH": GoTo End_Of_OpCode
                Case &HB5
                   StrText = "OR IYL": GoTo End_Of_OpCode
                Case &HB6
                   StrText = "OR (IY+dd)": GoTo End_Of_OpCode
                Case &HBC
                   StrText = "CP IYH": GoTo End_Of_OpCode
                Case &HBD
                   StrText = "CP IYL": GoTo End_Of_OpCode
                Case &HBE
                   StrText = "CP (IY+dd)": GoTo End_Of_OpCode
                Case &HCB
                
                Opcode = MEM(addr)
                If (addr >= 32768 And Not (Opcode And 64)) Then Opcode = 0
   


                                   
     Select Case Distag
        Case show_hex_val
         StrCode = StrCode & ";" & Hex8(CLng(Opcode))
        Case show_dec_val
         StrCode = StrCode & ";" & Opcode
        Case show_str_val
               Select Case Opcode
                Case &H7C, 0
                 StrCode = StrCode & ";" & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & ";" & Chr(&H22) & Chr(Opcode) & Chr(&H22)
               End Select

     End Select
     
                addr = addr + 1

                        Select Case Opcode
                        
                        Case &H0
                   StrText = "LD B,RLC (IY+dd)": GoTo End_Of_OpCode
                        Case &H1
                   StrText = "LD C,RLC (IY+dd)": GoTo End_Of_OpCode
                        Case &H2
                   StrText = "LD D,RLC (IY+dd)": GoTo End_Of_OpCode
                        Case &H3
                   StrText = "LD E,RLC (IY+dd)": GoTo End_Of_OpCode
                        Case &H4
                   StrText = "LD H,RLC (IY+dd)": GoTo End_Of_OpCode
                        Case &H5
                   StrText = "LD L,RLC (IY+dd)": GoTo End_Of_OpCode
                        Case &H6
                   StrText = "RLC (IY+dd)": GoTo End_Of_OpCode
                        Case &H7
                   StrText = "LD A,RLC (IY+dd)": GoTo End_Of_OpCode
                        Case &H8
                   StrText = "LD B,RRC (IY+dd)": GoTo End_Of_OpCode
                        Case &H9
                   StrText = "LD C,RRC (IY+dd)": GoTo End_Of_OpCode
                        Case &HA
                   StrText = "LD D,RRC (IY+dd)": GoTo End_Of_OpCode
                        Case &HB
                   StrText = "LD E,RRC (IY+dd)": GoTo End_Of_OpCode
                        Case &HC
                   StrText = "LD H,RRC (IY+dd)": GoTo End_Of_OpCode
                        Case &HD
                   StrText = "LD L,RRC (IY+dd)": GoTo End_Of_OpCode
                        Case &HE
                   StrText = "RRC (IY+dd)": GoTo End_Of_OpCode
                        Case &HF
                   StrText = "LD A,RRC (IY+dd)": GoTo End_Of_OpCode
                        Case &H10
                   StrText = "LD B,RL (IY+dd)": GoTo End_Of_OpCode
                        Case &H11
                   StrText = "LD C,RL (IY+dd)": GoTo End_Of_OpCode
                        Case &H12
                   StrText = "LD D,RL (IY+dd)": GoTo End_Of_OpCode
                        Case &H13
                   StrText = "LD E,RL (IY+dd)": GoTo End_Of_OpCode
                        Case &H14
                   StrText = "LD H,RL (IY+dd)": GoTo End_Of_OpCode
                        Case &H15
                   StrText = "LD L,RL (IY+dd)": GoTo End_Of_OpCode
                        Case &H16
                   StrText = "RL (IY+dd)": GoTo End_Of_OpCode
                        Case &H17
                   StrText = "LD A,RL (IY+dd)": GoTo End_Of_OpCode
                        Case &H18
                   StrText = "LD B,RR (IY+dd)": GoTo End_Of_OpCode
                        Case &H19
                   StrText = "LD C,RR (IY+dd)": GoTo End_Of_OpCode
                        Case &H1A
                   StrText = "LD D,RR (IY+dd)": GoTo End_Of_OpCode
                        Case &H1B
                   StrText = "LD E,RR (IY+dd)": GoTo End_Of_OpCode
                        Case &H1C
                   StrText = "LD H,RR (IY+dd)": GoTo End_Of_OpCode
                        Case &H1D
                   StrText = "LD L,RR (IY+dd)": GoTo End_Of_OpCode
                        Case &H1E
                   StrText = "RR (IY+dd)": GoTo End_Of_OpCode
                        Case &H1F
                   StrText = "LD A,RR (IY+dd)": GoTo End_Of_OpCode
                        Case &H20
                   StrText = "LD B,SLA (IY+dd)": GoTo End_Of_OpCode
                        Case &H21
                   StrText = "LD C,SLA (IY+dd)": GoTo End_Of_OpCode
                        Case &H22
                   StrText = "LD D,SLA (IY+dd)": GoTo End_Of_OpCode
                        Case &H23
                   StrText = "LD E,SLA (IY+dd)": GoTo End_Of_OpCode
                        Case &H24
                   StrText = "LD H,SLA (IY+dd)": GoTo End_Of_OpCode
                        Case &H25
                   StrText = "LD L,SLA (IY+dd)": GoTo End_Of_OpCode
                        Case &H26
                   StrText = "SLA (IY+dd)": GoTo End_Of_OpCode
                        Case &H27
                   StrText = "LD A,SLA (IY+dd)": GoTo End_Of_OpCode
                        Case &H28
                   StrText = "LD B,SRA (IY+dd)": GoTo End_Of_OpCode
                        Case &H29
                   StrText = "LD C,SRA (IY+dd)": GoTo End_Of_OpCode
                        Case &H2A
                   StrText = "LD D,SRA (IY+dd)": GoTo End_Of_OpCode
                        Case &H2B
                   StrText = "LD E,SRA (IY+dd)": GoTo End_Of_OpCode
                        Case &H2C
                   StrText = "LD H,SRA (IY+dd)": GoTo End_Of_OpCode
                        Case &H2D
                   StrText = "LD L,SRA (IY+dd)": GoTo End_Of_OpCode
                        Case &H2E
                   StrText = "SRA (IY+dd)": GoTo End_Of_OpCode
                        Case &H2F
                   StrText = "LD A,SRA (IY+dd)": GoTo End_Of_OpCode
                        Case &H30
                   StrText = "LD B,SLL (IY+dd)": GoTo End_Of_OpCode
                        Case &H31
                   StrText = "LD C,SLL (IY+dd)": GoTo End_Of_OpCode
                        Case &H32
                   StrText = "LD D,SLL (IY+dd)": GoTo End_Of_OpCode
                        Case &H33
                   StrText = "LD E,SLL (IY+dd)": GoTo End_Of_OpCode
                        Case &H34
                   StrText = "LD H,SLL (IY+dd)": GoTo End_Of_OpCode
                        Case &H35
                   StrText = "LD L,SLL (IY+dd)": GoTo End_Of_OpCode
                        Case &H36
                   StrText = "SLL (IY+dd)": GoTo End_Of_OpCode
                        Case &H37
                   StrText = "LD A,SLL (IY+dd)": GoTo End_Of_OpCode
                        Case &H38
                   StrText = "LD B,SRL (IY+dd)": GoTo End_Of_OpCode
                        Case &H39
                   StrText = "LD C,SRL (IY+dd)": GoTo End_Of_OpCode
                        Case &H3A
                   StrText = "LD D,SRL (IY+dd)": GoTo End_Of_OpCode
                        Case &H3B
                   StrText = "LD E,SRL (IY+dd)": GoTo End_Of_OpCode
                        Case &H3C
                   StrText = "LD H,SRL (IY+dd)": GoTo End_Of_OpCode
                        Case &H3D
                   StrText = "LD L,SRL (IY+dd)": GoTo End_Of_OpCode
                        Case &H3E
                   StrText = "SRL (IY+dd)": GoTo End_Of_OpCode
                        Case &H3F
                   StrText = "LD A,SRL (IY+dd)": GoTo End_Of_OpCode
                        Case &H40:
                        Case &H41:
                        Case &H42:
                        Case &H43:
                        Case &H44:
                        Case &H45:
                        Case &H46:
                        Case &H47
                   StrText = "BIT 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &H48:
                        Case &H49:
                        Case &H4A:
                        Case &H4B:
                        Case &H4C:
                        Case &H4D:
                        Case &H4E:
                        Case &H4F
                   StrText = "BIT 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &H50:
                        Case &H51:
                        Case &H52:
                        Case &H53:
                        Case &H54:
                        Case &H55:
                        Case &H56:
                        Case &H57
                   StrText = "BIT 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &H58:
                        Case &H59:
                        Case &H5A:
                        Case &H5B:
                        Case &H5C:
                        Case &H5D:
                        Case &H5E:
                        Case &H5F
                   StrText = "BIT 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &H60:
                        Case &H61:
                        Case &H62:
                        Case &H63:
                        Case &H64:
                        Case &H65:
                        Case &H66:
                        Case &H67
                   StrText = "BIT 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &H68:
                        Case &H69:
                        Case &H6A:
                        Case &H6B:
                        Case &H6C:
                        Case &H6D:
                        Case &H6E:
                        Case &H6F
                   StrText = "BIT 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &H70:
                        Case &H71:
                        Case &H72:
                        Case &H73:
                        Case &H74:
                        Case &H75:
                        Case &H76:
                        Case &H77
                   StrText = "BIT 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &H78:
                        Case &H79:
                        Case &H7A:
                        Case &H7B:
                        Case &H7C, 0:
                        Case &H7D:
                        Case &H7E:
                        Case &H7F
                   StrText = "BIT 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &H80
                   StrText = "LD B,RES 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &H81
                   StrText = "LD C,RES 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &H82
                   StrText = "LD D,RES 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &H83
                   StrText = "LD E,RES 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &H84
                   StrText = "LD H,RES 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &H85
                   StrText = "LD L,RES 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &H86
                   StrText = "RES 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &H87
                   StrText = "LD A,RES 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &H88
                   StrText = "LD B,RES 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &H89
                   StrText = "LD C,RES 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &H8A
                   StrText = "LD D,RES 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &H8B
                   StrText = "LD E,RES 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &H8C
                   StrText = "LD H,RES 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &H8D
                   StrText = "LD L,RES 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &H8E
                   StrText = "RES 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &H8F
                   StrText = "LD A,RES 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &H90
                   StrText = "LD B,RES 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &H91
                   StrText = "LD C,RES 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &H92
                   StrText = "LD D,RES 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &H93
                   StrText = "LD E,RES 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &H94
                   StrText = "LD H,RES 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &H95
                   StrText = "LD L,RES 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &H96
                   StrText = "RES 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &H97
                   StrText = "LD A,RES 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &H98
                   StrText = "LD B,RES 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &H99
                   StrText = "LD C,RES 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &H9A
                   StrText = "LD D,RES 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &H9B
                   StrText = "LD E,RES 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &H9C
                   StrText = "LD H,RES 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &H9D
                   StrText = "LD L,RES 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &H9E
                   StrText = "RES 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &H9F
                   StrText = "LD A,RES 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &HA0
                   StrText = "LD B,RES 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HA1
                   StrText = "LD C,RES 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HA2
                   StrText = "LD D,RES 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HA3
                   StrText = "LD E,RES 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HA4
                   StrText = "LD H,RES 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HA5
                   StrText = "LD L,RES 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HA6
                   StrText = "RES 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HA7
                   StrText = "LD A,RES 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HA8
                   StrText = "LD B,RES 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HA9
                   StrText = "LD C,RES 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HAA
                   StrText = "LD D,RES 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HAB
                   StrText = "LD E,RES 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HAC
                   StrText = "LD H,RES 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HAD
                   StrText = "LD L,RES 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HAE
                   StrText = "RES 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HAF
                   StrText = "LD A,RES 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HB0
                   StrText = "LD B,RES 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HB1
                   StrText = "LD C,RES 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HB2
                   StrText = "LD D,RES 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HB3
                   StrText = "LD E,RES 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HB4
                   StrText = "LD H,RES 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HB5
                   StrText = "LD L,RES 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HB6
                   StrText = "RES 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HB7
                   StrText = "LD A,RES 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HB8
                   StrText = "LD B,RES 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HB9
                   StrText = "LD C,RES 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HBA
                   StrText = "LD D,RES 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HBB
                   StrText = "LD E,RES 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HBC
                   StrText = "LD H,RES 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HBD
                   StrText = "LD L,RES 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HBE
                   StrText = "RES 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HBF
                   StrText = "LD A,RES 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HC0
                   StrText = "LD B,SET 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &HC1
                   StrText = "LD C,SET 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &HC2
                   StrText = "LD D,SET 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &HC3
                   StrText = "LD E,SET 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &HC4
                   StrText = "LD H,SET 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &HC5
                   StrText = "LD L,SET 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &HC6
                   StrText = "SET 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &HC7
                   StrText = "LD A,SET 0,(IY+dd)": GoTo End_Of_OpCode
                        Case &HC8
                   StrText = "LD B,SET 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &HC9
                   StrText = "LD C,SET 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &HCA
                   StrText = "LD D,SET 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &HCB
                   StrText = "LD E,SET 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &HCC
                   StrText = "LD H,SET 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &HCD
                   StrText = "LD L,SET 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &HCE
                   StrText = "SET 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &HCF
                   StrText = "LD A,SET 1,(IY+dd)": GoTo End_Of_OpCode
                        Case &HD0
                   StrText = "LD B,SET 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &HD1
                   StrText = "LD C,SET 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &HD2
                   StrText = "LD D,SET 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &HD3
                   StrText = "LD E,SET 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &HD4
                   StrText = "LD H,SET 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &HD5
                   StrText = "LD L,SET 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &HD6
                   StrText = "SET 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &HD7
                   StrText = "LD A,SET 2,(IY+dd)": GoTo End_Of_OpCode
                        Case &HD8
                   StrText = "LD B,SET 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &HD9
                   StrText = "LD C,SET 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &HDA
                   StrText = "LD D,SET 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &HDB
                   StrText = "LD E,SET 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &HDC
                   StrText = "LD H,SET 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &HDD
                   StrText = "LD L,SET 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &HDE
                   StrText = "SET 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &HDF
                   StrText = "LD A,SET 3,(IY+dd)": GoTo End_Of_OpCode
                        Case &HE0
                   StrText = "LD B,SET 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HE1
                   StrText = "LD C,SET 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HE2
                   StrText = "LD D,SET 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HE3
                   StrText = "LD E,SET 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HE4
                   StrText = "LD H,SET 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HE5
                   StrText = "LD L,SET 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HE6
                   StrText = "SET 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HE7
                   StrText = "LD A,SET 4,(IY+dd)": GoTo End_Of_OpCode
                        Case &HE8
                   StrText = "LD B,SET 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HE9
                   StrText = "LD C,SET 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HEA
                   StrText = "LD D,SET 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HEB
                   StrText = "LD E,SET 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HEC
                   StrText = "LD H,SET 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HED
                   StrText = "LD L,SET 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HEE
                   StrText = "SET 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HEF
                   StrText = "LD A,SET 5,(IY+dd)": GoTo End_Of_OpCode
                        Case &HF0
                   StrText = "LD B,SET 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HF1
                   StrText = "LD C,SET 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HF2
                   StrText = "LD D,SET 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HF3
                   StrText = "LD E,SET 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HF4
                   StrText = "LD H,SET 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HF5
                   StrText = "LD L,SET 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HF6
                   StrText = "SET 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HF7
                   StrText = "LD A,SET 6,(IY+dd)": GoTo End_Of_OpCode
                        Case &HF8
                   StrText = "LD B,SET 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HF9
                   StrText = "LD C,SET 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HFA
                   StrText = "LD D,SET 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HFB
                   StrText = "LD E,SET 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HFC
                   StrText = "LD H,SET 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HFD
                   StrText = "LD L,SET 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HFE
                   StrText = "SET 7,(IY+dd)": GoTo End_Of_OpCode
                        Case &HFF
                   StrText = "LD A,SET 7,(IY+dd)": GoTo End_Of_OpCode
                End Select
                GoTo End_Of_OpCode
               
               Case &HE1
                   StrText = "POP IY": GoTo End_Of_OpCode
                Case &HE3
                   StrText = "EX (SP),IY": GoTo End_Of_OpCode
                Case &HE5
                   StrText = "PUSH IY": GoTo End_Of_OpCode
                Case &HE9
                   StrText = "JP IY": GoTo End_Of_OpCode
                Case &HF9
                   StrText = "LD SP,IY": GoTo End_Of_OpCode
                End Select
                GoTo End_Of_OpCode
                
        Case &HFE
                   StrText = "CP nn": GoTo End_Of_OpCode
        Case &HFF
                   StrText = "RST 38H": GoTo End_Of_OpCode
                   
        End Select
      



End_Of_OpCode:

p = InStr(1, StrText, "+dd")
        If p > 0 Then
                
                Dim i As Byte
               
                i = MEM(addr)
                If (i >= 128) Then
                StrText = StrRep(StrText, p, 3, "-" + Trim(Str(256 - i)))
                Else
                StrText = StrRep(StrText, p, 3, "+" + Trim(Str(i)))
                End If
                                   
             Select Case Distag
               Case show_hex_val
                StrCode = StrCode & ";" & Hex8(CLng(MEM(addr)))
                Case show_dec_val
                 StrCode = StrCode & ";" & MEM(addr)
                Case show_str_val
               Select Case MEM(addr)
                Case &H7C, 0
                 StrCode = StrCode & ";" & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & ";" & Chr(&H22) & Chr(MEM(addr)) & Chr(&H22)
               End Select

             End Select
     
                addr = addr + 1
        End If
        


p = InStr(1, StrText, "nnnn")
        If p > 0 Then
            
            
                Val_nnnn = CLng(MEM(addr)) + 256 * CLng(MEM(addr + 1))
    
                 StrText = StrRep(StrText, p, 4, "$" + Hex16(Val_nnnn))
                 
                  If InStr(1, StrText, "CALL") > 0 Or InStr(1, StrText, "JP") > 0 Then
                  If Val_nnnn >= LBound(Labels) And Val_nnnn <= UBound(Labels) Then Labels(Val_nnnn) = True
                  If Left(StrComment, 2) = "" Then StrComment = "[" & Val_nnnn & "]"
                  End If
                
                                   
             Select Case Distag
               Case show_hex_val
                StrCode = StrCode & ";" & Hex8(CLng(MEM(addr))) & ";" & Hex8(CLng(MEM(addr + 1)))
                Case show_dec_val
                 StrCode = StrCode & ";" & MEM(addr) & ";" & MEM(addr + 1)
                Case show_str_val
               Select Case MEM(addr)
                Case &H7C, 0
                 StrCode = StrCode & ";" & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & ";" & Chr(&H22) & Chr(MEM(addr)) & Chr(&H22)
               End Select
             End Select
               
                 addr = addr + 2
        End If
        
p = InStr(1, StrText, "nn")
        If p > 0 Then
                
            If bINOUTinfo Then
            IOinfo = ""
            IOTAG = Hex8(CLng(MEM(addr)))
            


StrComment = GetIOTagCom(IOTAG)


            If IOinfo = "" Then
            StrText = StrRep(StrText, p, 2, "$" + Hex8(CLng(MEM(addr))))
            Else
            StrText = StrRep(StrText, p, 2, " " & IOinfo & " ")
            StrComment = StrComment & "[$" & Hex8(CLng(MEM(addr))) & "]"
            End If
            Else
            StrText = StrRep(StrText, p, 2, "$" + Hex8(CLng(MEM(addr))))
            bINOUTinfo = False
            End If
            
             Select Case Distag
               Case show_hex_val
                StrCode = StrCode & ";" & Hex8(CLng(MEM(addr)))
                Case show_dec_val
                 StrCode = StrCode & ";" & MEM(addr)
                Case show_str_val
               Select Case MEM(addr)
                Case &H7C, 0
                 StrCode = StrCode & ";" & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & ";" & Chr(&H22) & Chr(MEM(addr)) & Chr(&H22)
               End Select

             End Select
               
               
                addr = addr + 1


        End If
        
p = InStr(1, StrText, "fz")
        If p > 0 Then
               If MEM(addr) And 128 Then
               StrText = StrRep(StrText, p, 2, Trim(Str(-256 + MEM(addr))))
               StrComment = "[$" & Hex16(addr - 255 + MEM(addr)) & ":" & (addr - 255 + MEM(addr)) & "]" & IIf(StrComment <> "", ";", "") & StrComment
               Labels(addr - 255 + MEM(addr)) = True
               Else
               StrText = StrRep(StrText, p, 2, "+" & (Trim(Str(MEM(addr)))) + 1)
               StrComment = "[$" & Hex16(addr + MEM(addr) + 1) & ":" & (addr + MEM(addr) + 1) & "]" & IIf(StrComment <> "", ";", "") & StrComment
               Labels(addr + MEM(addr) + 1) = True
               End If
               
               
             Select Case Distag
               Case show_hex_val
                StrCode = StrCode & ";" & Hex8(CLng(MEM(addr)))
                Case show_dec_val
                 StrCode = StrCode & ";" & MEM(addr)
                Case show_str_val
               Select Case MEM(addr)
                Case &H7C, 0
                 StrCode = StrCode & ";" & Chr(&H22) & "_" & Chr(&H22)
                Case Else
                 StrCode = StrCode & ";" & Chr(&H22) & Chr(MEM(addr)) & Chr(&H22)
               End Select

             End Select
                
               addr = addr + 1

        End If
        
Cuted_OPP:

     DASM_Offset = addr
     
     If StrComment = "" Then StrAddr = StrCode + "|" + StrText Else StrAddr = StrCode + "|" + StrText + "|" + StrComment
         
  
   
   Disassemble = StrAddr
End Function

Private Function StrRep(text As String, pos As Integer, length As Integer, put_str As String)
' "123","12","67" - StrRep("1231267",4,2,45)
' "123","45","67"

Dim tmp_char_L As String
Dim tmp_char_R As String
tmp_char_L = Left(text, pos - 1)

If (pos) + length <= Len(text) Then
tmp_char_R = Right(text, Len(text) - pos - length + 1)
End If

StrRep = tmp_char_L & put_str & tmp_char_R
End Function
