Attribute VB_Name = "ModUDG"
 
 Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal y As Long, ByVal crColor As Long) As Long


Public bmiBuffer_UDG As BITMAPINFO
Public CharMapBuff() As Byte
Public CurrChar As Integer
Public CurrCharBuff(7) As Byte
Public CopyBuff(7) As Byte
Public Mini_bmp(7) As Byte
Public Sub SetBitmapColor_UDG(lIndex As Long, lColor As Long)
    If lIndex > 1 Then Exit Sub
    
    bmiBuffer_UDG.bmiColors(lIndex).rgbRed = (lColor And &HFF&)
    bmiBuffer_UDG.bmiColors(lIndex).rgbGreen = (lColor And &HFF00&) \ 256
    bmiBuffer_UDG.bmiColors(lIndex).rgbBlue = (lColor And &HFF0000) \ 65536
    
End Sub

Sub Load_UDG(Get_Buff As Boolean)
ReDim CharMapBuff(511)
Dim a As Integer

If Get_Buff Then
For a = 0 To 511
CharMapBuff(a) = MemUDG(a)
Next
Exit Sub
End If
'If bAGBChargen Then
'Get UDG From I interupt.
'bAGB_ON = Not bAGB_ON
'For z = 0 To 511
'CharMapBuff(z) = peekb(CLng(UDGmemSeg) * &H100 + z)
'Next z
'bAGB_ON = Not bAGB_ON

'Else
CopyMemory CharMapBuff(0), MEM(CLng(UDGmemSeg) * &H100), 512
'End If

If UDGmemSeg = &H86 And bQSChargen Then
For a = 0 To 511
CharMapBuff(a) = CharMapBuff(a) Xor 255
Next
End If

End Sub

Sub Refresh_Dis(CharNumber As Integer)
Dim Char_offset As Integer, Y_off As Integer
Dim lTopMost As Long, lBottomMost As Long, lLeftMost As Long, lRightMost As Long
   
lTopMost = 8
lBottomMost = 0
lLeftMost = 8
lRightMost = 0
    
Char_offset = 8 * CharNumber

CopyMemory Mini_bmp(0), CharMapBuff(Char_offset), 8

Select Case CharNumber
Case 0 To 13
Y_off = 0 + 3
X_off = (8 * Min_Multiplier) * CharNumber + 3
Case 14 To 27
Y_off = 8 * Min_Multiplier + 3
X_off = (8 * Min_Multiplier) * (CharNumber - 14) + 3
Case 28 To 41
Y_off = 16 * Min_Multiplier + 3
X_off = (8 * Min_Multiplier) * (CharNumber - 28) + 3
Case 42 To 55
Y_off = 24 * Min_Multiplier + 3
X_off = (8 * Min_Multiplier) * (CharNumber - 42) + 3
Case 56 To 64
Y_off = 32 * Min_Multiplier + 3
X_off = (8 * Min_Multiplier) * (CharNumber - 56) + 3
End Select

FrmUDG.Char_Picture.Visible = False
FrmUDG.Char_Picture.AutoRedraw = True
 StretchDIBits FrmUDG.Char_Picture.hdc, X_off, Y_off, 8 * Min_Multiplier, 8 * Min_Multiplier, 1, 1, 8, 8, Mini_bmp(0), bmiBuffer_UDG, DIB_RGB_COLORS, SRCCOPY
FrmUDG.Char_Picture.AutoRedraw = False
FrmUDG.Char_Picture.Visible = True

End Sub
Public Sub CreateCharBuffer_UDG()
    bmiBuffer_UDG.bmiHeader.biSize = Len(bmiBuffer_UDG.bmiHeader)
    bmiBuffer_UDG.bmiHeader.biWidth = 8
    bmiBuffer_UDG.bmiHeader.biHeight = 8
    bmiBuffer_UDG.bmiHeader.biPlanes = 1
    bmiBuffer_UDG.bmiHeader.biBitCount = 1
    bmiBuffer_UDG.bmiHeader.biCompression = BI_RGB
    bmiBuffer_UDG.bmiHeader.biSizeImage = 0
    bmiBuffer_UDG.bmiHeader.biXPelsPerMeter = 200
    bmiBuffer_UDG.bmiHeader.biYPelsPerMeter = 200
    bmiBuffer_UDG.bmiHeader.biClrUsed = 0
    bmiBuffer_UDG.bmiHeader.biClrImportant = 0
    InitBitmapColors_UDG
End Sub

Sub InitBitmapColors_UDG()
    SetBitmapColor_UDG 0, &HFFFFFF
    SetBitmapColor_UDG 1, 0
End Sub


Sub Paint_ap()

Dim pen_color As Long
Dim a, b
FrmUDG.App.Visible = False
FrmUDG.App.AutoRedraw = True
For a = 0 To 7
For b = 0 To 7
pen_color = FrmUDG.Pixel((8 * a) + b).BackColor
SetPixel FrmUDG.App.hdc, b * 2, a * 2, pen_color: SetPixel FrmUDG.App.hdc, b * 2, (a * 2) + 1, pen_color
SetPixel FrmUDG.App.hdc, (b * 2) + 1, a * 2, pen_color: SetPixel FrmUDG.App.hdc, (b * 2) + 1, (a * 2) + 1, pen_color
Next b
Next a
FrmUDG.App.Picture = FrmUDG.App.Image
FrmUDG.App.AutoRedraw = False
FrmUDG.App.Visible = True

End Sub
Sub Convert_Chr2Bin(ChrIndex As Integer)

Dim a, b, TmpStr As String

For a = 0 To 7
TmpStr = ""
For b = 0 To 7
If FrmUDG.Pixel((8 * a) + b).BackColor = 0 Then TmpStr = TmpStr + "1" Else TmpStr = TmpStr + "0"
Next b
CurrCharBuff(a) = CByte(BinToDbl(TmpStr))
CharMapBuff((ChrIndex * 8) + a) = CByte(BinToDbl(TmpStr))
FrmUDG.pokes(a).Caption = "B0" & Trim(val(a)) & ":" & IIf(CharMapBuff((ChrIndex * 8) + a) < 16, "0", "") & Hex(CharMapBuff((ChrIndex * 8) + a)) & "h :" & CharMapBuff((ChrIndex * 8) + a)
Next a

End Sub

Sub Convert_Byte2Bin(ChrIndex As Integer)

Dim a, b, TmpStr As String

For a = 0 To 7
TmpStr = ConvBin(CLng(CharMapBuff((ChrIndex * 8) + a)), 8)
FrmUDG.pokes(a).Caption = "B0" & Trim(val(a)) & ":" & IIf(CharMapBuff((ChrIndex * 8) + a) < 16, "0", "") & Hex(CharMapBuff((ChrIndex * 8) + a)) & "h :" & CharMapBuff((ChrIndex * 8) + a)

For b = 0 To 7
If Mid(TmpStr, b + 1, 1) = "1" Then
FrmUDG.Pixel((8 * a) + b).BackColor = 0
Else
FrmUDG.Pixel((8 * a) + b).BackColor = &HFFFFFF
End If

Next b
Next a

End Sub
Sub CopyChar(ChrIndex As Integer)

Dim a, b, TmpStr As String

For a = 0 To 7
TmpStr = ""
For b = 0 To 7
If FrmUDG.Pixel((8 * a) + b).BackColor = 0 Then TmpStr = TmpStr + "1" Else TmpStr = TmpStr + "0"
Next b
CopyBuff(a) = CByte(BinToDbl(TmpStr))
Next a

End Sub

