Attribute VB_Name = "PrtBuffer"
Option Explicit

Private Declare Function CreateDIBSection Lib "gdi32" _
    (ByVal hdc As Long, _
    pBitmapInfo As BITMAPINFO, _
    ByVal un As Long, _
    lplpVoid As Long, _
    ByVal handle As Long, _
    ByVal dw As Long) As Long
    
Private Declare Function GetObjectAPI Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long

'Public Sub INITprtColors()
'Create the gray color table, based on the original table
'CreateColorTables
'End Sub

Public Sub PaintPrtPaper(bArray() As Byte)
Exit Sub
Dim ret
PRTBm.bmiHeader.biHeight = Stylus_Y + 1
PRTBm.bmiHeader.biSizeImage = (Stylus_Y + 1) * 265
DeleteGeneratedDC (dc)

'Resize The DC Buffered.
'dc = GenerateDC(Bitmaphandle, FrmPrinter.Paper)
 
StretchDIBits FrmPrinter.Paper.hdc, 0, 0, 256, Stylus_Y, 0, 0, 265, Stylus_Y, bArray(0), PRTBm, DIB_RGB_COLORS, SRCCOPY

'draw the picture
'SetBitmapBits Bitmaphandle, PRTBm.bmWidthBytes * Stylus_Y * 256, bArray(0)
'BitBlt FrmPrinter.Paper.hdc, 0, 0, 256, Stylus_Y - 1, dc, 0, 0, vbSrcCopy 'FrmPrinter.Paper.Height
FrmPrinter.Paper.Refresh

End Sub



'    BitmapHandle: The receiver of the loaded bitmap handle
'    Picture box name = BuffPic
'OUT: The Generated DC
Public Function GenerateDC(ByRef Bitmaphandle As Long, PictureBx As PictureBox) As Long
Dim dct As Long
Dim hBitmap As Long

'Create a Device Context, compatible with the screen
dct = CreateCompatibleDC(0)

If dct < 1 Then
    GenerateDC = 0
    'Raise error
    'err.Raise vbObjectError + 1
    Exit Function
End If

hBitmap = PictureBx.hdc

If hBitmap = 0 Then 'Failure in loading bitmap
    DeleteDC dct
    GenerateDC = 0
    Exit Function
End If

'Throw the Bitmap into the Device Context
SelectObject dct, hBitmap

'Return the device context and handle
Bitmaphandle = hBitmap
GenerateDC = dct

End Function

'Deletes a generated DC
Public Function DeleteGeneratedDC(dct As Long) As Long

If dct > 0 Then
    DeleteGeneratedDC = DeleteDC(dct)
Else
    DeleteGeneratedDC = 0
End If

End Function

