VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cBinaryFileStream"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' *******************************************************************************
'  VB81 XuR added by XavSnap. (2007)
' *******************************************************************************

Option Explicit

'Resouces from http://vbaccelerator.com/
'
' For VB81 XuR project (XavSnap)
'

Private m_sFile As String
Private m_iFile As Integer
Private m_iLen As Long
Private m_iOffset As Long


Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)

Public Property Get File() As String
   File = m_sFile
End Property
Public Property Let File(ByVal sFile As String)
   Dispose
   m_sFile = sFile
   
   Dim lErr As Long
   If (FileExists(m_sFile, lErr)) Then
      m_iFile = FreeFile
      Open m_sFile For Binary Access Read Lock Write As #m_iFile
      m_iLen = LOF(m_iFile)
   Else
      err.Raise lErr, App.EXEName & ".File"
   End If
End Property


Public Property Get length() As Long
   length = m_iLen
End Property


Public Function Read( _
      buffer() As Byte, _
      ByVal readSize As Long _
   ) As Long
   
   Dim lReadSize As Long
   lReadSize = readSize
   If (m_iOffset + lReadSize >= m_iLen) Then
      readSize = m_iLen - m_iOffset
      If (readSize > 0) Then
         ReDim NewBuffer(0 To readSize - 1) As Byte
         Get #m_iFile, , NewBuffer
         CopyMemory buffer(0), NewBuffer(0), readSize
      Else
         Dispose
      End If
      m_iOffset = m_iOffset + readSize
   Else
      ' Can read
      
      Get #m_iFile, , buffer
      m_iOffset = m_iOffset + readSize
   End If
   Read = readSize
   
End Function
Public Function Init_Array(ByRef data() As Byte)
m_iOffset = 0
m_iLen = UBound(data) + 1
End Function

Public Property Get Curr_Array_Offset() As Long
Curr_Array_Offset = m_iOffset
End Property

Public Function Read_Array( _
      buffer_Out() As Byte, _
      buffer_In() As Byte, _
      ByVal readSize As Long, _
      Optional Decay As Integer = 0 _
   ) As Long
   
      ' buffer_Out() = Buffered datas.
      ' buffer_In() = Source array.
      ' Buffer readSize

   Dim lReadSize As Long
   lReadSize = readSize
   If (m_iOffset + lReadSize >= m_iLen) Then
      ' Read buffer! but the lenght < to total lenght.
      readSize = m_iLen - m_iOffset
      If readSize > 0 Then CopyMemory buffer_Out(0), buffer_In(m_iOffset), readSize
      m_iOffset = m_iOffset + readSize + Decay
   Else
      ' Read buffer! lenght is ok.
      CopyMemory buffer_Out(0), buffer_In(m_iOffset), readSize
      m_iOffset = m_iOffset + readSize + Decay
   End If
   Read_Array = readSize
   
End Function

Public Sub Dispose()
   If (m_iFile) Then
      Close #m_iFile
      m_iFile = 0
   End If
End Sub

Private Sub Class_Terminate()
   Dispose
End Sub
